/* global MapPage, AccountsPage, HistoryPage */

var AccountPage = new Object();

AccountPage.el = $('#account');
AccountPage.data;
AccountPage.lockUpdate = false;


//Fonction d'initialisation, affecte les evenements.
AccountPage.initialize = function () {
    this.eventHandler();
};

AccountPage.eventHandler = function () {
    this.el.on('click','.back-menu',function(){
        if (AccountPage.lockUpdate)
            AccountPage.lockUpdate = false;
        else
            AccountsPage.noReload = true;
        goToPage('#accounts');
    });
    
    this.el.on('click','.normal .greenButton',function(){
        if (AccountPage.data.owe2 === 0) {
            alert("Les comptes sont déjà soldés");
            return;
        }
        var message;
        if (AccountPage.data.owe2>0)
            message = "Vous avez réglé "+AccountPage.computeAmount()+" à "+AccountPage.data.name;
        else
            message = AccountPage.data.name + " vous a réglé "+AccountPage.computeAmount();
        navigator.notification.confirm(
            message+"\n\nRemise à 0 des comptes.", 
             function(index){
                if (index === 2) {
                    showLoading();
                    AccountPage.updateAccount({idCompte:AccountPage.data.idcomptes, type:"init"});
                }
            },
            "Solder les comptes ?",
            "Annuler,Solder"
        );
    });
    
    this.el.on('click','.solding .greenButton',function(){
        var message;
        if (AccountPage.data.owe2>0)
            message = "Vous avez réglé "+AccountPage.computeAmount()+" à "+AccountPage.data.name;
        else
            message = AccountPage.data.name + " vous a réglé "+AccountPage.computeAmount();
        navigator.notification.confirm(
            message+"\n\nRemise à 0 des comptes.", 
             function(index){
                if (index === 2) {
                    showLoading();
                    AccountPage.updateAccount({idCompte:AccountPage.data.idcomptes,type:"confirm"});
                }
            },
            "Solder les comptes ?",
            "Annuler,Confirmer"
        );
    });
    
    this.el.on('click','.solding .whiteButton',function(){
        var message;
        if (AccountPage.data.owe2>0)
            message = "Vous N'AVEZ PAS avez réglé "+AccountPage.computeAmount()+" à "+AccountPage.data.name;
        else
            message = AccountPage.data.name + " NE VOUS A PAS réglé "+AccountPage.computeAmount();
        navigator.notification.confirm(
            message, 
             function(index){
                if (index === 2) {
                    showLoading();
                    AccountPage.updateAccount({idCompte:AccountPage.data.idcomptes,type:"cancel"});
                }
            },
            "C'est une erreur",
            "Retour,Confirmer l'erreur"
        );
    });
};

AccountPage.computeAmount = function() {
    return MapPage.computeSimplePrice(Math.abs(AccountPage.data.soldAmount));
};

AccountPage.fillData = function(data) {
    AccountPage.data = data;
    AccountPage.el.find('.name').html(escapeXml(data.name));
    if (data.owe2<0) {
        AccountPage.el.find('.receive, .inreceive').show();
        AccountPage.el.find('.debt, .indebt, .even').hide();
    } else if (data.owe2>0) {
        AccountPage.el.find('.receive, .inreceive, .even').hide();
        AccountPage.el.find('.debt, .indebt').show();
    } else {
        AccountPage.el.find('.receive, .inreceive, .debt, .indebt').hide();
        AccountPage.el.find('.even').show();
    }
    if (typeof data.wantToSold === 'undefined') {
        AccountPage.el.find('.normal').show();
        AccountPage.el.find('.solding').hide();
    } else {
        AccountPage.el.find('.normal').hide();
        AccountPage.el.find('.solding').show();
        if (data.wantToSold === true) {
            AccountPage.el.find('.sending').show();
            AccountPage.el.find('.receiving').hide();
        } else {
            AccountPage.el.find('.sending').hide();
            AccountPage.el.find('.receiving').show();
        }
    }
    AccountPage.el.find('.amount').html(MapPage.computeSimplePrice(Math.abs(data.owe2)));
    AccountPage.el.find('.journeysD').html(data.journeys1D);
    AccountPage.el.find('.journeysP').html(data.journeys2D);
    AccountPage.el.find('.kmD').html(HistoryPage.computeSimpleKm(data.km1D));
    AccountPage.el.find('.kmP').html(HistoryPage.computeSimpleKm(data.km2D));
};

AccountPage.updateAccount = function(data) {
    serverRequest(
        "/comptes/update",
        "GET",
        function(response) {
            AccountPage.updateSuccess(data, response);
        },
        "update accounts",
        function() {AccountPage.updateAccount(data);},
        data
    );
};

AccountPage.updateSuccess = function(data, response) {
    if (response.status === "update") {
        alert("Les informations contenues sur la page précédente n'étaient plus à jour\n\nResynchronisation avec le serveur");
        goToPage('#comptes');
    } else if (response.status === "success") {
        switch(data.type) {
            case "init":
                AccountPage.data.wantToSold = true;
                break;
            case "confirm":
                AccountPage.data.owe2 = AccountPage.data.owe2 - AccountPage.data.soldAmount;
                delete AccountPage.data.wantToSold;
                AccountPage.lockUpdate = true;
                break;
            case "cancel":
                delete AccountPage.data.wantToSold;
                break;
        }
        AccountPage.fillData(AccountPage.data);
    }
};

//affiche la page
AccountPage.render = function() {
    AccountPage.reset();
    this.el.addClass("shown");
};

AccountPage.reset = function() {
};