/* global MapPage, AccountPage */

var AccountsPage = new Object();

AccountsPage.el = $('#accounts');
AccountsPage.accounts;
AccountsPage.userId;
AccountsPage.noReload = false;
AccountsPage.goingStraight;


//Fonction d'initialisation, affecte les evenements.
AccountsPage.initialize = function () {
    this.eventHandler();
};

AccountsPage.eventHandler = function () {
    this.el.on('click','.accountContainer',function(){
        var compteId = parseInt($(this).find('.idcomptes').html());
        AccountsPage.goToAccount(compteId);
    });
};

AccountsPage.goToAccount = function(compteId) {
    for (var i=0; i<AccountsPage.accounts.length; i++) {
        var line = AccountsPage.accounts[i];
        if (line.idcomptes === compteId) {
            AccountPage.fillData(line);
            goToPage('#account');
            break;
        }
    }
};

AccountsPage.requestAccounts = function() {
    serverRequest(
        "/comptes/get",
        "GET",
        function(data) {
            AccountsPage.accountsReceived(data);
        },
        "get accounts",
        AccountsPage.requestAccounts,
        {}
    );
};

AccountsPage.accountsReceived = function(data) {
    AccountsPage.accounts = data;
    var debt = 0;
    var receive = 0;
    for (var i=0; i<AccountsPage.accounts.length; i++) {
        var line = JSON.parse(AccountsPage.accounts[i].compte);
        //make sure tha user1 is currentUser 
        if (line.iduser2.idusers === AccountsPage.userId) {
            var temp = line.journeys1D;
            line.journeys1D = line.journeys2D;
            line.journeys2D = temp;
            temp = line.km1D;
            line.km1D = line.km2D;
            line.km2D = temp;
            line.owe2 = -line.owe2;
            line.soldAmount = -line.soldAmount;
            if (typeof line.wantToSold !== 'undefined')
                line.wantToSold = !line.wantToSold;
        }
        line.name = AccountsPage.accounts[i].name;
        //compte total amount
        if (line.owe2 < 0) {
            receive -= line.owe2;
            line.amountcolor = "green";
            line.amount = MapPage.computeSimplePrice(-line.owe2);
        }
        else {
            debt += line.owe2;
            if (line.owe2 > 0)
                line.amountcolor = "red";
            line.amount = MapPage.computeSimplePrice(line.owe2);
        }
        //save modifications
        AccountsPage.accounts[i] = line;
        //fill in line
        AccountsPage.el.find('.whiteBg').append($(account_template(line)));
    }
    //fill in total amount
    AccountsPage.el.find('.debt .amount').html(MapPage.computeSimplePrice(debt));
    AccountsPage.el.find('.receive .amount').html(MapPage.computeSimplePrice(receive));
    if (!!AccountsPage.goingStraight) {
        AccountsPage.goToAccount(AccountsPage.goingStraight.compteId);
        delete AccountsPage.goingStraight;
    }
};

//affiche la page
AccountsPage.render = function() {
    this.el.addClass("shown");
    if (AccountsPage.noReload) {
        AccountsPage.noReload = false;
    }
    else {
        AccountsPage.reset();
        showLoading();
        AccountsPage.requestAccounts();
    }
};

AccountsPage.reset = function() {
    delete AccountsPage.accounts;
    AccountsPage.userId = parseInt(localStorage.userId);
    AccountsPage.el.find('.whiteBg').html("");
    AccountsPage.el.find('.debt .amount').html("");
    AccountsPage.el.find('.receive .amount').html("");
};