/* global ProfilePage, MessagePage, Notification */

var ContactsPage = new Object();

ContactsPage.el = $('#contacts');
ContactsPage.userId;
ContactsPage.contacts = [];
ContactsPage.goingStraight = {};

//Fonction d'initialisation, affecte les evenements.
ContactsPage.initialize = function () {
    this.eventHandler();
};

ContactsPage.eventHandler = function () {
    this.el.on('click','.blockContact',function (event){
        var data = ContactsPage.extractData($(this));
        navigator.notification.confirm(
            "Un contact bloqué ne peut plus voir vos nouveaux trajets ni vous envoyer de messages\n\nBloquer ce contact ?", 
            function(index) {
                if (index === 2) {
                    ContactsPage.blockUnblockContact(data, true);
                }
            },
            "Kankaroo",
            "Annuler,Bloquer"
        );
    });
    
    this.el.on('click','.blockedOverlay',function (event){
        var data = ContactsPage.extractData($(this));
        navigator.notification.confirm(
            "Un contact bloqué ne peut plus voir vos nouveaux trajets ni vous envoyer de messages\n\nDébloquer ce contact ?",
            function(index) {
                if (index === 2) {
                    ContactsPage.blockUnblockContact(data, false);
                }
            },
            "Kankaroo",
            "Annuler,Débloquer"
        );
    });
    
    this.el.on('click','.deleteContact',function (event){
        var data = ContactsPage.extractData($(this));
        navigator.notification.confirm(
            "Supprimer ce contact ?",
            function(index) {
                if (index === 2) {
                    var send = {};
                    send.idContact = data.idContact;
                    data.ref.remove();
                    ContactsPage.sendRemove(send);
                }
            },
            "Kankaroo",
            "Annuler,Supprimer"
        );
    });
    
    this.el.on('click','.messageContact',function (event){
        ContactsPage.handleChatPageRequest($(this));
    });
    
    this.el.on('click','.addContact',function (event){
        var email = ContactsPage.el.find('input[name="e-mail"]').val();
        if (email.indexOf("@")!==-1) {
            showLoading();
            ContactsPage.sendAddContact(email);
        } else alert("Merci d'indiquer un email valide");
    });
    
    this.el.on('click','.goToProfile',function (event){
        //go to page profile
        var data = ContactsPage.extractData($(this));
        ProfilePage.setUpUsers(data);
        $(".shown").removeClass("shown");
        ProfilePage.render();
    });
};

ContactsPage.sendAddContact = function(email) {
    serverRequest(
        "/contacts/add",
        "GET",
        function(data) {
            alert("Le contact a été ajouté avec succès. Pour que cette personne reçoive vos messages, elle doit vous ajouter de la même manière");
            ContactsPage.goingStraight = {};
            ContactsPage.render();
        },
        "add contact",
        function() {ContactsPage.sendAddContact(email);},
        {contactMail: email}
    );
};

ContactsPage.handleChatPageRequest = function(object) {
    var data = ContactsPage.extractData(object);
        
    var send = new Object();
    send.name = data.name;
    send.notif = data.notifMessage;
    send.ref = data.ref;
    send.idContact = data.idContact;
    send.me = data.me;
    MessagePage.setUpUsers(send);

    //go to page chat
    $(".shown").removeClass("shown");
    MessagePage.render();
};

ContactsPage.blockUnblockContact = function(data, block) {
    var send = {};
    if (block === true) {
        data.ref.find('.blockedOverlay').show();
        send.unblock = false;
    } else {
        data.ref.find('.blockedOverlay').hide();
        send.unblock = true;
    }
    send.idContact = data.idContact;
    ContactsPage.senBlock(send);
};

ContactsPage.senBlock = function(data) {
    serverRequest(
        "/contacts/block",
        "GET",
        function(data) {},
        "block contact",
        function() {ContactsPage.senBlock(data);},
        data
    );
};

ContactsPage.sendRemove = function(data) {
    serverRequest(
        "/contacts/remove",
        "GET",
        function(data) {},
        "remove contact",
        function() {ContactsPage.sendRemove(data);},
        data
    );
};

ContactsPage.extractData = function(object) {
    var parent = object.parent();
    var data = {};
    data.idContact = parseInt(parent.find('.idContact').html());
    data.notifMessage = (parent.find('.notifMessage').html() === 'true');
    data.name = parent.find('.nameDiv').html();
    data.ref = parent;
    data.me = parent.find('.me').html();
    return data;
};

ContactsPage.requestContacts = function() {
    serverRequest(
        "/contacts/list",
        "GET",
        function(data) {
            ContactsPage.contactsReceived(data);
        },
        "get contacts",
        ContactsPage.requestContacts,
        {}
    );
};

ContactsPage.contactsReceived = function(data) {
    data.sort(function(a,b){
        return a.name < b.name ? -1 : 1;
    });
    ContactsPage.contacts = data;
    
    for (var i = 0; i<ContactsPage.contacts.length; i++) {
        var contact = ContactsPage.contacts[i];
        var subInfo = JSON.parse(contact.contact);
        if (subInfo.iduser1.idusers === ContactsPage.userId)
            ContactsPage.prepareContactData(1, contact, subInfo);
        else
            ContactsPage.prepareContactData(2, contact, subInfo);
    }
    
    if (ContactsPage.el.find('.whiteBg').html() === '') {
        if (!!ContactsPage.goingStraight.contactId) {
            notifyNotificationNotActual();
            ContactsPage.el.addClass("shown");
            return;
        } else
            ContactsPage.el.find('.whiteBg').html('<div class="text bold center" style="margin-top: 1.2em; margin-bottom: 1.2em">Aucun contact pour l\'instant</div>');
    }
    
    if (!!ContactsPage.goingStraight.contactId) {
        ContactsPage.el.find('.idContact').each(function(){
            if (parseInt($(this).html()) === ContactsPage.goingStraight.contactId)
                ContactsPage.goingStraight.object = $(this).parent();
        });
        if (!ContactsPage.goingStraight.object) {
            notifyNotificationNotActual();
            ContactsPage.el.addClass("shown");
            return;
        } else
            ContactsPage.handleChatPageRequest(ContactsPage.goingStraight.object);
    }
};

ContactsPage.prepareContactData = function(num, contact, subInfo) {
    var data = {};
    data.name = contact.name;
    data.blocked = contact.blocked;
    data.idContact = subInfo.idcontact;
    data.me = num;
    if (num === 1) {
        data.messagesNum = subInfo.nbrUnread1;
        data.notifMessage = subInfo.notifMessage1;
    } else {
        data.messagesNum = subInfo.nbrUnread2;
        data.notifMessage = subInfo.notifMessage2;
    }
    ContactsPage.appendContact(data);
};

ContactsPage.appendContact = function(data) {
    if (data.messagesNum > 4) data.messagesNum = 4;
    var contact = $(contact_template(data));
    ContactsPage.el.find('.whiteBg').append(contact);
};

//affiche la page
ContactsPage.render = function() {
    ContactsPage.reset();
    if (!ContactsPage.goingStraight.contactId) this.el.addClass("shown");
    showLoading();
    ContactsPage.requestContacts();
};

ContactsPage.reset = function() {
    ContactsPage.userId = parseInt(localStorage.userId);
    ContactsPage.contacts = [];
    ContactsPage.el.find('.whiteBg').html('');
    this.el.find('input[name="e-mail"]').val('').removeClass('focus');
};

ContactsPage.OneMoreUnreadMessage = function(contactId) {
    ContactsPage.el.find('.idContact').each(function(){
        if (parseInt($(this).html()) === contactId) {
            Notification.moreNotif($(this).parent().parent().find('.messageContact img'));
        }
    });
};
