/* global Notification, MapPage, Menu, Partir4Page, PartirPage, MyTravels, Map2Page */

var JourneyPage = new Object();

JourneyPage.el = $('#journey');

//Fonction d'initialisation, affecte les evenements.
JourneyPage.initialize = function () {
    this.eventHandler();
};
JourneyPage.eventHandler = function () {
    
    this.el.find('.back-menu').on('click',function (){
        JourneyPage.backToPreviousPage();
    });
    
    this.el.find('.travel').on('click',function (){
        $(".shown").removeClass("shown");
        Map2Page.render(".global");
    });
    
};

JourneyPage.backToPreviousPage = function() {
    $(".shown").removeClass("shown");
    Notification.handleNotification();
    MapPage.el.addClass("shown");
    Menu.scroller(MapPage);
};

//affiche la page
JourneyPage.render = function() {
    JourneyPage.reset();
    this.el.addClass("shown");
    JourneyPage.el.find('.name').html(escapeXml(MapPage.matchList[MapPage.matchNum].profile.name));
    Menu.handleJSRendering(JourneyPage);
    
    var match = MapPage.matchList[MapPage.matchNum];
    var isD = Partir4Page.userType === 'driver';
    MapPage.fillReverseGeocode(JourneyPage.el.find('.departure'), match.userJourney.pickupPlace.latitude, match.userJourney.pickupPlace.longitude);
    MapPage.fillReverseGeocode(JourneyPage.el.find('.arrival'), match.userJourney.dropPlace.latitude, match.userJourney.dropPlace.longitude);
    JourneyPage.el.find('.timeInfo').html(MapPage.otherTimeStringFormat(match));
    if (!isD) {
        JourneyPage.el.find('.driver').show();
        JourneyPage.el.find('.passenger').hide();
        JourneyPage.el.find('.detour').html(Partir4Page.detourConverter(match.userJourney.detour));
        JourneyPage.el.find('.passengers').html(match.userJourney.passengers);
    } else {
        JourneyPage.el.find('.driver').hide();
        JourneyPage.el.find('.passenger').show();
        JourneyPage.el.find('.detour').html(Partir4Page.detourConverter(match.userJourney.detour));
        JourneyPage.el.find('.passengers').html(match.userJourney.passengers);
    }
    if (MapPage.vehicle.type === 'car') {
        JourneyPage.el.find('.helmet').hide();
    } else {
        JourneyPage.el.find('.helmet').show();
        if (match.userJourney.helmet)
            JourneyPage.el.find('.helmetVal').html("Oui");
        else
            JourneyPage.el.find('.helmetVal').html("Non");
    }
    if (match.userJourney.luggage)
            JourneyPage.el.find('.luggage').html("Oui");
        else
            JourneyPage.el.find('.luggage').html("Non");
};

JourneyPage.reset = function() {
    
};