/* global Notification, device, LoginPage, ContactsPage, Create2Page, Create3FirmPage, Create3Page, CreatePage, EWalletPage, Feedback, HistoryPage, MapPage, MessagePage, MyAccountPage, MyCarsPage, MyProfilePage, MyTravels, Partir2Page, Partir3Page, Partir4Page, PartirPage, PasswdPage, ProfilePage, Menu, Map2Page, GradePage, Geocoding, Map3Page, JourneyPage, cordova, StatusBar, AccountsPage, AccountPage */

var load = new Object();
load.version = 1611291209;
load.iOSFirstLoad;
load.asyncLocked = {app : true, google : true};
load.updateServerAnswer;
load.googleScriptInitializedLocked = false;

//Initialise l'application
load.initialize = function() {
    load.bindEvents();
};

load.bindEvents =function() {
    document.addEventListener('deviceready', load.onDeviceReady, false);
};

load.onDeviceReady = function() {
    load.initGoogleScript("load");
    load.initApp();
};

load.initApp = function() {
    setTimeout(function(){
        navigator.splashscreen.hide();
    }, 50);
    load.initDeviceType();
    load.initPages();
    if (!localStorage.partir2Favorites) window.localStorage.setArray("partir2Favorites", []);
    if (!localStorage.partir3Favorites) window.localStorage.setArray("partir3Favorites", []);
    if (!localStorage.geocodingCache) window.localStorage.setArray("geocodingCache", []);
    if (!localStorage.messagesCache) window.localStorage.setArray("messagesCache", []);
    if (!localStorage.reverseGeocodingCache) window.localStorage.setArray("reverseGeocodingCache", []);
    if (!localStorage.alarms) window.localStorage.setArray("alarms", []);
    if (!localStorage.notificationsHandled) window.localStorage.setArray("notificationsHandled", []);
    Notification.restoreHandledNotifications();
    load.adaptViewForIos();
    load.checkVersion();
};

//Envoi la version actuelle au serveur
load.checkVersion = function () {
    serverRequest(
        "/checkVersion",
        "GET",
        function(data) {
            load.updateServerAnswer = data;
            if (deviceType ==='iOS')
                httpTimeOut = 20000;
            if (!!data.notUptodateEnough) {
                load.forEverNotification(data.message, data.url);
            } else {
                initializeApp();
                if (load.asyncLocked.google === false) {
                    load.loadUnlocked();
                } else {
                    load.asyncLocked.app = false;
                }
            }
        },
        "Loading request",
        null,
        {
            appVersion: load.version,
            os: deviceType
        },
        function(){
            load.forEverNotificationError();
        }
    );
};

load.loadUnlocked = function() {
    LoginPage.disconnected(null, "Loading request");
    if (!!load.updateServerAnswer.couldUpdate)
        load.updateNotification(load.updateServerAnswer.message, load.updateServerAnswer.url);
};

load.updateNotification = function(message, url) {
    navigator.notification.confirm(
        message,
        function(index){
            if (index === 2) {
                window.location.href = url;
            }
        },
        'Mise à jour disponible',
        'Plus tard,Mettre à jour'
    );
};

load.forEverNotification = function(message, url) {
    navigator.notification.alert(
        message,
        function(){
            load.forEverNotification(message, url);
            window.location.href = url;
        },
        'Mise à jour requise',
        'Mettre à jour'
    );
};

load.forEverNotificationError = function() {
    navigator.notification.alert(
        "Si le problème persiste mettez l'application Kankaroo à jour",
        function(){load.forEverNotificationError();},
        'Erreur',
        'Ok'
    );
};

load.adaptViewForIos = function() {
    if (deviceType !== 'iOS') 
        return;
    $('.header, .headerMenu, .headerPhysicalPadding').each(function() {
        $(this).height($(this).height() + 20);
    });
    $('#create2 .add, #myCars .add, #create2 .progressionInfo, #create3 .progressionInfo,\
        #create3firm .progressionInfo, #map .tagsContainer, #map-wrapper, #map-overlay,\
        #myTravels .newTravelContainer, #notif, #notif-overlay, #notifPopUp,\
        #partir2 .autocompleteBigBox, #notif, .fake-menu, .back-menu, .header .open-menu,\
        #menu .headerMenu .menu-close, #menu .headerMenu .headerImg, .loadingMessage')
            .each(function() {
                $(this).css("top",parseInt($(this).css('top'), 10) + 20);
        });
    $('.header, .headerMenu, .headerPhysicalPadding').prepend("<div style='height: 20px;'></div>");
    cordova.plugins.Keyboard.disableScroll(true);
    $(".pageContent").css("overflow","scroll");
    window.addEventListener('native.keyboardshow', function(e) {
        $(".keyboardPadding").remove();
        $('.page').each(function() {
            if ($(this).is(':visible')) {
                if ($(this).attr('id') === "chat") {
                    MessagePage.el.find('#message-input').css("bottom",e.keyboardHeight);
                    MessagePage.fixHeights(e.keyboardHeight);
                } else {
                    $(this).find('.pageContent').append("<div class='keyboardPadding' style='height: "+e.keyboardHeight+"px;'></div>");
                }
            }
        });
        $('.popUp').each(function() {
            if ($(this).is(':visible')) {
                if ($(this).parent().parent().attr('id') !== "map2") {
                    StatusBar.hide();
                }
            }
        });
        load.handlePartirPageBug();
    });
    window.addEventListener('native.keyboardhide', function(e) {
        $(".keyboardPadding").remove();
        load.handleStatusBar();
        if ($('#chat').is(':visible')) {
            MessagePage.el.find('#message-input').css("bottom",0);
            MessagePage.fixHeights();
        }
        load.handlePartirPageBug();
    });
    $("<style type='text/css'> .pac-container {overflow: scroll !important; max-height: 15em; -webkit-overflow-scrolling: touch;} </style>").appendTo("head");
    httpTimeOut = 2000;
    load.iOSFirstLoad = true;
};

//TODO watch, here for a strange bug
load.handlePartirPageBug = function() {
    if (PartirPage.el.find('.travel5').is(":visible")) {
        PartirPage.el.find('.travel5 .onoffswitch').hide();
        setTimeout(function() {
            PartirPage.el.find('.travel5 .onoffswitch').show();
        },0);
    }
};

load.handleStatusBar = function() {
    if (deviceType !== 'iOS') 
        return;
    if (CreatePage.el.is(":visible") | LoginPage.el.is(":visible"))
        StatusBar.hide();
    else
        StatusBar.show();
};

load.initPages = function() {
    document.addEventListener("pause", function() {
        if (!!MyTravels.gpsTimeout) {
            clearTimeout(MyTravels.gpsTimeout);
            delete MyTravels.gpsTimeout;
        }
        appIsOnForeground = false;
    }, false);
    document.addEventListener("resume", function() {
        appIsOnForeground = true;
        if (!!localStorage.mail) {
            if (deviceType === 'android')
                Notification.fetchNotifications();
            else {
                setTimeout(function() {
                    Notification.fetchNotifications();
                }, 1000);
            }
        }
    }, false);
    ContactsPage.initialize();
    Create2Page.initialize();
    Create3FirmPage.initialize();
    Create3Page.initialize();
    CreatePage.initialize();
    EWalletPage.initialize();
    AccountsPage.initialize();
    AccountPage.initialize();
    GradePage.initialize();
    Feedback.initialize();
    HistoryPage.initialize();
    LoginPage.initialize();
    MapPage.initialize();
    Map2Page.initialize();
    Map3Page.initialize();
    JourneyPage.initialize();
    MessagePage.initialize();
    MyAccountPage.initialize();
    MyCarsPage.initialize();
    MyProfilePage.initialize();
    MyTravels.initialize();
    Notification.initialize();
    Partir2Page.initialize();
    Partir3Page.initialize();
    Partir4Page.initialize();
    PartirPage.initialize();
    PasswdPage.initialize();
    ProfilePage.initialize();
    Menu.initialize();
};

load.initDeviceType = function() {
    if (device.platform === 'android' || device.platform === 'Android' || device.platform === "amazon-fireos")
        deviceType = 'android';
    else
        deviceType = 'iOS';
};

load.initGoogleScript = function(source) {
    if (!!source)
        Geocoding.initializeSource = source;
    delete Map2Page.map;
    delete Partir2Page.autocomplete;
    $('body').append('<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?key=AIzaSyDUDuW0oHEF39tzNxyyPQTF_b3cGY7rEeQ&amp;libraries=geometry,places&amp;v=3&callback=googleScriptInitialized"></script>');
    setTimeout(function() {
        if (load.googleScriptInitializedLocked === false) {
            navigator.notification.alert(
                "Services Google inaccessibles",
                function(){load.initGoogleScript(source);},
                'Erreur de connexion',
                'Réessayer'
            );
        }
    },4000);
};

function googleScriptInitialized() {
    if (load.googleScriptInitializedLocked === false) {
        load.googleScriptInitializedLocked = true;
        $.getScript("lib/InfoBox.js", function() {
            Geocoding.initialize();
        });
    }
};

//A laiser en fin de fichier pour mettre en place les EventsListener
load.initialize();
