/* global PasswdPage, facebookConnectPlugin, Notification, Partir2Page, deviceType, Create3FirmPage, Create3Page */

var LoginPage = new Object();

LoginPage.el = $('#login');
LoginPage.email;

//Fonction d'initialisation, affecte les evenements.
LoginPage.initialize = function() {
    this.eventHandler();
};

//Affiche la page
LoginPage.render = function () {
    LoginPage.reset();
    this.el.addClass("shown");
};

//Affecte tout les evenements
LoginPage.eventHandler = function () {
    LoginPage.facebookSetUp();
    this.el.find('form').submit(function (event) {
        $("#login_error").hide();
        var formData = {
            mail : LoginPage.el.find('input[name="mail"]').val(),
            password : LoginPage.el.find('input[name="password"]').val()
        };

        if(formData.password.length<8 || formData.mail.indexOf("@")===-1)
                $("#login_error").show();
        else 
        {
            window.plugins.toast.showShortTop('Tentative de connexion...');
            // process the form
            serverRequest(
                "/loginAttempt",
                "POST",
                function(data) {loginSuccess(data,formData);},
                "connection LodingPage",
                null,
                formData                        
            );
        }
        event.preventDefault();
    });
    
    if (deviceType === 'android') {
        this.el.on('click','.password',function(){
           LoginPage.el.find('.password').hide();
           LoginPage.el.find('input[name="password"]').show().focus();
        });

        this.el.on('blur','input[name="password"]',function(){
            if($(this).val()===''){
                LoginPage.el.find('.password').show().removeClass('focus').blur();
                LoginPage.el.find('input[name="password"]').hide();
            }
        });

        this.el.on('click','.email',function(){
           LoginPage.el.find('.email').hide();
           LoginPage.el.find('input[name="mail"]').show().focus();
        });

        this.el.on('blur','input[name="mail"]',function(){
            if($(this).val()===''){
                LoginPage.el.find('.email').show().removeClass('focus').blur();;
                LoginPage.el.find('input[name="mail"]').hide();
            }
        });
    }

    this.el.on('click','.createAccount',function(){
       goToPage('#create');
    });

    this.el.on('click','.pwdRecovery',function(){
        PasswdPage.el.find('input[name="e-mail"]').val($('input[name=mail]').val());
        goToPage('#passwd');
    });
};

//Function pour les Event Facebook.
LoginPage.facebookSetUp = function () {
    $("#facebook").click(fbLogin);
};

//Demande accés a l'adresse mail
function fbLogin() {
    facebookConnectPlugin.login(["email"],
        fbLoginSuccess,
        function (error) {}
    );
}

function fbLoginSuccess (userData) {
    //recupère le token de facebook
    facebookConnectPlugin.getAccessToken(
        function(token) {
            window.plugins.toast.showShortTop('Tentative de connexion...');
            var FBdata = new Object();
            FBdata.FBToken = token;
            serverRequest(
                "/loginAttempt",
                "POST",
                function(data) {loginSuccess(data);},
                "connection LodingPage",
                null,
                FBdata                        
            );
        },
        function(err) {
            alert("Could not get access token: " + err);
        }
    );
}

//Fonction qui gère un login correct. Vérifie si la connection s'est faite avec facebook ou non avec la présence de formData (pas de formData donc Facebook)
function loginSuccess(data,formData) {
    LoginPage.el.find('input[name=password]').val('');
    if (deviceType === 'android') {
        LoginPage.el.find('input[name=password]').hide();
        LoginPage.el.find('.password').show();
    }
    if (typeof formData!=="undefined" && typeof data.error === 'undefined') { //Kankaroo
        localStorage.loginToken = data.loginToken; //stocke le loginToken
        localStorage.userId = data.id;
        localStorage.mail = formData.mail; //stoque le mail
        localStorage.hadAccount = true;
        LoginPage.FirstArrivalOnMyTravelsPage();
        sendRegIDToServer();
        Notification.fetchNotifications();
    } else if (typeof data.error === 'undefined') { //Facebook
        localStorage.loginToken = data.loginToken; //stocke le loginToken
        localStorage.userId = data.id;
        localStorage.mail = data.mail;
        localStorage.hadAccount = true;
        if(data.firstConnection) {localStorage.createStateMemory = 2; goToPage("#create2");}
        else LoginPage.FirstArrivalOnMyTravelsPage();
        sendRegIDToServer();
        Notification.fetchNotifications();
    } else {
        if(data.error==="wrongCredentials"){
            $("#login_error").show();
        }
    }
}

//fonction a appeler aprés déconection avec pour argument la demande en cours
LoginPage.disconnected = function (action, origin) {
    var reconnect = new Object();
    if(typeof localStorage.loginToken==='undefined'|| localStorage.loginToken ==='undefined'
            ||typeof localStorage.mail==='undefined'|| localStorage.mail === 'undefined') {
            //pas de compte en mémoire
            if (!!localStorage.hadAccount)
                goToPage("#login");
            else
                goToPage("#create");
            $("#loadScreen").hide();
            return;
    }
    reconnect.loginToken = localStorage.loginToken;
    reconnect.mail = localStorage.mail;
    serverRequest(
        "/loginAttempt",
        "POST",
        function(data) {
            if(data.status==="update"){
                window.localStorage.removeItem("mail");
                window.localStorage.removeItem("loginToken");
                goToPage("#login");
            } else if(typeof data.error!=="undefined"){
                window.localStorage.removeItem("mail");
                window.localStorage.removeItem("loginToken");
                goToPage("#login");
            } else {
                //compte trouvé
                if(action) action();
                if (origin === "Loading request") { //The app is loading
                    $("#loadScreen").hide();
                    if (localStorage.createStateMemory === '2') goToPage("#create2");
                    else if(localStorage.createStateMemory === '3') {
                        Create3FirmPage.return ="#create3Special";
                        Create3FirmPage.returnObject = Create3Page;
                        goToPage("#create3firm");
                    }
                    else goToPage("#myTravels");
                    Notification.fetchNotifications();
                }
            }
        },
        origin,
        null,
        reconnect                        
    );
};

LoginPage.reset = function() {
    this.el.find('form')[0].reset();
    $("#login_error").hide();
    if (deviceType === 'android') {
        LoginPage.el.find('.email').show();
        LoginPage.el.find('.password').show();
        LoginPage.el.find('input[name="mail"]').hide();
        LoginPage.el.find('input[name="password"]').hide();
        if (!!LoginPage.email) {
            if (LoginPage.email !== '' & LoginPage.email !== 'Adresse e-mail') {
                $('input[name=mail]').val(LoginPage.email);
                LoginPage.el.find('.email').hide();
                LoginPage.el.find('input[name="mail"]').show();
            } else
                $('input[name=mail]').val('');
            delete LoginPage.email;
        }
    } else {
        if (!!LoginPage.email) {
            if (LoginPage.email !== '' & LoginPage.email !== 'Adresse e-mail')
                $('input[name=mail]').val(LoginPage.email);
            delete LoginPage.email;
        }
        LoginPage.el.find('.email').hide();
        LoginPage.el.find('.password').hide();
        LoginPage.el.find('input[name="mail"]').show();
        LoginPage.el.find('input[name="password"]').show();
    }
};

LoginPage.FirstArrivalOnMyTravelsPage = function() {
    Partir2Page.getFavorites(function() {
        goToPage("#myTravels");
    });
};
