/* global MapPage, Notification, cordova, google, Geocoding, Partir4Page, THURSDAY, WEDNESDAY, TUESDAY, MONDAY, Menu, load, windowHeight, Map3Page, JourneyPage */

var Map2Page = new Object();

Map2Page.el = $('#map2');
Map2Page.map;
Map2Page.panorama;
Map2Page.skipRDVTuto;
Map2Page.dragLock = false;
Map2Page.menuChanged = 'none';
Map2Page.polylineMaker;
Map2Page.rdvMarker;
Map2Page.dropMarker;
Map2Page.trajetBounds;
Map2Page.markersAreMobile;
Map2Page.MapTutorialInterval;
Map2Page.autocomplete;
Map2Page.selectedMenu;
Map2Page.outCorrespondsTo;

//Fonction d'initialisation, affecte les evenements.
Map2Page.initialize = function () {
    this.eventHandler();
};

Map2Page.eventHandler = function () {
    
    this.el.find('.back-menu').on('click',function (){
        Map2Page.outCorrespondsTo = '.back-menu';
        Map2Page.backToPreviousPage();
    });
    
    this.el.find('.mapTutorialPositionSaved').on('click',function (){
        Map2Page.outCorrespondsTo = '.mapTutorialPositionSaved';
        Map2Page.backToPreviousPage();
    });
    
    this.el.on('touchstart','.centerMarkerRdv, .centerMarkerDrop',function(){
        Map2Page.tutoToast();
    });
    
    this.el.on('touchstart','.mapTutorialContent',function(){
        Map2Page.tutoClickHandler();
    });
    
    this.el.on('click', '.overlay, .popUpCancel', function (event) {
        event.stopPropagation();
        hidePopUp(Map2Page);
    });
    
    this.el.on('click', '.popUp', function (event) {
        event.stopPropagation();
    });
    
    this.el.on('click','#map-overlay .address',function(){
        Map2Page.el.find('.addressSearchPopUp').show();
        Map2Page.el.find('.rdvDescription').hide();
        Map2Page.showPopUp();
        if (!Map2Page.autocomplete) {
            Map2Page.autocomplete = new google.maps.places.Autocomplete(
                (document.getElementById('autocomplete2')),
                {
                    componentRestrictions: {country: 'fr'}
                }
            );
            google.maps.event.addListener(Map2Page.autocomplete, 'place_changed', function () {
                var place = Map2Page.autocomplete.getPlace();
                Map2Page.centerMap(place.geometry.location.lat(), place.geometry.location.lng());
                hidePopUp(Map2Page);
                cordova.plugins.Keyboard.close();
            });
        }
        setTimeout(function() {
            Map2Page.el.find('#autocomplete2').focus();
            cordova.plugins.Keyboard.show();
        },10);
    });
    
    this.el.on('click','.searchAddress',function(){
        Geocoding.straightGeocoding($("#autocomplete2").val(), function (data) {
            if (data === "fail") {
                alert("L'adresse n'a pas pu être identifiée");
            }
            else {
                Map2Page.centerMap(data.geometry.location.lat(), data.geometry.location.lng());
            }
            hidePopUp(Map2Page);
            cordova.plugins.Keyboard.close();
        });
    });
    
    this.el.on('click',".snobbed",function () {
        cordova.plugins.Keyboard.close();
        hidePopUp(Map2Page);
        MapPage.RDVTutoSnobed = true;
        Map2Page.el.find(Map2Page.outCorrespondsTo).click();
    });
    
    this.el.on('click',".described",function () {
        cordova.plugins.Keyboard.close();
        var val = Map2Page.el.find('.rdvDescriptionText').val();
        if (val !== 'Précision sur le rendez-vous' & val !== '')
            Map2Page.el.find('input[name="rdv-description"]').val(val);
        else
            MapPage.RDVTutoSnobed = true;
        hidePopUp(Map2Page);
        Map2Page.el.find(Map2Page.outCorrespondsTo).click();
    });
    
};

Map2Page.renderRDV = function() {
    Map2Page.selectedMenu = "rdv";
    Map2Page.markersAreMobile = false;
    Map2Page.handleMarkers();
    Map2Page.zoomBoundAndCenter(MapPage.depPassenger, MapPage.rdvRoadPoint, Map2Page.rdvMarker.getPosition());
};

Map2Page.renderDrop = function() {
    Map2Page.selectedMenu = "arrival";
    Map2Page.markersAreMobile = false;
    Map2Page.handleMarkers();
    Map2Page.zoomBoundAndCenter(MapPage.arrPassenger, MapPage.dropRoadPoint, Map2Page.dropMarker.getPosition());
};

Map2Page.renderGlobal = function() {
    Map2Page.selectedMenu = "global";
    Map2Page.markersAreMobile = false;
    Map2Page.rdvMarker.close();
    Map2Page.dropMarker.close();
    Map2Page.el.find('.centerMarkerRdv').hide();
    Map2Page.el.find('.centerMarkerDrop').hide();
    Map2Page.handleMapTutoVisibility(false);
    Map2Page.el.find('#map-overlay').hide();
    Map2Page.map.fitBounds(Map2Page.trajetBounds);
};

Map2Page.handleMarkers = function() {
    if(Map2Page.panorama.getVisible()) {
        Map2Page.markersAreMobile = false;
        Map2Page.rdvMarker.close();
        Map2Page.dropMarker.close();
        Map2Page.el.find('.centerMarkerRdv').hide();
        Map2Page.el.find('.centerMarkerDrop').hide();
        Map2Page.handleMapTutoVisibility(false);
        Map2Page.el.find('#map-overlay').hide();
    } else {
        //this handles the markers and the mapTuto
        var type;
        if (Map2Page.selectedMenu === "rdv") {
            type = 'RDV';
            Map2Page.el.find('.RDVOrArrival').html('le RDV');
        } else if (Map2Page.selectedMenu === "arrival") {
            type = 'dépose';
            Map2Page.el.find('.RDVOrArrival').html('la dépose');
        }
        if (Map2Page.markersAreMobile === true) {
            Map2Page.rdvMarker.close();
            Map2Page.dropMarker.close();
            if(Map2Page.selectedMenu === "rdv") {
                Map2Page.el.find('.centerMarkerRdv').show();
                Map2Page.el.find('.centerMarkerDrop').hide();
            } else if (Map2Page.selectedMenu === "arrival") {
                Map2Page.el.find('.centerMarkerRdv').hide();
                Map2Page.el.find('.centerMarkerDrop').show();
            }
            Map2Page.el.find('.mapTutorialContent').html('<img src="img/lock_markers.svg" alt=""><div class="mapTutorialText">Verrouiller le</br>lieu de ' + type + '</div>');
        } else {
            if (Map2Page.selectedMenu === "rdv") {
                Map2Page.rdvMarker.open(Map2Page.map);
                Map2Page.dropMarker.close();
            } else if (Map2Page.selectedMenu === "arrival") {
                Map2Page.rdvMarker.close();
                Map2Page.dropMarker.open(Map2Page.map);
            }
            Map2Page.el.find('.centerMarkerRdv').hide();
            Map2Page.el.find('.centerMarkerDrop').hide();
            Map2Page.el.find('.mapTutorialContent').html('<img src="img/unlock_markers.svg" alt=""><div class="mapTutorialText">Positionner le</br>lieu de ' + type + '</div>');
        }
        if (!MapPage.cantEdit)
            Map2Page.handleMapTutoVisibility(true);
        else
            Map2Page.handleMapTutoVisibility(false);
        
        //this handles the overlay part
        Map2Page.el.find('#map-overlay').show();
        if (Map2Page.selectedMenu === "rdv") {
            Map2Page.el.find('.rdv-overlay').show();
            Map2Page.el.find('.arrival-overlay').hide();
            if(!MapPage.cantEdit){
                Map2Page.el.find('.rdv-description').hide();
                Map2Page.el.find('input[name="rdv-description"]').show();
            } else {
                Map2Page.el.find('.rdv-description').show();
                Map2Page.el.find('input[name="rdv-description"]').hide();
            }
        } else if (Map2Page.selectedMenu === "arrival") {
            Map2Page.el.find('.rdv-overlay').hide();
            Map2Page.el.find('.arrival-overlay').show();
            if(!MapPage.cantEdit){
                Map2Page.el.find('.arrival-description').hide();
                Map2Page.el.find('input[name="arrival-description"]').show();
            } else {
                Map2Page.el.find('.arrival-description').show();
                Map2Page.el.find('input[name="arrival-description"]').hide();
            }
        }
    }
};

Map2Page.handleMapTutoVisibility = function(show) {
    if (!!Map2Page.MapTutorialInterval)
        clearInterval(Map2Page.MapTutorialInterval);
    if (show) {
        Map2Page.el.find('.mapControls').show();
        Map2Page.el.find('.mapTutorialContent').css('opacity','1');
        Map2Page.MapTutorialInterval = setInterval(function() {
            Map2Page.el.find('.mapTutorialContent').animate({opacity:'0.3'},300);
            setTimeout(function() {
                Map2Page.el.find('.mapTutorialContent').animate({opacity:'1'},300);
            },300);
        },2000);
    } else {
        Map2Page.el.find('.mapControls').hide();
        Map2Page.el.find('.mapTutorialContent').css('opacity','1');
    }
};

Map2Page.tutoClickHandler = function() {
    if(!MapPage.cantEdit){
        Map2Page.markersAreMobile = !Map2Page.markersAreMobile;
        if (Map2Page.markersAreMobile === true)
            window.plugins.toast.showShortCenter("Déplacez la carte, le panneau est fixé au centre de l'écran");
        Map2Page.handleMarkers();
        google.maps.event.trigger(Map2Page.map, "idle");
    }
};

Map2Page.markerClickHandler = function() {
    if(!MapPage.cantEdit){
        if (!Map2Page.markersAreMobile) {
            Map2Page.markersAreMobile = true;
            window.plugins.toast.showShortCenter("Déplacez la carte, le panneau est fixé au centre de l'écran");
            Map2Page.handleMarkers();
            google.maps.event.trigger(Map2Page.map, "idle");
        }
    }
};

Map2Page.tutoToast = function() {
    if(!MapPage.cantEdit)
        window.plugins.toast.showShortCenter("Déplacez la carte, le panneau est fixé au centre de l'écran");
};

Map2Page.initializeMap = function (label) {
    Map2Page.computeTrajetCenter();
    if (!Map2Page.map) {
        var mapOptions = {
            zoom: 8,
            center: Map2Page.trajetBounds.getCenter(),
            mapTypeControl:false,
            panControl:false,
            streetViewControl:true,
            streetViewControlOptions: {
                position: google.maps.ControlPosition.LEFT_CENTER
            },
            zoomControl:false
        };
        Map2Page.map = new google.maps.Map(
                $('#map-canvas')[0],
                mapOptions
        );
        Map2Page.handleMapLoadingMessage();
        Map2Page.initializeMapEvent();
        Map2Page.endRendering(label);
        setTimeout(function() {
            if ($('#map-canvas div').first().html() === '') { //The map is not displayed
                navigator.notification.alert(
                    "Il semble que la carte ne s'affiche pas",
                    function() {
                        Geocoding.label = label;
                        Geocoding.intializeLocked = false;
                        load.googleScriptInitializedLocked = false;
                        load.initGoogleScript("map2");
                    },
                    'Erreur de connexion',
                    'Réessayer'
                );
            }
        }, 7000);
    } else {
        Map2Page.resetMatch();
        google.maps.event.trigger(Map2Page.map, "resize");
        Map2Page.endRendering(label);
    }
};

Map2Page.computeTrajetCenter = function() {
    var bounds = new google.maps.LatLngBounds();
    var latlngdep;
    var latlngarr;
    if (!!MapPage.route) {
        for (var i = 0; i < MapPage.route.length; i++) {
            bounds.extend(MapPage.route[i]);
        }
    } else {
        latlngdep = new google.maps.LatLng(MapPage.depDriver.lat, MapPage.depDriver.lng);
        latlngarr = new google.maps.LatLng(MapPage.arrDriver.lat, MapPage.arrDriver.lng);
        bounds.extend(latlngdep);
        bounds.extend(latlngarr);
    }
    latlngdep = new google.maps.LatLng(MapPage.depPassenger.lat, MapPage.depPassenger.lng);
    latlngarr = new google.maps.LatLng(MapPage.arrPassenger.lat, MapPage.arrPassenger.lng);
    bounds.extend(latlngdep);
    bounds.extend(latlngarr);
    Map2Page.trajetBounds = bounds;
};

Map2Page.initializeMapEvent = function () {
    google.maps.event.addListener(Map2Page.map,'idle', function() {
        if (Map2Page.selectedMenu === "rdv"){
            if(!MapPage.cantEdit & Map2Page.markersAreMobile === true){
                var center = Map2Page.map.getCenter();
                Map2Page.rdvMarker.setPosition(center);
                MapPage.matchList[MapPage.matchNum].agreementJourney.pickupPlace.latitude  = center.lat();
                MapPage.matchList[MapPage.matchNum].agreementJourney.pickupPlace.longitude = center.lng();
                Map2Page.refreshAddress(true);
            } else {
                Map2Page.refreshAddress(false);
            }
        } else if (Map2Page.selectedMenu === "arrival") {
            if(!MapPage.cantEdit & Map2Page.markersAreMobile === true){
                var center = Map2Page.map.getCenter();
                Map2Page.dropMarker.setPosition(center);
                MapPage.matchList[MapPage.matchNum].agreementJourney.dropPlace.latitude  = center.lat();
                MapPage.matchList[MapPage.matchNum].agreementJourney.dropPlace.longitude = center.lng();
                Map2Page.refreshAddress(true);
            } else {
                Map2Page.refreshAddress(false);
            }
        }
        if (Map2Page.selectedMenu !== "global") {
            Map2Page.dragLock = false;
            if (Map2Page.menuChanged === 'back') Map2Page.backToPreviousPage();
            if(!MapPage.cantEdit)
                Map2Page.el.find('.mapControls').show();
        }
    });

    google.maps.event.addListener(Map2Page.map,'dragstart', function() {
        if (Map2Page.selectedMenu !== "global") {
            if(Map2Page.markersAreMobile === true)
                Map2Page.el.find('.mapControls').hide();
            Map2Page.dragLock = true;
        }
    });

    Map2Page.panorama = Map2Page.map.getStreetView();
    google.maps.event.addListener(Map2Page.panorama, 'visible_changed', function() {
        if (Map2Page.selectedMenu !== "global") {
            Map2Page.handleMarkers();
        }
    });
};

//updates the address in the overlay
Map2Page.refreshAddress = function (enforced) {
    var center;
    if (Map2Page.selectedMenu === "rdv"){
        var overlayVal = Map2Page.el.find('#map-overlay .rdv-overlay .address').html();
        if (enforced === true | overlayVal === "chargement de l'adresse..." | overlayVal === "Déplacez la carte pour raffraichir l'adresse")
            center = Map2Page.rdvMarker.getPosition();
    } else if (Map2Page.selectedMenu === "arrival") {
        var overlayVal = Map2Page.el.find('#map-overlay .arrival-overlay .address').html();
        if (enforced === true | overlayVal === "chargement de l'adresse..." | overlayVal === "Déplacez la carte pour raffraichir l'adresse")
            center = Map2Page.dropMarker.getPosition();
    }
    if (!!center) {
        var latlong = {lat : center.lat(), lng : center.lng()};
        Geocoding.reverseGeocodingMap(latlong,function(data){
            if(data[0]){
                if (Map2Page.selectedMenu === "rdv")
                    Map2Page.el.find('#map-overlay .rdv-overlay .address').html(data[0].formatted_address);
                if (Map2Page.selectedMenu === "arrival")
                    Map2Page.el.find('#map-overlay .arrival-overlay .address').html(data[0].formatted_address);
            }
        });
    }
};

Map2Page.streetViewAlert = function() {
    window.plugins.toast.showShortTop("Sortie de street view");
    Map2Page.panorama.setVisible(false);
};

Map2Page.showTrajet = function() {
    if (!MapPage.route)
        return;
    Map2Page.polylineMaker = new google.maps.Polyline({
        path: MapPage.route,
        geodesic: true,
        strokeColor: '#000000',
        strokeOpacity: 0.3,
        strokeWeight: 4,
        clickable : false
    });
    Map2Page.polylineMaker.setMap(Map2Page.map);
};

Map2Page.showMarker = function () {
    var int = MapPage.markers.length;
    for (var i =0;i<int;i++){
        MapPage.markers[i].setMap(Map2Page.map);
    }

    Map2Page.loadMeetUpMaker();
    Map2Page.loadDropMarker();
};

Map2Page.loadMeetUpMaker = function() {
    var image = $('<img alt="" src="img/rdv_flag.png" style="height: 80px; width: 110px">');
    
    var journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
    var lat = journey.pickupPlace.latitude;
    var lng = journey.pickupPlace.longitude;

    Map2Page.loadMarkerSvg(image,'rdvMarker',lat,lng);
};

Map2Page.loadDropMarker = function(){
    var image = $('<img alt="" src="img/drop_flag.png" style="height: 80px; width: 110px">');
    
    var journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
    var lat = journey.dropPlace.latitude;
    var lng = journey.dropPlace.longitude;

    Map2Page.loadMarkerSvg(image,'dropMarker',lat,lng);
};

Map2Page.loadMarkerSvg = function(svgObject,markerType,lat,lng){
    var markerWidth;
    var markerHeight;
    var pixelOffset;
    var zIndex;
    
    markerWidth = 110;
    markerHeight = 80;
    pixelOffset = new google.maps.Size(markerWidth*-0.5, 4);
    zIndex = -19;

    var markerDiv = $('<div></div>').append(svgObject).css({
        width: markerWidth + 'px',
        height: 'auto',
        position: 'relative'
    });
    
    var markerInfoBox = new InfoBox({
        alignBottom: true,
        content: markerDiv[0],
        closeBoxURL: '',
        pixelOffset: pixelOffset,
        pane: 'overlayImage',
        position: new google.maps.LatLng(lat, lng),
        zIndex: zIndex,
        disableAutoPan: true,
        enableEventPropagation: true
    });

    markerDiv.on('touchstart', function(event) {
        event.stopPropagation();
        Map2Page.markerClickHandler();
    });

    markerInfoBox.open(Map2Page.map);
    if(typeof Map2Page[markerType] !== "undefined"){
        Map2Page[markerType].close();
    }
    Map2Page[markerType] = markerInfoBox;
};

Map2Page.zoomBoundAndCenter = function(point, point2, center) {
    Map2Page.trickToBeShureMapMoved();
    var bounds = new google.maps.LatLngBounds();
    bounds.extend(new google.maps.LatLng(point.lat,point.lng));
    if (!!point2)
        bounds.extend(point2);
    bounds.extend(center);
    var ne = bounds.getNorthEast();
    var sw = bounds.getSouthWest();
    var cornerLat;
    if (Math.abs(center.lat()-sw.lat()) < Math.abs(center.lat()-ne.lat())) cornerLat = 2*center.lat() - ne.lat();
    else cornerLat = 2*center.lat() - sw.lat();
    var cornerLng;
    if (Math.abs(center.lng()-sw.lng()) < Math.abs(center.lng()-ne.lng())) cornerLng = 2*center.lng() - ne.lng();
    else cornerLng = 2*center.lng() - sw.lng();
    var corner = new google.maps.LatLng(cornerLat,cornerLng);
    bounds.extend(corner);
    Map2Page.map.fitBounds(bounds);
};

Map2Page.trickToBeShureMapMoved = function() {
    var center = Map2Page.map.getCenter();
    var newCenter = new google.maps.LatLng(center.lat()+0.00001, center.lng()+0.00001);
    Map2Page.map.panTo(newCenter);
};

Map2Page.resetMatch = function () {
    //delete markers
    if (!!Map2Page.polylineMaker) {
        Map2Page.polylineMaker.setMap(null);
        delete Map2Page.polylineMaker;
    }
    Map2Page.rdvMarker.setMap(null);
    delete Map2Page.rdvMaker;
    Map2Page.dropMarker.setMap(null);
    delete Map2Page.dropMarker;
};

Map2Page.endRendering = function(label) {
    Map2Page.showTrajet();
    Map2Page.showMarker();
    if (label === ".rdv")
        Map2Page.renderRDV();
    else if (label === ".arrival")
        Map2Page.renderDrop();
    else
        Map2Page.renderGlobal();
};

Map2Page.needHandleRDVTuto = function() {
    if (!!Map2Page.skipRDVTuto) { //Needs to be the fisrt check
        Map2Page.skipRDVTuto = false;
        return false;
    }
    if (Map2Page.outCorrespondsTo === '.back-menu')
        return false;
    if (!!MapPage.RDVTutoSnobed)
        return false;
    if (!!MapPage.cantEdit)
        return false;
    if (Map2Page.selectedMenu !== "rdv")
        return false;
    if (Map2Page.el.find('input[name="rdv-description"]').val() !== 'Décrivez le lieu de RDV')
        return false;
    else {
        Map2Page.markersAreMobile = false;
        Map2Page.handleMarkers();
        Map2Page.el.find('.addressSearchPopUp').hide();
        Map2Page.el.find('.rdvDescription').show();
        Map2Page.el.find('.rdvDescriptionText').val(Map2Page.el.find('.rdvDescriptionText').attr('placeholder'));
        Map2Page.showPopUp();
        setTimeout(function() {
            Map2Page.el.find('.rdvDescriptionText').focus();
            cordova.plugins.Keyboard.show();
        },10);
        return true;
    }
};

Map2Page.backToPreviousPage = function() {
    if (Map2Page.panorama.getVisible())
        Map2Page.streetViewAlert();
    if (Map2Page.dragLock === true) {
        Map2Page.menuChanged = 'back';
        return;
    }
    Map2Page.menuChanged = 'none';
    if (Map2Page.needHandleRDVTuto())
        return;
    if (!!Map2Page.MapTutorialInterval)
        clearInterval(Map2Page.MapTutorialInterval);
    if (!MapPage.cantEdit) {
        MapPage.fillInRDVDrop(false);
        if ((MapPage.type === 'type1' & Partir4Page.userType === 'driver') | (MapPage.type === 'type2' & Partir4Page.userType === 'passenger')) {
            Map2Page.checkForCounterProposition();
        }
    }
    
    if (Map2Page.selectedMenu === "rdv" | Map2Page.selectedMenu === "arrival")
        Map2Page.backToMap();
    else
        Map2Page.backToJourney();
};

Map2Page.backToMap = function() {
    $(".shown").removeClass("shown");
    Notification.handleNotification();
    Menu.scroller(MapPage);
    MapPage.el.addClass("shown");
};

Map2Page.backToJourney = function() {
    $(".shown").removeClass("shown");
    JourneyPage.el.addClass("shown");
};

Map2Page.checkForCounterProposition = function() {
    var initialMatch = MapPage.counterPropositionInitialMatch;
    var initialJourney = initialMatch.agreementJourney;
    var match = MapPage.matchList[MapPage.matchNum];
    var journey = match.agreementJourney;
    var counter = match.agreements[MapPage.agreementNum].counterProposition;
    
    var switchToCounterProposition = false;
    var causedByMap = false;
    
    if (initialJourney.pickupPlace.latitude !== journey.pickupPlace.latitude
            | initialJourney.pickupPlace.longitude !== journey.pickupPlace.longitude
            | (initialMatch.match.pickupDescription !== match.match.pickupDescription & !(!initialMatch.match.pickupDescription & match.match.pickupDescription === ''))) {
        MapPage.el.find('.rdvBox').css('backgroundColor','rgb(255,250,230)');
        switchToCounterProposition = true;
        causedByMap = true;
    } else {
        if ((counter & MONDAY) !== 0)
            MapPage.el.find('.rdvBox').css('backgroundColor','rgb(240,245,250)');
        else
            MapPage.el.find('.rdvBox').css('backgroundColor','transparent');
    }
    
    if (initialJourney.dropPlace.latitude !== journey.dropPlace.latitude
            | initialJourney.dropPlace.longitude !== journey.dropPlace.longitude
            | (initialMatch.match.dropDescription !== match.match.dropDescription & !(!initialMatch.match.dropDescription & match.match.dropDescription === ''))) {
        MapPage.el.find('.dropBox').css('backgroundColor','rgb(255,250,230)');
        switchToCounterProposition = true;
        causedByMap = true;
    } else {
        if ((counter & TUESDAY) !== 0)
            MapPage.el.find('.dropBox').css('backgroundColor','rgb(240,245,250)');
        else
            MapPage.el.find('.dropBox').css('backgroundColor','transparent');
    }
    
    var initialDate = new Date(initialMatch.agreementJourney.pickupTimeMin + " GMT");
    var date = new Date(match.agreementJourney.pickupTimeMin + " GMT");
    if (initialDate.getTime() !== date.getTime()) {
        MapPage.el.find('.timeBox').css('backgroundColor','rgb(255,250,230)');
        switchToCounterProposition = true;
    } else {
        if ((counter & WEDNESDAY) !== 0)
            MapPage.el.find('.timeBox').css('backgroundColor','rgb(240,245,250)');
        else
            MapPage.el.find('.timeBox').css('backgroundColor','transparent');
    }
    
    var initialPrice;
    var price;
    if (Partir4Page.userType ==="driver"){
        initialPrice = initialMatch.agreementJourney.price;
        price = match.agreementJourney.price;
    } else {
        initialPrice = initialMatch.agreementJourney.passengerPrice;
        price = match.agreementJourney.passengerPrice;
    }
    if (initialPrice !== price) {
        MapPage.el.find('.priceBox').css('backgroundColor','rgb(255,250,230)');
        switchToCounterProposition = true;
    } else {
        if ((counter & THURSDAY) !== 0)
            MapPage.el.find('.priceBox').css('backgroundColor','rgb(240,245,250)');
        else
            MapPage.el.find('.priceBox').css('backgroundColor','transparent');
    }
    
    if (switchToCounterProposition === true) {
        MapPage.switchToCounterProposition(causedByMap);
    } else {
        MapPage.loadMatch(false, true);
    }
};

//affiche la page
Map2Page.render = function(label) {
    Map2Page.reset();
    Map2Page.markersAreMobile = false;
    Map2Page.el.find('.mapControls').hide();
    Map2Page.el.find('.centerMarkerRdv').hide();
    Map2Page.el.find('.centerMarkerDrop').hide();
    if (label === '.rdv') {
        Map2Page.el.find('.headerTitle').html("Lieu de RDV");
        Map2Page.skipRDVTuto = false;
    } else if (label === '.arrival') {
        Map2Page.el.find('.headerTitle').html("Lieu de dépose");
        Map2Page.skipRDVTuto = true;
    } else {
        Map2Page.el.find('.headerTitle').html("Trajet de "+escapeXml(MapPage.matchList[MapPage.matchNum].profile.name));
    }
    this.el.addClass("shown");
    Menu.handleJSRendering(Map2Page);
    $('#map-wrapper').height(windowHeight -  Map2Page.el.find('.header').outerHeight());
    Map2Page.initializeMap(label);
};

Map2Page.reset = function() {
    
};

Map2Page.handleMapLoadingMessage = function() {
    setTimeout(function() {
        if ($('#map-canvas div').first().html() === '') //The map is not displayed
            Map2Page.handleMapLoadingMessage();
        else
            Map2Page.el.find('#map2MapLoad').hide();
    }, 300);
};

Map2Page.centerMap = function(lat, lng) {
    var center = new google.maps.LatLng(lat, lng);
    Map2Page.map.panTo(center);
};

Map2Page.showPopUp = function() {
    var popUp = Map2Page.el.find('.popUp');
    var overlay = Map2Page.el.find('.overlay');
    popUp.show();
    overlay.show();
};