/* global Notification, MapPage, Menu, Partir4Page, PartirPage, MyTravels, Map2Page */

var Map3Page = new Object();

Map3Page.el = $('#map3');

//Fonction d'initialisation, affecte les evenements.
Map3Page.initialize = function () {
    this.eventHandler();
};

Map3Page.eventHandler = function () {
    
    this.el.find('.back-menu').on('click',function (){
        Map3Page.backToPreviousPage();
    });
    
    this.el.on('click','.navigationTravel',function(){
        var journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
        window.open("https://maps.google.com/maps?saddr=" + MapPage.depDriver.lat + "," + MapPage.depDriver.lng + "&daddr=" + journey.pickupPlace.latitude + "," + journey.pickupPlace.longitude, '_system');
    });
    
    this.el.on('click','.validTime',function(){
        var day = parseInt(Map3Page.el.find("input[name='dayInput']").val(), 10);
        var month = parseInt(Map3Page.el.find("input[name='month']").val(), 10);
        var year = parseInt(Map3Page.el.find("input[name='year']").val(), 10);
        var hour = parseInt(Map3Page.el.find("input[name='hour']").val(), 10);
        var minutes = parseInt(Map3Page.el.find("input[name='minutes']").val(), 10);
        var date = new Date(year, month-1, day, hour, minutes);
        var dateS = date.toUTCString();
        MapPage.matchList[MapPage.matchNum].agreementJourney.pickupTimeMin = dateS.substring(0,dateS.length - 3);
        MapPage.el.find('.timeBox .agreementBoxAddress').html(MyTravels.computeTimeString(0, date));
        if (MapPage.type !== 'normal')
            Map2Page.checkForCounterProposition();
        Map3Page.backToPreviousPage();
    });
    
    this.el.on('touchstart', '.addMin, .addH', function (event) {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
        var object = $(this);
        var num = parseInt(object.parent().find('input').val(), 10);
        object.parent().find('input').val(num + 1).blur();
        PartirPage.timer = setTimeout(function(){
        if (object.hasClass('addMin')) PartirPage.timeOutMin(object, "plus", 1, 100);
        else PartirPage.timeOutH(object, "plus");
        },300);
        object.one('touchend', function () {
            clearTimeout(PartirPage.timer);
            clearInterval(PartirPage.interval);
        });
    });

    this.el.on('touchstart', '.substractMin, .substractH', function (event) {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
        var object = $(this);
        var num = parseInt(object.parent().find('input').val(), 10);
        object.parent().find('input').val(num - 1).blur();
        PartirPage.timer = setTimeout(function(){
        if (object.hasClass('substractMin')) PartirPage.timeOutMin(object, "substract", 1, 100);
        else PartirPage.timeOutH(object, "substract");
        },300);
        object.one('touchend', function () {
            clearTimeout(PartirPage.timer);
            clearInterval(PartirPage.interval);
        });
    });
    
    this.el.on('touchstart', '.addDay, .addMonth, .addYear', function (event) {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
        var object = $(this);
        var kind;
        if (object.hasClass('addYear')) kind = 'year';
        else if (object.hasClass('addMonth')) kind = 'month';
        else if (object.hasClass('addDay')) kind = 'day';
        PartirPage.timeOutDateAction("plus", kind, Map3Page);
        PartirPage.timer = setTimeout(function(){
        PartirPage.timeOutDate("plus", kind, Map3Page);
        },300);
        object.one('touchend', function () {
            clearTimeout(PartirPage.timer);
            clearInterval(PartirPage.interval);
        });
    });

    this.el.on('touchstart', '.substractDay, .substractMonth, .substractYear', function (event) {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
        var object = $(this);
        var kind;
        if (object.hasClass('substractYear')) kind = 'year';
        else if (object.hasClass('substractMonth')) kind = 'month';
        else if (object.hasClass('substractDay')) kind = 'day';
        PartirPage.timeOutDateAction("substract", kind, Map3Page);
        PartirPage.timer = setTimeout(function(){
        PartirPage.timeOutDate("substract", kind, Map3Page);
        },300);
        object.one('touchend', function () {
            clearTimeout(PartirPage.timer);
            clearInterval(PartirPage.interval);
        });
    });
    
    this.el.on('blur',"input[name='dayInput'], input[name='month'], input[name='year']",function () {
        if (PartirPage.el.find("input[name='dayInput']").val() === "")
            PartirPage.el.find("input[name='dayInput']").val("01");
        if (PartirPage.el.find("input[name='month']").val() === "")
            PartirPage.el.find("input[name='month']").val("01");
        if (PartirPage.el.find("input[name='year']").val() === "")
            PartirPage.el.find("input[name='year']").val("2015");
        var day = parseInt(Map3Page.el.find("input[name='dayInput']").val(), 10);
        var month = parseInt(Map3Page.el.find("input[name='month']").val(), 10);
        var year = parseInt(Map3Page.el.find("input[name='year']").val(), 10);
        var date = new Date(Date.UTC(year, month-1, day, 0, 0, 0, 0));
        var dayNum = date.getDate();
        if (dayNum < 10) dayNum = "0"+dayNum;
        var monthNum = date.getMonth() + 1;
        if (monthNum < 10) monthNum = "0"+monthNum;
        Map3Page.el.find("input[name='dayInput']").val(dayNum);
        Map3Page.el.find("input[name='month']").val(monthNum);
        Map3Page.el.find("input[name='year']").val(date.getFullYear());
    });

    this.el.on('blur','input[name="hour"]',function () {
        if ($(this).val() === "")
            $(this).val("01");
        if (parseInt($(this).val(), 10) > 23) {
            $(this).val('00');
        } else if (parseInt($(this).val(), 10) < 0) {
            $(this).val(23);
        }
        var value = parseInt(Map3Page.el.find('input[name="hour"]').val(), 10);
        if (value < 10) Map3Page.el.find('input[name="hour"]').val("0"+value);
    });

    this.el.on('blur','input[name="minutes"]',function () {
        if ($(this).val() === "")
            $(this).val("01");
        if (parseInt($(this).val(), 10) > 59) {
            $(this).val('00');
            var h = Map3Page.el.find("input[name='hour']").val();
            if (h === '23') Map3Page.el.find("input[name='hour']").val('00');
            else Map3Page.el.find("input[name='hour']").val(parseInt(h, 10) + 1);
        } else if (parseInt($(this).val(), 10) < 0) {
            $(this).val(59);
            var h = Map3Page.el.find("input[name='hour']").val();
            if (h === '00') Map3Page.el.find("input[name='hour']").val(23);
            else Map3Page.el.find("input[name='hour']").val(parseInt(h, 10) - 1);
        }

        var value = parseInt(Map3Page.el.find('input[name="hour"]').val(), 10);
        if (value < 10) Map3Page.el.find('input[name="hour"]').val("0"+value);
        value = parseInt(Map3Page.el.find('input[name="minutes"]').val(), 10);
        if (value < 10) Map3Page.el.find('input[name="minutes"]').val("0"+value);
    });
};

Map3Page.backToPreviousPage = function() {
    $(".shown").removeClass("shown");
    Notification.handleNotification();
    Menu.scroller(MapPage);
    MapPage.el.addClass("shown");
};

Map3Page.fillTime = function() {
    var journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
    var date    = new Date(journey.pickupTimeMin + " GMT");
    Map3Page.el.find("input[name='dayInput']").val(date.getDate()).blur();
    Map3Page.el.find("input[name='month']").val(date.getMonth() + 1).blur();
    Map3Page.el.find("input[name='year']").val(date.getFullYear());
    Map3Page.el.find("input[name='hour']").val(date.getHours()).blur();
    Map3Page.el.find("input[name='minutes']").val(date.getMinutes()).blur();
};

//affiche la page
Map3Page.render = function() {
    Map3Page.reset();
    this.el.addClass("shown");
    Map3Page.el.find('.name').html(escapeXml(MapPage.matchList[MapPage.matchNum].profile.name));
    Menu.handleJSRendering(Map3Page);
    if (Partir4Page.userType === 'driver') {
        Map3Page.el.find('.driver').hide();
        Map3Page.el.find('.passenger').show();
    } else {
        Map3Page.el.find('.driver').show();
        Map3Page.el.find('.passenger').hide();
    }
    Map3Page.el.find('.timeInfo').html(MapPage.otherTimeStringFormat(MapPage.matchList[MapPage.matchNum]));
    Map3Page.fillTime();
};

Map3Page.reset = function() {
    
};