/* global encodeURIComponent, Partir4Page, MapPage, Notification, ContactsPage, Menu, windowHeight, deviceType */

var MessagePage = new Object();

MessagePage.el = $('#chat');
MessagePage.userInfo;
MessagePage.contentToGoSomewhere;
MessagePage.pendingMessages = [];
MessagePage.commingFrom;

//Fonction d'initialisation, affecte les evenements.
MessagePage.initialize = function () {
    this.eventHandler();
};

MessagePage.eventHandler = function () {
    this.el.find('#message-send').click(function(){
        var message = MessagePage.el.find('#message-content').val();
        if (message !== MessagePage.el.find('#message-content').attr('placeholder') & message !== "") {
            if (encodeURIComponent(message).length > 254) {
                alert('Le message est trop long pour être envoyé en une seule fois');
                return;
            }
            MessagePage.el.find('#message-content').val('');
            var data = new Object();
            data.class="pending";
            data.message = message;
            data.time = 'Envoi en cours...';
            var messageTemplate = MessagePage.appendMessage(data);
            MessagePage.fixHeights();
            if (MessagePage.commingFrom === "MapPage")
                messageTemplate.find('.storeData').html("<span class='storeMatchId'>"+MessagePage.userInfo.matchId+"</span>"
                    +"<span class='storeJourneyId'>"+MessagePage.userInfo.journeyId+"</span>");
            else
                messageTemplate.find('.storeData').html("<span class='storeContactId'>"+MessagePage.userInfo.idContact+"</span>");
            MessagePage.pendingMessages.push(messageTemplate);
            MessagePage.sendMessage(encodeURIComponent(message), messageTemplate);
        }
    });
    
    this.el.find('textarea').on('focus',function (){
        MessagePage.fixHeightsCriticalTimeout(true);
    });
    
    this.el.find('textarea').on('blur',function (){
        MessagePage.fixHeightsCriticalTimeout(false);
    });

    this.el.find('.back-menu').on('click',function (){
        MessagePage.backToPreviousPage();
    });
};

MessagePage.fixHeightsCriticalTimeout = function(keyBoardUp) {
    if (deviceType !== 'iOS') {
        setTimeout(function(){
            if (($(window).height() !== windowHeight & keyBoardUp === false) 
                |($(window).height() === windowHeight & keyBoardUp === true)) {
                MessagePage.fixHeightsCriticalTimeout(keyBoardUp);
                return;
            }
            MessagePage.fixHeights();
        }, 500);
    }
};

MessagePage.sendMessage = function (message, messageTemplate) {
    if( MessagePage.commingFrom === "MapPage"){
        MessagePage.sendMessageMatch(message, messageTemplate, MessagePage.userInfo.matchId, MessagePage.userInfo.journeyId);
    } else {
        MessagePage.sendMessageContact(message, messageTemplate, MessagePage.userInfo.idContact);
    }
};

MessagePage.sendMessageMatch = function (message, messageTemplate, matchId, journeyId) {
    serverRequest(
        "/travel/sendMessage",
        "GET",
        function(){
            MessagePage.messageSent(messageTemplate);
        },
        "send message travel MessagePage",
        function (){
            MessagePage.sendMessageMatch(message, messageTemplate, matchId, journeyId);
        },
        {
            'matchId':matchId,
            'myJourneyId':journeyId,
            'message':message
        },
        null,
        null,
        null,
        null,
        messageTemplate
    );
};

MessagePage.sendMessageContact = function (message, messageTemplate, contactId) {
    serverRequest(
        "/contacts/sendMessage",
        "GET",
        function(){
            MessagePage.messageSent(messageTemplate);
        },
        "send message contact MessagePage",
        function (){
            MessagePage.sendMessage(message, messageTemplate, contactId);
        },
        {
            'idContact':contactId,
            'message':message
        },
        null,
        null,
        null,
        null,
        messageTemplate
    );
};

MessagePage.messageSent = function(messageTemplate, fail){
    var index = -1;
    for(var i = 0;i<MessagePage.pendingMessages.length;i++){
        if (MessagePage.pendingMessages[i] === messageTemplate) {
            index = i;
            break;
        }
    }
    if (index > -1) {
        MessagePage.pendingMessages.splice(index, 1);
    }
    if (!fail) {
        messageTemplate.find('.time').html(MessagePage.computeTime(new Date()));
        messageTemplate.find('.pending-wrapper').removeClass('pending-wrapper').addClass('user-wrapper');
    } else {
        messageTemplate.find('.time').html('echec');
        messageTemplate.find('.pending-wrapper').removeClass('pending-wrapper').addClass('fail-wrapper');
    }
};

MessagePage.setUpUsers = function (data) {
    MessagePage.userInfo = data;
    if( typeof MessagePage.userInfo.journeyId !=="undefined"){
        MessagePage.commingFrom = "MapPage";
        MessagePage.el.find(".name").html(escapeXml(data.name));
        MessagePage.el.find(".previousPageTitle").html('Récapitulatif');
    } else {
        MessagePage.commingFrom = "ContactsPage";
        MessagePage.el.find(".name").html(data.name);
        MessagePage.el.find(".previousPageTitle").html('Contacts');
    }
};

MessagePage.loadMessages = function() {
    if(MessagePage.commingFrom === "MapPage"){
        serverRequest(
            "/travel/messages",
            "GET",
            function(data) {
                MessagePage.receptionMessages(data, true);
                if (Partir4Page.userType === 'driver')
                    MapPage.matchList[MapPage.matchNum].match.nbrUnreadD = 0;
                else
                    MapPage.matchList[MapPage.matchNum].match.nbrUnreadP = 0;
                Notification.changeNumNotif(MapPage.el.find(".messageTagNotif"),0);
                if ($('#chatJourneyBigImg').length>0) {
                    Notification.changeNumNotif($('#chatJourneyBigImg'),0);
                }
            },
            "get message travel MessagePage",
            MessagePage.loadMessages,
            {
                matchId:MessagePage.userInfo.matchId,
                myJourneyId:MessagePage.userInfo.journeyId
            }
        );
    } else {
        serverRequest(
            "/contacts/messages",
            "GET",
            function(data) {
                MessagePage.receptionMessages(data, true);
                Notification.changeNumNotif(MessagePage.userInfo.ref.find('.messageContact img'),0);
            },
            "get message contact MessagePage",
            MessagePage.loadMessages,
            {
                idContact:MessagePage.userInfo.idContact
            }
        );
    }
};

MessagePage.receptionMessages = function (data, fromServer){
    data.sort(function(a,b){
        var Atime = new Date(a.date);
        var Btime = new Date(b.date);
        return Atime.getTime() > Btime.getTime() ? 1 : -1;
    });
    
    var messageHolder = MessagePage.el.find('#message-holder');
    messageHolder.html('');
    if (!!fromServer) {
        MessagePage.el.find('.loadingMessage').hide();
        MessagePage.putInCache(data);
    }
    for(var i = 0;i<data.length;i++){
        var localData = new Object();
        if(MessagePage.commingFrom === "MapPage"){
            localData.message = decodeURIComponent(data[i].message);
            if(data[i].sender === Partir4Page.userType){
                localData.class="user";
            } else {
                localData.class="remoteUser";
            }
        } else {
            localData.message = decodeURIComponent(data[i].text);
            if(data[i].sender === MessagePage.userInfo.me){
                localData.class="user";
            } else {
                localData.class="remoteUser";
            }
        }
        var date = new Date(data[i].date+" GMT");
        localData.time = MessagePage.computeTime(date);
        MessagePage.appendMessage(localData);
    }
    
    //add messages from MessagePage.pendingMessages that correspond to the current location
    for(var i = 0;i<MessagePage.pendingMessages.length;i++){
        var operate = false;
        var contactIdSpan = MessagePage.pendingMessages[i].find('.storeContactId');
        if (!!contactIdSpan.html()) {
            if (parseInt(contactIdSpan.html()) === MessagePage.userInfo.idContact)
                operate = true;
        } else {
            if (parseInt(MessagePage.pendingMessages[i].find('.storeMatchId').html()) === MessagePage.userInfo.matchId)
                operate = true;
        }
        if (operate) {
            MessagePage.el.find('#message-holder').append(MessagePage.pendingMessages[i]);
        }
    }
    MessagePage.fixHeights();
};

MessagePage.appendMessage = function (data) {
    var messageHolder = MessagePage.el.find('#message-holder');
    var messageTemplate = $("<div>"+message_template(data)+"</div>");
    messageHolder.append(messageTemplate);
    return messageTemplate;
};

MessagePage.appendMessageFromNotif = function (message, time) {
    var data = new Object();
    data.class="remoteUser";
    data.message = decodeURIComponent(message);
    data.time = MessagePage.computeTime(new Date(time));
    var messageTemplate = MessagePage.appendMessage(data);
    var pendingList = [];
    MessagePage.el.find('#message-wrapper').find('.pending-wrapper').each(function(){
        pendingList.push($(this).parent().parent());
        $(this).parent().parent().remove();
    });
    MessagePage.appendMessage(messageTemplate);
    for (var i=0; i < pendingList.length; i++) {
        MessagePage.el.find('#message-holder').append(pendingList[i]);
    }
    MessagePage.fixHeights();
};

MessagePage.fixHeights = function(keyboardHeight) {
        MessagePage.el.find('#message-holder').css('height', 'auto');
        var othersHeight = MessagePage.el.find('.header').outerHeight() + MessagePage.el.find('#message-input').outerHeight() + 10;
        var targetHeight = (!!keyboardHeight)?($(window).height() - keyboardHeight - othersHeight + 2):($(window).height() - othersHeight + 2);
        MessagePage.el.find('#message-wrapper').css('height', targetHeight);
        if (MessagePage.el.find('#message-holder').height() > targetHeight)
            MessagePage.el.find('#message-holder').css('height', '100%');
        MessagePage.el.find('#message-wrapper').scrollTop(MessagePage.el.find('#message-holder').prop("scrollHeight"));
};

MessagePage.computeTime = function(date) {
    var res = '';
    var now = new Date();
    var year = date.getFullYear();
    var month = date.getMonth()+1;
    var day = date.getDate();
    if(now.getDate()===day && (now.getMonth()+1)===month && now.getFullYear()===year) res += "Aujourd'hui ";
    else {
        if(day<10) day = "0"+day;
        if(month<10) month = "0"+month;
        res += "Le "+day+"/"+month+"/"+year+" ";
    }
    var hourMin= date.getHours();
    var minutesMin = date.getMinutes();
    var dateMinString;
    if(minutesMin<10) minutesMin = "0"+minutesMin;
    if(hourMin<10) hourMin = "0"+hourMin;
    dateMinString = hourMin+":"+minutesMin;
    res += 'à '+dateMinString;
    return res;
};

MessagePage.handleNotifMessageChange = function(bool) {
    if(MessagePage.commingFrom === "MapPage"){
        if (Partir4Page.userType === 'driver') MapPage.matchList[MapPage.matchNum].match.driverNotifMessage = bool;
        else MapPage.matchList[MapPage.matchNum].match.passengerNotifMessage = bool;
        var data = {
            matchId:MessagePage.userInfo.matchId,
            myJourneyId:MessagePage.userInfo.journeyId,
            notifMessage : bool
        };
        MessagePage.senNotifMessageChangeMatch(data);
    } else {
        MessagePage.userInfo.ref.find('.notifMessage').html(bool);
        var data = {
            idContact:MessagePage.userInfo.idContact,
            notifMessage: bool
        };
        MessagePage.senNotifMessageChangeContact(data);
    }
};

MessagePage.senNotifMessageChangeMatch = function(data) {
    serverRequest(
        "/travel/message/changePref",
        "GET",
        function() {},
        "change travel message notif pref",
        function() {MessagePage.senNotifMessageChangeMatch(data);},
        data
    );
};

MessagePage.senNotifMessageChangeContact = function(data) {
    serverRequest(
        "/contacts/messages/changePref",
        "GET",
        function() {},
        "change travel message notif pref",
        function() {MessagePage.senNotifMessageChangeContact(data);},
        data
    );
};

MessagePage.backToPreviousPage = function() {
    $(".shown").removeClass("shown");
    if(MessagePage.commingFrom === "MapPage"){
        MapPage.el.addClass("shown");
        Menu.handleJSRendering(MapPage);
        if (!!MessagePage.contentToGoSomewhere) {
            if (MessagePage.contentToGoSomewhere.type === "agreement")
                goSomewhere(MessagePage.contentToGoSomewhere.journeyId, MessagePage.contentToGoSomewhere.matchId, MessagePage.contentToGoSomewhere.agreementId);
            else
                goToPage("#myTravels");
        }
    } else {
        ContactsPage.el.addClass("shown");
        Menu.handleJSRendering(ContactsPage);
    }
};

//Affiche la page
MessagePage.render = function () {
    if (MessagePage.userInfo.notif === true) MessagePage.el.find("input[value='chat']").prop('checked',true);
    else MessagePage.el.find("input[value='chat']").prop('checked',false);
    MessagePage.el.find('textarea').val('').focus().blur();
    MessagePage.retriveFromCache();
    this.el.addClass("shown");
    Menu.handleJSRendering(MessagePage);
    MessagePage.el.find('#message-input').css("bottom",0);
    MessagePage.fixHeights();
    delete MessagePage.contentToGoSomewhere;
    MessagePage.loadMessages();
};

MessagePage.sendDowngradeUnreadMatch = function(journeyId, matchId) {
    serverRequest(
        "/travel/downgradeUnreadMessages",
        "GET",
        function() {},
        "downgrade unread messages",
        function() {MessagePage.sendDowngradeUnreadMatch(journeyId, matchId);},
        {
            'matchId':matchId,
            'myJourneyId':journeyId
        }
    );
};

MessagePage.sendDowngradeUnreadContact = function(contactId) {
    serverRequest(
        "/contacts/downgradeUnreadMessages",
        "GET",
        function() {},
        "downgrade unread messages",
        function() {MessagePage.sendDowngradeUnreadContact(contactId);},
        {idContact : contactId}
    );
};

MessagePage.putInCache = function(data) {
    var messagesCache = window.localStorage.getArray("reverseGeocodingCache");
    var cacheItem = {
        data : data,
        matchId : MessagePage.userInfo.matchId,
        idContact : MessagePage.userInfo.idContact
    };
    var foundInCache = false;
    for (var i=0; i<messagesCache.length; i++) {
        var item = messagesCache[i];
        if (item.matchId === cacheItem.matchId & item.idContact === cacheItem.idContact) {
            messagesCache[i] = cacheItem;
            foundInCache = true;
        }
    }
    if (!foundInCache)
        messagesCache.push(cacheItem);
    window.localStorage.setArray("reverseGeocodingCache", messagesCache);
};

MessagePage.retriveFromCache = function() {
    MessagePage.el.find('#message-holder').html('');
    MessagePage.el.find('.loadingMessage').show();
    var messagesCache = window.localStorage.getArray("reverseGeocodingCache");
    var cacheItem;
    for (var i=0; i<messagesCache.length; i++) {
        var item = messagesCache[i];
        if (item.matchId === MessagePage.userInfo.matchId & item.idContact === MessagePage.userInfo.idContact) {
            cacheItem = item;
        }
    }
    if (!!cacheItem)
        MessagePage.receptionMessages(cacheItem.data, false);
};