/* global facebookConnectPlugin, CreatePage, deviceType */

var MyAccountPage = new Object();
var facebook = false;
MyAccountPage.el = $('#myAccount');
MyAccountPage.initialState;

//Fonction d'initialisation, affecte les evenements.
MyAccountPage.initialize = function() {
        this.eventHandler();
};

MyAccountPage.eventHandler = function () {
    this.el.on('touchstart','label',function(event){
        $(this).one('touchmove',function (event){
            $(this).off('touchend'); 
        });
        $(this).one('touchend', function (event) {
            radioImg($(this),CreatePage);
        });
    });

    this.el.find('form').submit(this.formHandler);

    this.el.on('click',".valid",function(event) {
        event.preventDefault();
        MyAccountPage.prepareData();
    });

    this.el.on('click',".cancel",function (event) {
        event.preventDefault();
        MyAccountPage.el.find('input[name=curPasswordKankaroo]').val('');
        MyAccountPage.el.find('input[name=curPasswordBoth]').val('');
        hidePopUp(MyAccountPage);
    });

    this.el.on('click',".popUp",function (event) {
        event.stopPropagation();
    });

    this.el.on('click','.overlay',function(event){
        event.stopPropagation();
        MyAccountPage.el.find('input[name=curPasswordKankaroo]').val('');
        MyAccountPage.el.find('input[name=curPasswordBoth]').val('');
        hidePopUp(MyAccountPage);
    });
    
    this.el.on('click','.pwdHelp',function(event){
        event.stopPropagation();
        navigator.notification.confirm(
        "Vous allez recevoir un mail de récupération du mot de passe à l'adresse : "+localStorage.mail, 
         function(index){
            if (index === 2) {
                var data = {'mail' : localStorage.mail};
                MyAccountPage.el.find('input[name="curPasswordKankaroo"]').val('');
                MyAccountPage.el.find('input[name="curPasswordBoth"]').val('');
                hidePopUp(MyAccountPage);
                showLoading();
                serverRequest(
                    "/restorePassword",
                    "GET",
                    function(data) {
                        alert('Vous avez reçu un mail de récupération');
                    },
                    "password recuperation",
                    null,
                    data
                );  
            }
        },
        "Mot de passe oublié ?",
        ["Annuler","Recevoir"]
        );
    });
    
    this.el.on('click','.facebookLogin',function(){
        facebookConnectPlugin.login(["email"],
            function() {
                hidePopUp(MyAccountPage);
                facebookConnectPlugin.getLoginStatus(
                    function(data) {MyAccountPage.prepareData(data);}
                );
            },
            function (error) { alert("erreur " + error);}
        );
    });
    
    this.el.on('change','select[name=favoriteGps]',function(){
        var val = $(this).val();
        if (val === "none")
            window.localStorage.removeItem("favoriteGPS");
        else
            localStorage.favoriteGPS = val;
        window.plugins.toast.showShortBottom('Préférence enregistrée');
    });

};

MyAccountPage.formHandler = function (event) {
        if (event) event.preventDefault();
        MyAccountPage.el.find(".create_error").each(function() {$(this).hide();});

        var valid = true;
        if(MyAccountPage.el.find('input[name=firstName]').val()==="Prénom*"){
            MyAccountPage.el.find('.firstName').show();
            valid=false;
        }
        if(MyAccountPage.el.find('input[name=name]').val()==="Nom* (non divulgué)"){
            MyAccountPage.el.find('.name').show();
            valid=false;
        }
        if(MyAccountPage.el.find('input[name=password]').val().length<8&&MyAccountPage.el.find('input[name=password]').val().length>0){
            MyAccountPage.el.find('.pass').show();
            valid=false;
        }
        if(MyAccountPage.el.find('input[name=mail]').val().indexOf('@')===-1){
            MyAccountPage.el.find('.mail').show();
            valid=false;
        }	

        if(MyAccountPage.el.find(".selectedLabel").length===0){
            MyAccountPage.el.find('.sex').show();
            valid=false;
        }		

        if(valid) {
            if(facebook) {
                facebookConnectPlugin.getLoginStatus(
                    function(data){
                        if(data.status==="connected") {
                            MyAccountPage.prepareData(data);
                        }
                        else showPopUp(MyAccountPage);
                    }, 
                    function() {}
                );
            }
            else showPopUp(MyAccountPage);
        } else
            alert('Information incomplètes ou incorrectes');
};

MyAccountPage.prepareData = function (FBdata, type) {
        var formData = {
        'firstName'			: MyAccountPage.el.find('input[name=firstName]').val(),
        'name'			        : MyAccountPage.el.find('input[name=name]').val(),
        'sex'                           : MyAccountPage.el.find("label[for=sexF]").hasClass('selectedLabel'),
        'mail' 				: MyAccountPage.el.find('input[name=mail]').val()
        };
        var password = MyAccountPage.el.find('input[name=curPasswordKankaroo]').val();
        if (password !=="") formData.password = password;
        password = MyAccountPage.el.find('input[name=curPasswordBoth]').val();
        if (password !=="") formData.password = password;
        if (MyAccountPage.el.find('input[name=password]').val()!=="")
        {
            formData.newPassword = MyAccountPage.el.find('input[name=password]').val();
        }
        if (!!FBdata) {
            formData.FBToken = FBdata.authResponse.accessToken;
            delete formData.password;
        }
        if (!type) {
            window.plugins.toast.showShortTop('Envoi en cours...');
            MyAccountPage.sendData(formData);
        } else {
            delete formData.password;
            delete formData.FBToken;
            if (type === 'save')
                MyAccountPage.initialState = formData;
            else if (type === 'check')
                return formData;
        }
};


MyAccountPage.sendData = function(formData) {
    // process the form
    serverRequest(
        "/modifyAccountAttempt",
        "POST",
        function(data) {
            MyAccountPage.el.find('input[name="curPasswordKankaroo"]').val('');
            MyAccountPage.el.find('input[name="curPasswordBoth"]').val('');
            MyAccountPage.modifySuccess(data,formData);
        },
        "modify account",
        function() {MyAccountPage.sendData(formData);},
        formData                        
    );
};

MyAccountPage.modifySuccess = function(data,formData) {
        if(typeof data.error==="undefined"&& typeof data.status === "undefined")
        {
            MyAccountPage.el.find('input[name=password]').val('').blur();
            localStorage.mail = formData.mail;
            localStorage.loginToken = data.loginToken;
            hidePopUp(MyAccountPage);
            window.plugins.toast.showShortBottom('Modifications enregistrées');
            MyAccountPage.prepareData(null, 'save');
        } else if (data.error === "wrongCredentials" ) {
            alert("Mot de passe incorrect");
        } else if (data.error === "mailExistsAlready"){
            alert('Cette adresse mail correspond déjà à un compte Kankaroo');
        } else if (data.status){
            hidePopUp(MyAccountPage);
            window.plugins.toast.showShortBottom('Modifications enregistrées');
            MyAccountPage.prepareData(null, 'save');
        }
};

//Affiche la page
MyAccountPage.render = function () {
    MyAccountPage.el.find('input[name=password]').val('').blur();
    $(".create_error").hide();
    this.el.addClass("shown");
    showLoading();
    MyAccountPage.getMyAccount();
    if (deviceType === 'iOS') {
        if (MyAccountPage.el.find('select[name=favoriteGps] option[value="plan"]').length === 0) {
            MyAccountPage.el.find('select[name=favoriteGps]').append('<option value="plan">Plan</option>');
        }
    }
    if (!!localStorage.favoriteGPS)
        MyAccountPage.el.find('select[name=favoriteGps]').val(localStorage.favoriteGPS);
    else
        MyAccountPage.el.find('select[name=favoriteGps]').val("none");
};

MyAccountPage.getMyAccount = function () {
        //récupère les informations
        serverRequest(
            "/myAccount",
            "GET",
            function(data) {
                getMyAccountSuccess(data);
            },
            "get my account page",
            MyAccountPage.getMyAccount,
            null             
        );
};

MyAccountPage.checkForChanges = function(page) {
    var form = MyAccountPage.prepareData(null, 'check');
    if (JSON.stringify(form) !== JSON.stringify(MyAccountPage.initialState)) {
        navigator.notification.confirm(
            "Vous avez des modifications non enregistrées",
            function(index){
                if (index === 2)
                    goToPage(page, true);
                else if (index === 3) {
                    MyAccountPage.el.find('form').submit();
                }
            },
            'Kankaroo',
            'Annuler, Quitter, Enregistrer les modifications'
        );
    } else
        goToPage(page, true);
};

function getMyAccountSuccess(data){
    if(data.sex===false)
    {
        MyAccountPage.el.find("label[for='sexM']").trigger("touchstart").trigger("touchend");
    } else {
        MyAccountPage.el.find("label[for='sexF']").trigger("touchstart").trigger("touchend");
    }

    if(typeof data.firstName!== 'undefined'){
        MyAccountPage.el.find("input[name='firstName']").val(data.firstName).addClass('focus');
    }
    if(typeof data.name!== 'undefined'){
        MyAccountPage.el.find("input[name='name']").val(data.name).addClass('focus');
    }
    if(typeof data.mail!== 'undefined'){
        MyAccountPage.el.find("input[name='mail']").val(data.mail).addClass('focus');
    }
    if(data.facebook===true&&data.password===true) {
        facebook = true;
        MyAccountPage.el.find(".facebookLinked").show();
        MyAccountPage.el.find(".kankarooFacebook").show();
        MyAccountPage.el.find(".facebook").hide();
        MyAccountPage.el.find(".kankaroo").hide();
    } else if (data.facebook===true) {
        facebook = true;
        MyAccountPage.el.find(".facebookLinked").show();
        MyAccountPage.el.find(".kankarooFacebook").hide();
        MyAccountPage.el.find(".facebook").show();
        MyAccountPage.el.find(".kankaroo").hide();
    } else {
        facebook = false;
        MyAccountPage.el.find(".facebookLinked").hide();
        MyAccountPage.el.find(".kankarooFacebook").hide();
        MyAccountPage.el.find(".facebook").hide();
        MyAccountPage.el.find(".kankaroo").show();
    }
    MyAccountPage.prepareData(null, 'save');
}

MyAccountPage.reset = function() {
    var img = MyAccountPage.el.find('.selectedLabel').find('img');
    if (img.length !== 0) {
        replaceImgSrc(img.attr("src").substring(0, img.attr("src").length - 5) + "0.svg", img);
    }
    MyAccountPage.el.find('.selectedLabel').removeClass("selectedLabel");
    MyAccountPage.el.find("input[name='firstName']").val("");
    MyAccountPage.el.find("input[name='name']").val("");
    MyAccountPage.el.find("input[name='mail']").val("");
    MyAccountPage.el.find(".kankarooFacebook").hide();
    MyAccountPage.el.find(".facebook").hide();
    MyAccountPage.el.find(".kankaroo").hide();
    MyAccountPage.initialState = {};
};