/* global Create2Page, Camera */

var MyCarsPage = new Object();

MyCarsPage.el = $('#myCars');
MyCarsPage.vehicles = [];
MyCarsPage.vehiculeNum = 0;
MyCarsPage.vehiculeCount = 0;
MyCarsPage.vehicleNames = [];
MyCarsPage.vehicleNameAlert = false;
MyCarsPage.vehicleDuplicateNameAlert = false;
MyCarsPage.vehiclePictureAlert = false;
MyCarsPage.registerVehicle;
MyCarsPage.initialState = [];
MyCarsPage.tempState = [];

MyCarsPage.initialize = function() {
            this.eventHandler();
};

MyCarsPage.eventHandler = function () {
    this.el.on('click',".add",function(event) {
        if(MyCarsPage.el.find('.vehicule').length===0){
            MyCarsPage.el.find('.vehiContainer').html('');
        }
        if(MyCarsPage.vehiculeCount<5){
            MyCarsPage.vehiculeCount++;
            MyCarsPage.vehiculeNum++;
            var html = vehicule_template({num: MyCarsPage.vehiculeNum, deletable: true});
            MyCarsPage.el.find(".vehiContainer").append(html);
        } else {
            alert("Vous avez atteint le nombre max de véhicule - 5");
        }
    });

    this.el.on('click','.del',function(){
        var object = $(this).parent().parent();
        navigator.notification.confirm(
            "Supprimer ce véhicule ?", 
             function(index){
                if (index === 2) {
                    var idBox = object.find('.idVehicule');
                    if(idBox.length===0){
                        object.remove();
                        MyCarsPage.vehiculeCount--;
                        MyCarsPage.numberVehi();
                        window.plugins.toast.showShortBottom('Véhicule supprimé');
                    } else {
                        window.plugins.toast.showShortTop('Envoi en cours...');
                        var data = {idVehicle : parseInt(idBox.val())};
                        MyCarsPage.sendVehicleDelete(data, object);
                    }
                }
            },
            "Kankaroo",
            ["Annuler","Supprimer"]
        );		
    });

    this.el.on('touchstart','label',function(event){
        $(this).one('touchmove',function (event){
            $(this).off('touchend'); 
        });
        $(this).one('touchend', function (event) {
            radioImg($(this),MyCarsPage);
            if ($(this).hasClass('radioCar')) {
                $(this).parent().parent().find('select').val(3);
            }
            else if ($(this).hasClass('radioBike')) {
                $(this).parent().parent().find('select').val(1);
            }
        });
    });

    this.el.on('click','.imageLoaded ,.imageLoadedLandscape',function(event){
        event.stopPropagation();
        var object = $(this);
        navigator.notification.confirm(
            "Supprimer cette photo ?", 
             function(index){MyCarsPage.confirmDelCallback(index,object);},
            "Kankaroo",
             "Annuler,Supprimer"
        );		
    });


    var object; //contient la place de l'image à charger
    this.el.on('click','.image', function(event){
        event.stopPropagation();
        showPopUp(MyCarsPage);
        object = $(this);
    });

    this.el.on('click','.overlay',function(event){
        event.stopPropagation();
        hidePopUp(MyCarsPage);
    });

    this.el.on('click','.popUp',function(event){
        event.stopPropagation();
    });

    this.el.on('click',".popUpCamera", function(event) {
        event.stopPropagation();
        MyCarsPage.handleCamera(object.find('.camera'));
        hidePopUp(MyCarsPage);
    });

    this.el.on('click',".popUpGallery", function(event) {
        event.stopPropagation();
        MyCarsPage.handleGallery(object.find('.camera'));
        hidePopUp(MyCarsPage);
    });

    this.el.on('click',".valid",function(event) {
        event.preventDefault();
        MyCarsPage.validityChecks();
    });

};

MyCarsPage.validityChecks = function(callBack) {
    MyCarsPage.vehicleNames = [];
    MyCarsPage.vehicleNameAlert = false;
    MyCarsPage.vehicleDuplicateNameAlert = false;
    MyCarsPage.vehiclePictureAlert = false;
    MyCarsPage.el.find('.vehicule').each(MyCarsPage.checkVehicleData);
    if (MyCarsPage.vehicleNameAlert) {
        alert("Précisez le modèle du véhicule");
    } else if (MyCarsPage.vehicleDuplicateNameAlert) {
        alert("Le modèle de chaqu'un de vos véhicules doit être unique");
    } else if (MyCarsPage.vehiclePictureAlert) {
        navigator.notification.confirm(
        "Ajoutez une photo de votre véhicule !", 
        function(index){
            if (index === 1) {
                if (!!callBack)
                    callBack();
                else
                    MyCarsPage.readyToSendVehicles();
            }
        },
        "Kankaroo",
         "Plus tard,Ajouter"
        );
    }
    else {
        if (!!callBack)
            callBack();
        else
            MyCarsPage.readyToSendVehicles();
    }
};

MyCarsPage.readyToSendVehicles = function(type) {
    var requestsSynchro = {number : MyCarsPage.vehiculeCount, success : true, fromPartirPage : MyCarsPage.fromPartirPage};
    if (type === 'save')
        MyCarsPage.initialState = [];
    else if (type === 'check')
        MyCarsPage.tempState = [];
    else
        window.plugins.toast.showShortTop('Envoi en cours...');
    MyCarsPage.el.find('.vehicule').each(function(){MyCarsPage.validVehicule($(this), requestsSynchro, type);});
};

MyCarsPage.sendVehicleDelete = function(data, object) {
    serverRequest(
        "/vehicles/delete",
        "GET",
        function() {
            object.remove();
            MyCarsPage.vehiculeCount--;
            MyCarsPage.numberVehi();
            window.plugins.toast.showShortBottom('Véhicule supprimé');
            MyCarsPage.removeVehicleFromInitialState(data.idVehicle);
        },
        "send Vehicle Delete",
        function() {MyCarsPage.sendVehicleDelete(data, object);},
        data             
    );
};

MyCarsPage.handleGallery = function(object) {
    event.stopPropagation();
    navigator.camera.getPicture( 
        function (data) {
            Create2Page.cameraSuccess(data,object.parent());
            if(object.parent().hasClass('car'))
                object.parent().parent().append("<span class='vehicleModified'></span>");
            else object.parent().parent().append("<span class='insuranceModified'></span>");
        }, 
        Create2Page.cameraError, 
        { 	
                quality : 50, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.PHOTOLIBRARY, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 300,
                targetHeight: 300,
                correctOrientation:1,
                saveToPhotoAlbum: false 
        }
    );
};

MyCarsPage.handleCamera = function(object) {
    event.stopPropagation();
    navigator.camera.getPicture( 
        function (data) {
            Create2Page.cameraSuccess(data,object.parent());
            if(object.parent().hasClass('car'))
                object.parent().parent().append("<span class='vehicleModified'></span>");
            else object.parent().parent().append("<span class='insuranceModified'></span>");
        }, 
        Create2Page.cameraError, 
        { 	
                quality : 50, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.CAMERA, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 300,
                targetHeight: 300,
                correctOrientation:1,
                saveToPhotoAlbum: false 
        }
    );
};

MyCarsPage.checkVehicleData = function() {
    var object = $(this);
    var vehicleName = object.find('.name').val();
    if(vehicleName==="Modèle du véhicule"){
        MyCarsPage.vehicleNameAlert = true;
        return false;
    }
    else if (MyCarsPage.vehicleNames.indexOf(vehicleName) >= 0) {
        MyCarsPage.vehicleDuplicateNameAlert = true;
        return false;
    }
    else MyCarsPage.vehicleNames.push(vehicleName);
    if(object.find('.car').find(".camera").length>0){
        MyCarsPage.vehiclePictureAlert = true;
    }
};

MyCarsPage.validVehicule = function(object, requestsSynchro, type){
    var formData = {
        'name'			: object.find('.name').val(),
        'smoking'                   : object.find("label[for='"+object.find('input[value="true"]').attr('id')+"']").hasClass('selectedLabel'),
        'seats'			: parseInt(object.find('select').val())
        };
    if (object.find('.radioBike').hasClass('selectedLabel')){
        formData.type = "moto";
    } else {
        formData.type = "car";
    }

    if(object.find('.idVehicule').length===0) {
        if(object.find('.car').find("img").length===1){
            formData.vehiclePicture = object.find('.car').find('img').attr('src').substring(23,object.find('.car').find('img').attr('src').length);
        }
        if(object.find('.insurance').find("img").length===1){
            formData.insurancePicture = object.find('.insurance').find('img').attr('src').substring(23,object.find('.insurance').find('img').attr('src').length);
        }
        if (!type)
            MyCarsPage.sendNewVehicle(formData, object, requestsSynchro);
        else if (type === 'save')
            MyCarsPage.initialState.push(formData);
        else if (type === 'check')
            MyCarsPage.tempState.push(formData);
    } else {
        formData.idVehicle = parseInt(object.find('.idVehicule').val());
        if (object.find('.vehicleModified').length !== 0)
        {
            if(object.find('.car').find("img").length===1){
                formData.vehiclePicture = object.find('.car').find('img').attr('src').substring(23,object.find('.car').find('img').attr('src').length);
            } else {
                formData.vehiclePicture = "";
            }
        }
        if (object.find('.insuranceModified').length !== 0)
        {
            if(object.find('.insurance').find("img").length===1){
                formData.insurancePicture = object.find('.insurance').find('img').attr('src').substring(23,object.find('.insurance').find('img').attr('src').length);
            } else {
                formData.insurancePicture = "";
            }
        }
        formData = MyCarsPage.checkModif(formData);
        if (!type)
            MyCarsPage.sendOldVehicle(formData, object, requestsSynchro);
        else if (type === 'save')
            MyCarsPage.initialState.push(formData);
        else if (type === 'check')
            MyCarsPage.tempState.push(formData);
    }
};

MyCarsPage.sendNewVehicle = function(formData, object, requestsSynchro) {
    serverRequest(
        "/vehicles/create",
        "POST",
        function(data) {
            object.append('<input type="text" class="idVehicule" name="idVehicule" style="display:none" value="'+data.idVehicle+'">');
        },
        "create or modify vehicle MyCarsPage",
        function() {MyCarsPage.sendNewVehicle(formData, object, requestsSynchro);},
        formData,
        null,
        null,
        null,
        requestsSynchro
    );
};

MyCarsPage.sendOldVehicle = function(formData, object, requestsSynchro) {
    serverRequest(
        "/vehicles/modify",
        "POST",
        function(data) {},
        "create or modify vehicle MyCarsPage",
        function() {MyCarsPage.sendOldVehicle(formData, object, requestsSynchro);},
        formData,
        null,
        null,
        null,
        requestsSynchro
    );
};

MyCarsPage.checkModif = function (data) {
    var result = $.grep(MyCarsPage.vehicles, function(e){ return e.idvehicle === data.idVehicle; });
    var object = result[0];
    if(object){
        if(data.name === object.name){
            delete data.name;
        }
        if(data.type === object.type){
            delete data.type;
        }
        if(data.seats === object.freeSeats){
            delete data.seats;
        }
        if(data.smoking === object.smoking){
            delete data.smoking;
        }
    }
    return data;

};

MyCarsPage.confirmDelCallback = function(index,object){
        if(index===2){
            if(object.parent().hasClass("car")){
                object.parent().parent().append("<span class='vehicleModified'></span>");
                object.parent().html("<img class='camera' src='img/add_photo.svg'><div style='margin-left: 3%; margin-right: 3%'>Photo du véhicule</div>");
            } else {
                object.parent().parent().append("<span class='insuranceModified'></span>");
                object.parent().html("<img class='camera' src='img/add_photo.svg'><div style='margin-left: 3%; margin-right: 3%'>Vignette d’assurance</div>");
            }
        }
};

//Affiche la page
MyCarsPage.render = function () {
    MyCarsPage.reset();
    this.el.addClass("shown");
    MyCarsPage.el.find('.addPadding').css("height", MyCarsPage.el.find('.add').outerHeight());
    showLoading();
    MyCarsPage.getMyCars(MyCarsPage.registerVehicle);
    delete MyCarsPage.registerVehicle;
};

MyCarsPage.getMyCars = function (registerV) {
    //récupère les informations
    serverRequest(
        "/vehicles/list",
        "GET",
        function(data) {
            MyCarsPage.getMyCarsSuccess(data, registerV);
        },
        "get my cars list",
        function() {MyCarsPage.getMyCars(registerV);},
        null             
    );        
};

MyCarsPage.getMyCarsSuccess = function (data, registerV) {
    var list = JSON.parse(data.vehicles);
    MyCarsPage.vehicles = list;
    MyCarsPage.el.find('.vehicule').each(function(){
        var object = $(this);
        if (object.find('.idVehicule').length === 0){
            object.remove();
        }
    });
    if(list.length>0){
        MyCarsPage.vehiculeCount = list.length;
        var requestsSynchro = {number : 2*MyCarsPage.vehiculeCount, success : true};
        for(var i=0;i<list.length;i++){
            if (MyCarsPage.el.find("input[value='"+list[i].idvehicle+"']").length === 0){
                MyCarsPage.vehiculeNum++;
                var templateObject = new Object();
                templateObject.num = MyCarsPage.vehiculeNum;
                var idObject = { id : list[i].idvehicle };
                templateObject.idVehicule = idObject;
                templateObject.deletable = true;
                var object = $(vehicule_template(templateObject));
                MyCarsPage.el.find(".vehiContainer").append(object);
            } else {
                var object = MyCarsPage.el.find("input[value='"+list[i].idvehicle+"']").parent('.vehicule');
            }

            if (list[i].type==="moto"){
                object.find(".radioBike").trigger("touchstart").trigger("touchend");
            } else {
                object.find(".radioCar").trigger("touchstart").trigger("touchend");
            }
            if (list[i].smoking){
                object.find(".radioSmoke").trigger("touchstart").trigger("touchend");
            } else {
                object.find(".radioNSmoke").trigger("touchstart").trigger("touchend");
            }
            object.find('select').val(list[i].freeSeats);
            object.find('.name').val(list[i].name).addClass("focus");
            MyCarsPage.addImg(object,list[i].idvehicle, requestsSynchro);
        }
        MyCarsPage.readyToSendVehicles('save');
    } else  {
        endLoading();
        MyCarsPage.readyToSendVehicles('save');
        if (!!registerV) {
            MyCarsPage.el.find('.add').click();
        }
        MyCarsPage.numberVehi();
    }
};

MyCarsPage.numberVehi = function() {
    if(this.el.find('.vehicule').length===0){
        this.el.find('.vehiContainer').html('<div class="whiteBg"><span style=\"padding-left: 2%; padding-right: 2%; display: block; text-align: center;\">Vous n’avez aucun véhicule d’enregistré</span></div>');
    }
};

MyCarsPage.addImg = function(object,idvehicle, requestsSynchro){
    //récupère les informations
    var data =new Object();
    data.idVehicle = idvehicle;
    serverRequest(
        "/vehicles/vehiclePicture",
        "GET",
        function(data) {
            if(typeof data.noPicture !== "undefined"){
            } else {
                Create2Page.cameraSuccess(data.picture,object.find('.car'));
            }
        },
        "get vehicleImg",
        null,
        data,
        null,
        null,
        null,
        requestsSynchro
    );

    serverRequest(
        "/vehicles/insurancePicture",
        "GET",
        function(data) {
            if(typeof data.noPicture !== "undefined"){
            } else {
                Create2Page.cameraSuccess(data.picture,object.find('.insurance'));
            }
        },
        "get insuranceImg",
        null,
        data,
        null,
        null,
        null,
        requestsSynchro
    );
};

MyCarsPage.reset = function (){
    this.el.find('.vehiContainer').html('');
    MyCarsPage.vehiculeNum = 0;
    MyCarsPage.vehiculeCount = 0;
    MyCarsPage.initialState = [];
    MyCarsPage.tempState = [];
};

MyCarsPage.checkForChanges = function(page) {
    MyCarsPage.readyToSendVehicles('check');
    if (JSON.stringify(MyCarsPage.tempState) !== JSON.stringify(MyCarsPage.initialState)) {
        navigator.notification.confirm(
            "Vous avez des modifications non enregistrées",
            function(index){
                if (index === 2)
                    goToPage(page, true);
                else if (index === 3) {
                    MyCarsPage.fromPartirPage = false;
                    MyCarsPage.validityChecks(function() {
                        window.plugins.toast.showShortTop('Envoi en cours...');
                        MyCarsPage.readyToSendVehicles();
                        goToPage(page, true);
                    });
                }
            },
            'Kankaroo',
            'Annuler, Quitter, Enregistrer les modifications'
        );
    } else
        goToPage(page, true);
};

MyCarsPage.removeVehicleFromInitialState = function(id) {
    for (var i = 0; i < MyCarsPage.initialState.length; i++) {
        if (MyCarsPage.initialState[i].idVehicle === id)
            MyCarsPage.initialState.splice(i, 1);
    }
};