/* global Create3FirmPage, Create2Page, Camera, Create3Page */

var MyProfilePage = new Object();

MyProfilePage.el = $('#myProfile');
MyProfilePage.load = true;
MyProfilePage.initialState;

//Fonction d'initialisation, affecte les evenements.
MyProfilePage.initialize = function() {
    this.eventHandler();
};

MyProfilePage.eventHandler = function () {

    this.el.on('click',".valid",function(event) {
        event.preventDefault();
        window.plugins.toast.showShortTop('Envoi en cours...');
        MyProfilePage.prepareData();
    });

    this.el.on('touchstart','label',function(event){
        $(this).one('touchmove',function (event){
                $(this).off('touchend'); 
        });
        $(this).one('touchend', function (event) {
            radioImg($(this),MyProfilePage);
        });
    });

    this.el.on('click','.imageLoaded, .imageLoadedLandscape',function(event){
        event.stopPropagation();
        var object = $(this);
        navigator.notification.confirm("Supprimer cette photo ?", function(index){MyProfilePage.confirmDelCallback(index,object);}, "Kankaroo", "Annuler,Supprimer");		
    });


    var object; //contient la place de l'image à charger
    this.el.on('click','.image', function(event){
        event.stopPropagation();
        showPopUp(MyProfilePage);
        object = $(this);
    });

    this.el.on('click','.overlay',function(event){
        event.stopPropagation();
        hidePopUp(MyProfilePage);
    });

    this.el.on('click','.popUp',function(event){
        event.stopPropagation();
    });

    this.el.on('click',".popUpCamera", function(event) {
        event.stopPropagation();
        MyProfilePage.handleCamera(object.find('.camera'));
        hidePopUp(MyProfilePage);
    });

    this.el.on('click',".popUpGallery", function(event) {
        event.stopPropagation();
        MyProfilePage.handleGallery(object.find('.camera'));
        hidePopUp(MyProfilePage);
    });

    this.el.on('click','#firm',function(event){
        MyProfilePage.load = false;
        Create3FirmPage.return ="#myProfile";
        Create3FirmPage.returnObject = MyProfilePage;
        goToPage("#create3firm", true);
    });
};

MyProfilePage.handleCamera = function(object) {
    event.stopPropagation();
    navigator.camera.getPicture( 
        function (data) {
            object.parent().parent().append("<span class='meModified'></span>");
            Create2Page.cameraSuccess(data,object.parent());
        }, 
        Create2Page.cameraError, 
        { 	
                quality : 50, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.CAMERA, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 600,
                targetHeight: 600,
                correctOrientation:1,
                saveToPhotoAlbum: false 
        }
    );
};

MyProfilePage.handleGallery = function(object) {
    event.stopPropagation();
    navigator.camera.getPicture( 
        function (data) {
            object.parent().parent().append("<span class='meModified'></span>");
            Create2Page.cameraSuccess(data,object.parent());
        }, 
        Create2Page.cameraError, 
        { 	
                quality : 50, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.PHOTOLIBRARY, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 600,
                targetHeight: 600,
                correctOrientation:1,
                saveToPhotoAlbum: false 
        }
    );
};

MyProfilePage.prepareData = function(type){
    var formData = {
      "comment"     : MyProfilePage.el.find('textarea').val(),
      "preferences" : MyProfilePage.el.find('input[name="music"]').val(),
      "workplace"   : MyProfilePage.el.find('#firm').html(),
      "transport"   : MyProfilePage.el.find("input[id='"+MyProfilePage.el.find('.selectedLabel').attr('for')+"']").val()
    };
    if (formData.comment === MyProfilePage.el.find('textarea[name="comment"]').attr('placeholder')){
        formData.comment = "";
    }
    if (formData.workplace.substring(0,1) === "<"){
        formData.workplace = "";
    } else {
        formData.workplace = restoreXml(formData.workplace);
    }
    if (formData.preferences === MyProfilePage.el.find('input[name="music"]').attr('placeholder'))
    {
        formData.preferences = "";
    }
    if (MyProfilePage.el.find('.meModified').length !== 0){
        formData.picture = MyProfilePage.el.find('.me').find('img').attr('src').substring(23,MyProfilePage.el.find('.me').find('img').attr('src').length);
    }
    if (!type)
        MyProfilePage.sendData(formData);
    else if (type === 'save')
        MyProfilePage.initialState = formData;
    else if (type === 'check')
        return formData;
};

MyProfilePage.sendData = function(formData) {
    serverRequest(
        "/profile/modify",
        "POST",
        function(data){
            window.plugins.toast.showShortBottom('Modifications Enregistrées');
            MyProfilePage.prepareData('save');
        },
        "modify profil myProfile",
        function() {MyProfilePage.sendData(formData);},
        formData
    );
};

MyProfilePage.confirmDelCallback= function(index,object){
    if(index===2){
        if(object.parent().hasClass("me")){
            object.parent().parent().append("<span class='meModified'></span>");
            object.parent().html("<br><img class='camera' src='img/add_photo.svg'><div style='margin-left: 3%; margin-right: 3%'>Photo de moi</div>");
        }
    }  
};

//Affiche la page
MyProfilePage.render = function () {
    this.el.addClass("shown");
    if(MyProfilePage.load){
        showLoading();
        var requestsSynchro = {number : 2, success : true};
        MyProfilePage.getImg(requestsSynchro);
        MyProfilePage.getProfile(requestsSynchro);
    } else {
        MyProfilePage.load=true;
    }
    var width = MyProfilePage.el.find('.image').width();
    MyProfilePage.el.find('.image').css('height',width);
    MyProfilePage.el.find('textarea').css('height',width - 10);
};

MyProfilePage.getProfile = function (requestsSynchro){
    serverRequest(
        "/profile/display",
        "GET",
        MyProfilePage.gotProfile,
        "profil myProfile",
        function() {MyProfilePage.getProfile(requestsSynchro);},
        null,
        null,
        null,
        null,
        requestsSynchro
    );
};

MyProfilePage.gotProfile = function(data){
    if(typeof data.name !== "undefined"){
        MyProfilePage.el.find(".name").html(escapeXml(data.name));
    }
    if(typeof data.comment !== "undefined"){
        MyProfilePage.el.find("textarea").val(data.comment).addClass("focus");
    }
    if(typeof data.preferences !== "undefined"){
        MyProfilePage.el.find("input[name='music']").val(data.preferences).addClass("focus");
    }
    if(typeof data.workplace !== "undefined"){
        MyProfilePage.el.find("#firm").html(escapeXml(data.workplace));
    } else
        MyProfilePage.el.find('#firm').html('<span style="color: rgb(140,140,140)">Entreprise ou campus</span>');
    if(typeof data.averageRatings !== "undefined"){
        MyProfilePage.handleStar(data.averageRatings,MyProfilePage.el.find('.noteBar .rating'));
    }
    if(typeof data.ratings !== "undefined"){
        MyProfilePage.handleComments(data.ratings, MyProfilePage, data.numberOfRatings);
    }
    if(typeof data.transport !=="undefined"){
        MyProfilePage.el.find("label[for='"+MyProfilePage.el.find("input[value='"+data.transport.toLowerCase()+"']").attr('id')+"']").trigger("touchstart").trigger("touchend");
    }
    MyProfilePage.prepareData('save');
};

MyProfilePage.handleStar = function(note,object){
    object.html('');
    var nbStar=0;
    var nt=note;
    if(note === 0) {
        object.html("<span class='italic' style='color:white'>Aucune note<span>");
        return;
    }

    while(nt>=1){
        object.append("<img src='img/rattingStar0.svg' alt=''>");
        nt--;
        nbStar++;
    }
    if(nbStar<5){
        if(nt>(4.0/5.0)){
            object.append("<img src='img/rattingStar0.svg' alt=''>");
        } else if (nt>(3.0/5.0)){
            object.append("<img src='img/rattingStar4.svg' alt=''>");
        } else if (nt>(2.0/5.0)){
            object.append("<img src='img/rattingStar3.svg' alt=''>");
        } else if (nt>(1.0/5.0)){
            object.append("<img src='img/rattingStar2.svg' alt=''>");
        } else if (nt> 0){
            object.append("<img src='img/rattingStar1.svg' alt=''>");
        } else {
            object.append("<img src='img/emptyStar.svg' alt=''>");
        }
        nbStar++;
        while(nbStar<5){
            object.append("<img src='img/emptyStar.svg' alt=''>");
            nbStar++;
        }
    }
};

MyProfilePage.handleComments = function (comments,page, nbrGrade) {
    comments.sort(function(a,b) {
        var Atime = new Date(a.date);
        var Btime = new Date(b.date);
        return ((Atime.getTime() < Btime.getTime())?1:-1); 
    });
    page.el.find('.comments').html('');
    var length = comments.length;
    if(length === 0) {
        page.el.find('.comments').html("<div class='comment' style='text-align: center'>Aucun commentaire</div>");
    }
    for (var i = 0;i<length;i++) {
        MyProfilePage.addComment(comments[i],page);
    }
    page.el.find('.gradeNbr').html('('+nbrGrade+' notes)');
};

MyProfilePage.addComment = function (comment,page){
    var date = new Date(comment.date+" GMT");
    var year = date.getFullYear();
    var month = date.getMonth()+1;
    var day = date.getDate();
    if(day<10) day = "0"+day;
    if(month<10) month = "0"+month;
    year = year.toString().substring(2,4);
    var dateString = "Le "+day+"/"+month+"/"+year;
    var html = $('<div class="comment"><div class="titleComment"><span class="bold">'+
            escapeXml(comment.rater)+' </span><span class="rating"></span><span class="date"> '+
            dateString+'</span></div><div class="msg">'+escapeXml(decodeURIComponent(comment.comment))+'</div></div>');
    page.el.find('.comments').append(html);
    MyProfilePage.handleStar(comment.grade,html.find('.rating'));
};

MyProfilePage.getImg = function(requestsSynchro){
    serverRequest(
        "/profile/picture",
        "GET",
        MyProfilePage.gotImg,
        "image profil myProfile",
        function() {MyProfilePage.getImg(requestsSynchro);},
        null,
        null,
        null,
        null,
        requestsSynchro
    );
};

MyProfilePage.gotImg = function (data) {
    if (typeof data.noPicture !== "undefined"){
        //pas de photo de profil
    } else if (typeof data.picture !== "undefined"){
        Create2Page.cameraSuccess(data.picture,MyProfilePage.el.find('.image'));
    } else if (typeof data.url !== "undefined") {
        Create3Page.loadImgFromUrl(data.url,MyProfilePage.el.find('.image'));
    }
};

MyProfilePage.checkForChanges = function(page) {
    var form = MyProfilePage.prepareData('check');
    if (JSON.stringify(form) !== JSON.stringify(MyProfilePage.initialState)) {
        navigator.notification.confirm(
            "Vous avez des modifications non enregistrées",
            function(index){
                if (index === 2)
                    goToPage(page, true);
                else if (index === 3) {
                    window.plugins.toast.showShortTop('Envoi en cours...');
                    MyProfilePage.prepareData();
                    goToPage(page, true);
                }
            },
            'Kankaroo',
            'Annuler, Quitter, Enregistrer les modifications'
        );
    } else
        goToPage(page, true);
};

MyProfilePage.reset = function (){
    MyProfilePage.el.find('.comments').html('');
    MyProfilePage.el.find('.noteBar .rating').html('');
    MyProfilePage.el.find('.nameOverlay').html('');
    MyProfilePage.el.find("textarea").val('');
    MyProfilePage.el.find("input[name='music']").val('');
    MyProfilePage.el.find('#firm').html('<span style="color: rgb(140,140,140)">Entreprise ou campus</span>');
    MyProfilePage.el.find('.me').html("<img class='camera' src='img/add_photo.svg'><div style='margin-left: 3%; margin-right: 3%'>Photo de moi</div>");
    MyProfilePage.el.find("label[for='"+MyProfilePage.el.find("input[value='car']").attr('id')+"']").trigger("touchstart").trigger("touchend");
    MyProfilePage.initialState = {};
};