/* global MyProfilePage, MapPage, Partir4Page, Menu, MessagePage, ImageHandler, Create3Page, Create2Page, ContactsPage, ProfilePage, Map2Page, GradePage, Map3Page, JourneyPage, AccountPage */

var Notification = new Object();
Notification.el = $("#notif");
Notification.popUp = $("#notifPopUp");
Notification.justClicked;
Notification.handledAleready = [];
Notification.popUpOpen = 'none';

Notification.initialize = function (){
    this.eventHandler();
};

Notification.eventHandler = function () {
    this.el.on('touchstart', '#driverNotifContainer, #passengerNotifContainer', function (event) {
        var object = $(this);
        $(this).one('touchmove',function (event){
           object.off('touchend'); 
        });
        $(this).one('touchend', function (event) {
            if (object.attr('id') === 'driverNotifContainer') {
                Notification.popUp.find(".driver").show();
                Notification.popUp.find(".passenger").hide();
            } else {
                Notification.popUp.find(".driver").hide();
                Notification.popUp.find(".passenger").show();
            }
            Notification.handlePopUp('agreement');
        });
    });

    this.el.on('touchstart', '#notificationNotifContainer', function (event) {
        var object = $(this);
        $(this).one('touchmove',function (event){
           object.off('touchend'); 
        });
        $(this).one('touchend', function (event) {
            if (Notification.popUp.find('#notificationPopUp .content').html() === '')
                Notification.popUp.find('.noNotifMessage').show();
            else
                Notification.popUp.find('.noNotifMessage').hide();
            Notification.handlePopUp('notification');
            Notification.oldNewNotif($("#notificationNotif"),'old');
        });
    });

    $('#notif-overlay').on('click', function (event) {
        event.stopPropagation();
        Notification.closePopUp();
    });

    this.popUp.on('click','.agreement',function(){
        var matchId = parseInt($(this).find('.matchId').html());
        var agreementId = parseInt($(this).find('.agreementId').html());
        MapPage.matchNum = MapPage.matchList.map(function(e){return e.match.idmatches;}).indexOf(matchId);
        MapPage.agreementNum = MapPage.matchList[MapPage.matchNum].agreements.map(function(e) { return e.idagreements; }).indexOf(agreementId);
        MapPage.switchMatch(true);
        Notification.closePopUp();
    });
    
    this.popUp.on('click','.messageTag',function(event){
        event.stopPropagation();
        var object = $(this).parent().parent();
        var matchId = parseInt(object.find('.matchId').html());
        var agreementId = parseInt(object.find('.agreementId').html());
        MapPage.matchNum = MapPage.matchList.map(function(e){return e.match.idmatches;}).indexOf(matchId);
        MapPage.agreementNum = MapPage.matchList[MapPage.matchNum].agreements.map(function(e) { return e.idagreements; }).indexOf(agreementId);
        MapPage.switchMatch(true, true);
        Notification.closePopUp();
    });
    
    this.popUp.on('click','.potentialTag',function(){
        var matchId = parseInt($(this).find('.matchId').html());
        MapPage.matchNum = MapPage.matchList.map(function(e){return e.match.idmatches;}).indexOf(matchId);
        MapPage.switchMatch();
        Notification.closePopUp();
    });

    this.popUp.on('click', '.notification',function(){
        //handle click on notification
        Notification.closePopUp();
        var content = JSON.parse($(this).find('.notificationContent').html());
        Notification.notifAction(content);
        $(this).remove();
        Notification.adjustTopBannerNotifBadge();
    });
    
    this.popUp.on('click', '.lockedNewJourneyRefresh',function(){
        MapPage.el.find('.back-menu').click();
    });
    
};

Notification.handleNotification = function (event) {
    //For the whole notification bar
    var showNotifs = Menu.notificationsAreVisible();
    if(showNotifs){
        Notification.el.find("#notificationNotifContainer").show();
        Notification.el.show();
    } else {
        Notification.el.find("#notificationNotifContainer").hide();
        Notification.el.hide();
    }

    //For the driver/passenger notif
    var hash = window.location.hash;
    if (hash ==="#map" & !MessagePage.el.is(":visible") & !ProfilePage.el.is(":visible") & !Map2Page.el.is(":visible") & !Map3Page.el.is(":visible") & !GradePage.el.is(":visible") & !JourneyPage.el.is(":visible")) {
        if (Partir4Page.userType === "driver"){
            Notification.el.find("#passengerNotifContainer").show();
        } else {
            Notification.el.find("#driverNotifContainer").show();
        }
    } else {
        Notification.el.find("#passengerNotifContainer").hide();
        Notification.el.find("#driverNotifContainer").hide();
    }
};

Notification.handlePopUp = function(type){
    if(Notification.popUpOpen === type){
        Notification.closePopUp();
    } else {
        Notification.popUpOpen = type;
        $('#notif-overlay').show();
        Notification.popUp.find("#notificationPopUp, #agreementPopUp").hide();
        Notification.el.find('#notificationSelect, #driverSelect, #passengerSelect').hide();
        Notification.selectNotif($('#notificationNotif'), false, 'notification');
        Notification.selectNotif($('#driverNotif'), false, 'agreement');
        Notification.selectNotif($('#passengerNotif'), false, 'agrement');
        if (type === 'agreement') {
            Notification.selectNotif($('#driverNotif'), true, type);
            Notification.selectNotif($('#passengerNotif'), true, type);
            Notification.el.find("#driverSelect, #passengerSelect").show();
        } else {
            Notification.selectNotif($('#notificationNotif'), true, type);
            Notification.el.find("#"+type+"Select").show();
        }
        Notification.popUp.find("#"+type+"PopUp").show();
        Notification.popUp.show();
    }
};

Notification.closePopUp = function() {
    Notification.popUpOpen = 'none';
    Notification.popUp.hide();
    $('#notif-overlay').hide();
    Notification.el.find('#notificationSelect, #driverSelect, #passengerSelect').hide();
    Notification.selectNotif($('#notificationNotif'), false, 'notification');
    Notification.selectNotif($('#driverNotif'), false, 'agreement');
    Notification.selectNotif($('#passengerNotif'), false, 'agrement');
};

Notification.moreNotif = function(img){
    var src = img.attr('src');
    var num = parseInt(src.substring(src.length-5,src.length-4));
    if (num<4){
        Notification.changeNumNotif(img,num+1);
    }
};

Notification.lessNotif = function(img){
    var src = img.attr('src');
    var num = parseInt(src.substring(src.length-5,src.length-4));
    if (num>0){
        Notification.changeNumNotif(img,num-1);
    }
};

Notification.changeNumNotif = function(img,num){
    if (num > 4) num = 4;
    if (num < 0) num = 0;
    var src = img.attr('src');
    src = src.substring(0,src.length-5)+ num + src.substring(src.length-4,src.length);
    replaceImgSrc(src, img);
};

Notification.oldNewNotif = function(img,state){
    var src = img.attr('src');
    if (src.indexOf('_selected') >= 0 & state === 'new')
        return;
    src = src.substring(0,src.length-9)+ state + src.substring(src.length-6,src.length);
    replaceImgSrc(src, img);
};

Notification.selectNotif = function(img,wantSelected,type){
    var src = img.attr('src');
    var isSelected = src.indexOf('_selected') >= 0;
    if (isSelected & wantSelected)
        return;
    else if (isSelected) {
        if (type === 'notification')
            src = src.substring(0,src.length-18) + src.substring(src.length-9,src.length);
        else
            src = src.substring(0,src.length-14) + src.substring(src.length-5,src.length);
    } else if (wantSelected) {
        if (type === 'notification')
            src = src.substring(0,src.length-10)+ '_selected' + src.substring(src.length-10,src.length);
        else
            src = src.substring(0,src.length-6)+ '_selected' + src.substring(src.length-6,src.length);
    } else
        return;
    replaceImgSrc(src, img);
};

Notification.addAgreement = function(agreementId,journeyId,matchId,name,userRating, sex, tag){
    var object ={
        'name':name,
        'matchId':matchId,
        'agreementId':agreementId
    };
    if (tag === "RDVTag")
        object.RDVTag = true;
    else if (tag === "activeTag")
        object.activeTag = true;
    else if (tag === "passiveTag")
        object.passiveTag = true;
    var agreement = $(agreement_template(object));
    Notification.popUp.find('#agreementPopUp .agreementsContent').append(agreement);
    if (Partir4Page.userType === 'driver')
        Notification.moreNotif(Notification.el.find("#passengerNotif"));
    else
        Notification.moreNotif(Notification.el.find("#driverNotif"));
    agreement.find('.image').css('height',Notification.popUp.width()*0.49);
    MyProfilePage.handleStar(userRating,agreement.find(".rating"));
    Notification.fillImage(agreement,matchId,journeyId, sex);
};

Notification.addNoAgreement = function(matchId,name) {
    var object ={
        'name':name,
        'matchId':matchId
    };
    var noAgreement = $(no_agreement_template(object));
    Notification.popUp.find('#agreementPopUp .noAgreementsContent').append(noAgreement);
    if (Partir4Page.userType === 'driver')
        Notification.moreNotif(Notification.el.find("#passengerNotif"));
    else
        Notification.moreNotif(Notification.el.find("#driverNotif"));
};

Notification.removeAgreement = function(agreementId) {
    Notification.popUp.find('.agreement').each(function() {
        if ($(this).find('.agreementId').html() === agreementId.toString()) {
            $(this).remove();
            Notification.lessNotif(Notification.el.find("#driverNotif:visible, #passengerNotif:visible"));
        }
    });
};

Notification.fillImage = function (agreement,matchId,journeyId, sex) {
    var type;
    if (sex) type = 'female';
    else type = 'male';
    if (typeof sex !== 'undefined') agreement.find('.image img').attr('src', 'img/replace_image_'+type+'.svg');
    if (ImageHandler.isLoaded(matchId,"profile")){
        if (ImageHandler.isData(matchId)){
            Create2Page.cameraSuccess(ImageHandler.getImage(matchId,"profile"),agreement.find('.image'));
        } else  {
            Create3Page.loadImgFromUrl(ImageHandler.getImage(matchId,"profile"),agreement.find('.image'));
        }
    } else {
        if (!ImageHandler.noImg(matchId,"profile")){
            serverRequest(
                "/travel/pic",
                "GET",
                function(data){
                    ProfilePage.storeImg(data,matchId,"profile");
                    Notification.fillImage(agreement,matchId,journeyId, sex);
                },
                "image MapPage",
                function() {Notification.fillImage(agreement,matchId,journeyId, sex);},
                {
                    'myJourneyId':journeyId,
                    'matchId':matchId
                }                        
            );
            return;
        }
    }
};

Notification.addAgreements = function (journeyId) {
    if (Partir4Page.userType === 'driver')
        Notification.changeNumNotif(Notification.el.find("#passengerNotif"),0);
    else
        Notification.changeNumNotif(Notification.el.find("#driverNotif"),0);
    Notification.popUp.find('#agreementPopUp .agreementsContent').html('');
    Notification.popUp.find('#agreementPopUp .noAgreementsContent').html('');
    Notification.sortAgreements();
    for (var i=0;i<MapPage.matchAgreementsPairsList.length;i++){
        var pair = MapPage.matchAgreementsPairsList[i];
        var match = MapPage.matchList[pair.matchNum];
        var agreement = match.agreements[pair.agreementNum];
        Notification.addAgreement(agreement.idagreements,journeyId,match.match.idmatches,match.profile.name,match.profile.averageRatings, match.profile.sex, agreement.tag);
    }
    for (var i=0;i<MapPage.matchNoAgreementsNumsList.length;i++){
        var match = MapPage.matchList[MapPage.matchNoAgreementsNumsList[i]];
        Notification.addNoAgreement(match.match.idmatches,match.profile.name);
    }
    if (Notification.popUp.find('.agreement').length === 0)
        Notification.popUp.find('.agreementsTitle').hide();
    else
        Notification.popUp.find('.agreementsTitle').show();
    if (Notification.popUp.find('.potentialTag').length === 0) {
        Notification.popUp.find('.noAgreementsTitle').hide();
        Notification.popUp.find('.noAgreementsContent').hide();
    } else {
        Notification.popUp.find('.noAgreementsTitle').show();
        Notification.popUp.find('.noAgreementsContent').show();
    }
};

Notification.addNotification = function(message, title, content) {
    if (content.type === 'ignore') return;
    var fill = {
        message: message,
        title: title,
        firstName: content.firstName,
        content: JSON.stringify(content)
    };
    var html = notification_template(fill);
    Notification.popUp.find('#notificationPopUp .content').append(html);
    Notification.moreNotif($('#notificationNotif'));
    Notification.oldNewNotif($('#notificationNotif'), 'new');
};

Notification.fetchNotifications = function() {
    serverRequest(
        "/getNotifications",
        "GET",
        function(data){
            Notification.gotNotifications(data);
        },
        "get Notifications",
        Notification.fetchNotifications,
        null
    );
};

Notification.gotNotifications = function(data) {
    var notifications = JSON.parse(data.notifications);
    Notification.popUp.find('#notificationPopUp .content').html('');
    Notification.changeNumNotif($('#notificationNotif'),0);
    Notification.oldNewNotif($('#notificationNotif'), 'old');
    if (!Notification.justClicked & !Notification.appleJustClicked) {
        var index = -1;
        var noSplice = false;
        for (var i=0; i < notifications.length; i++) {
            var notification = notifications[i];
            if (Notification.handledAleready.indexOf(notification.idnotifications) < 0) {
                var result = Notification.checkIfDestEqualsThis(JSON.parse(notification.json), notification.message, !Notification.appleOnForeground);
                if (result === "break"){
                    Notification.handledAleready.push(notification.idnotifications);
                    index = i;
                    noSplice = true;
                    break;
                } else if (result) {
                    Notification.sendNotificationHandled(notification.idnotifications);
                    index = i;
                    break;
                }
                Notification.handledAleready.push(notification.idnotifications);
            }
        }
        if (index !== -1) {
            for (var i=index; i < notifications.length; i++) {
                var notification = notifications[i];
                Notification.handledAleready.push(notification.idnotifications);
            }
            if (!noSplice)
                notifications.splice(index, 1);
        }
    }
    for (var i=0; i < notifications.length; i++) {
        var notification = notifications[i];
        if (!!Notification.justClicked) {
            if (Notification.justClicked.notificationId.toString() === notification.idnotifications.toString()) {
                // Do nothing
            } else {
                var content = JSON.parse(notification.json);
                content.notificationId = notification.idnotifications;
                Notification.addNotification(notification.message, notification.title, content);
            }
        } else if (!!Notification.appleJustClicked) {
            if (Notification.appleJustClicked.notificationId.toString() === notification.idnotifications.toString()) {
                Notification.appleJustClicked = JSON.parse(notification.json);
                Notification.appleJustClicked.notificationId = notification.idnotifications;
                Notification.notifAction(Notification.appleJustClicked);
            } else {
                var content = JSON.parse(notification.json);
                content.notificationId = notification.idnotifications;
                Notification.addNotification(notification.message, notification.title, content);
            }
        } else {
            var content = JSON.parse(notification.json);
            content.notificationId = notification.idnotifications;
            Notification.addNotification(notification.message, notification.title, content);
        }
    }
    if (!!Notification.justClicked) {
        Notification.findIdenticalNotifications(Notification.justClicked);
    }
    if (!!Notification.appleJustClicked) {
        Notification.findIdenticalNotifications(Notification.appleJustClicked);
    }
    delete Notification.justClicked;
    delete Notification.appleJustClicked;
    delete Notification.appleOnForeground;
    Notification.storeHandledNotifications();
};

Notification.sendNotificationHandledClear = function(id) {
    var index = Notification.handledAleready.indexOf(id);
    if (index >= 0)
        Notification.handledAleready.splice(index, 1);
    Notification.sendNotificationHandled(id);
    Notification.storeHandledNotifications();
};

Notification.sendNotificationHandled = function(id) {
    serverRequest(
        "/notificationDealtWith",
        "GET",
        function(){},
        "delete Notifications",
        function(){Notification.sendNotificationHandled(id);},
        {idNotification: id}
    );
};

Notification.notifyActionAndErease = function(content) {
    Notification.popUp.find('.notificationContent').each(function() {
        var notifCont = JSON.parse($(this).html());
        if (content.notificationId === notifCont.notificationId)
            $(this).parent().remove();
    });
    Notification.notifAction(content);
    Notification.adjustTopBannerNotifBadge();
};

Notification.notifAction = function(content) {
    if (["agreement","newMatch","matchCanceled","messageMatch"].indexOf(content.type) >= 0) {
        goSomewhere(content.journeyId, content.matchId, content.agreementId, content.type === "messageMatch");
    } else if (content.type === "messageContact") {
        goToMessageContact(content.contactId);
    } else if (content.type === "comptes") {
        goToAccounts(content.compteId);
    } else ;
    Notification.sendNotificationHandledClear(content.notificationId);
    Notification.findIdenticalNotifications(content);
};

Notification.checkIfDestEqualsThis = function(content, message, lessTrue) {
    var hash = window.location.hash;
    if (hash === "#map") {
        var match = MapPage.matchList[MapPage.matchNum];
        if (content.type === "messageMatch") {
            if (content.journeyId === Partir4Page.journeyId) {
                if (content.matchId === match.match.idmatches) {
                    if (MessagePage.el.is(":visible")) {
                        MessagePage.appendMessageFromNotif(content.messageContent, content.messageTime);
                        MessagePage.sendDowngradeUnreadMatch(content.journeyId, content.matchId);
                    } else {
                        //Display the number of unread messages
                        var nbr;
                        if (Partir4Page.userType === 'driver') {
                            match.match.nbrUnreadD++;
                            nbr = match.match.nbrUnreadD;
                        }
                        else {
                            match.match.nbrUnreadP++;
                            nbr = match.match.nbrUnreadP;
                        }
                        Notification.changeNumNotif(MapPage.el.find(".messageTagNotif"),nbr);
                        if (MapPage.el.find('#chatJourneyBigImg').length>0) {
                            Notification.changeNumNotif(MapPage.el.find("#chatJourneyBigImg"),nbr);
                        }
                    }
                    return !lessTrue;
                } else {
                    var matchNum = -1;
                    for (var i = 0; i < MapPage.matchList.length; i++) {
                        if (MapPage.matchList[i].match.idmatches === content.matchId) {
                            matchNum = i;
                            break;
                        }
                    }
                    if (matchNum === -1) {
                        return false;
                    }
                    //Display the numbre of unread messages
                    if (Partir4Page.userType === 'driver') MapPage.matchList[matchNum].match.nbrUnreadD ++;
                    else MapPage.matchList[matchNum].match.nbrUnreadP ++;
                    return false;
                }
            } else return false;
        } else if (content.type === "agreement" | content.type === "comptes") {
            if (content.journeyId === Partir4Page.journeyId) {
                if (content.matchId === match.match.idmatches) {
                    var ok = false;
                    if (MapPage.agreementNum === -1) 
                        ok = true;
                    else if (content.agreementId === match.agreements[MapPage.agreementNum].idagreements)
                        ok = true;
                    if (ok) {
                        alert(message);
                        if (MessagePage.el.is(":visible")) {
                            MessagePage.contentToGoSomewhere = content;
                            return !lessTrue;
                        } else {
                            if (content.type === "agreement")
                                goSomewhere(content.journeyId, content.matchId, content.agreementId);
                            else
                                goToPage("#myTravels");
                            return true;
                        }
                    } else {
                        MapPage.lockedSwitchContent = {
                            message : message,
                            content : content,
                            track: content.type
                        };
                        return false;
                    }
                } else {
                    var track = content.type==="comptes"?"comptes":"matchId";
                    MapPage.lockedSwitchContent = {
                        message : message,
                        content : content,
                        track: track
                    };
                    return false;
                }
            } else return false;
        } else if (content.type === "matchCanceled") {
            if (content.journeyId === Partir4Page.journeyId) {
                if (content.matchCanceledId === match.match.idmatches) {
                    alert(message);
                    goSomewhere(content.journeyId, content.matchId, content.agreementId);
                    return true;
                } else {
                    var contentBis = {
                        journeyId : content.journeyId,
                        matchId : content.matchId
                    };
                    MapPage.lockedSwitchContent = {
                        message : message,
                        content : contentBis,
                        track: 'matchCanceled'
                    };
                    return false;
                }
            } else return false;
        } else if (content.type === "newMatch") {
            if (content.journeyId === Partir4Page.journeyId) {
                MapPage.lockedNewJourney = true;
                Notification.popUp.find('.lockedNewJourneyRefresh').show();
            }
            return false;
        } else return false;
    } else if (hash === "#partir4") {
        if (content.journeyId === Partir4Page.journeyId) {
            alert(message);
            goSomewhere(content.journeyId);
            return "break";
        }
    } else if (hash === "#contacts") {
        if (MessagePage.el.is(":visible")) {
            if (MessagePage.userInfo.idContact === content.contactId) {
                MessagePage.appendMessageFromNotif(content.messageContent, content.messageTime);
                MessagePage.sendDowngradeUnreadContact(content.contactId);
                return !lessTrue;
            }
        }
        ContactsPage.OneMoreUnreadMessage(content.contactId);
        return false;
    } else if (hash === "#myTravels") {
        if (content.type === "agreement" | content.type === "matchCanceled" | content.type === "newMatch") {
            alert(message);
            goToPage('#myTravels');
            return "break";
        }
    } else if (hash === "#accounts") {
        if (content.type === "comptes") {
            alert(message);
            goToAccounts(content.compteId);
            return "break";
        }
    } else if (hash === "#account") {
        if (content.type === "comptes") {
            if (content.compteId === AccountPage.data.idcomptes) {
                alert(message);
                goToAccounts(content.compteId);
            }
            else
                AccountPage.lockUpdate = true;
            return "break";
        }
    } else return false;
    return false;
};

Notification.findIdenticalNotifications = function(content) {
    Notification.popUp.find('.notificationContent').each(function() {
        var notifCont = JSON.parse($(this).html());
        if (
              content.journeyId === notifCont.journeyId 
            & content.matchId === notifCont.matchId
            & (content.agreementId === notifCont.agreementId | content.type === "messageMatch" | notifCont.type === "messageMatch")
            & content.contactId === notifCont.contactId
            ) {
                if (content.notificationId !== notifCont.notificationId)
                    Notification.purgeIdenticalNotifications($(this).parent(), notifCont);
            }
    });
};

Notification.purgeIdenticalNotifications = function(object, content) {
    Notification.sendNotificationHandledClear(content.notificationId);
    object.remove();
    Notification.adjustTopBannerNotifBadge();
};

Notification.adjustTopBannerNotifBadge = function() {
    var notifNum = Notification.popUp.find('.notification').length;
    Notification.changeNumNotif($('#notificationNotif'), notifNum);
    if (notifNum === 0) {
        Notification.popUp.find('#notificationPopUp .content').html('');
        Notification.popUp.find('.noNotifMessage').show();
        Notification.oldNewNotif($('#notificationNotif'),'old');
    }
};

Notification.sortAgreements = function() {
    MapPage.matchAgreementsPairsList.sort(function(a,b){
        var tagA = MapPage.matchList[a.matchNum].agreements[a.agreementNum].tag;
        var tagB = MapPage.matchList[b.matchNum].agreements[b.agreementNum].tag;
        var scoreA = MapPage.matchList[a.matchNum].match.score;
        var scoreB = MapPage.matchList[b.matchNum].match.score;
        if (tagA === tagB)
            return scoreA < scoreB ? -1 : 1;
        else
            return Notification.tagASmallerThanTagB(tagA, tagB);
    });
};

Notification.tagASmallerThanTagB = function(a, b) {
    switch(a) {
        case "passiveTag" :
            return true;
            break;
        case "activeTag" :
            if (b === "passiveTag")
                return false;
            else
                return true;
            break;
        case "RDVTag" :
            return false;
            break;
    }
};

Notification.setSelectedGuy = function(matchId, agreementId) {
    Notification.popUp.find('.selectedGuy').hide();
    if (!!agreementId) {
        Notification.popUp.find('.agreementId').each(function() {
            var id = parseInt($(this).html());
            if (id === agreementId) {
                $(this).parent().find('.selectedGuy').show();
            }
        });
    } else {
        Notification.popUp.find('.potentialTag .matchId').each(function() {
            var id = parseInt($(this).html());
            if (id === matchId) {
                $(this).parent().find('.selectedGuy').show();
            }
        });
    }
};

Notification.storeHandledNotifications = function() {
    if (Notification.handledAleready.length > 100)
        Notification.handledAleready.splice(0,50);
    window.localStorage.setArray("notificationsHandled", Notification.handledAleready);
};

Notification.restoreHandledNotifications = function() {
    Notification.handledAleready = window.localStorage.getArray("notificationsHandled");
};