/* global cordova, PartirPage, Geocoding, google, MyTravels, deviceType */

var Partir2Page = new Object();

Partir2Page.el = $('#partir2');
Partir2Page.returnObject;
Partir2Page.autocomplete;
Partir2Page.locomotionType;
Partir2Page.displayTuto = false;

//Fonction d'initialisation, affecte les evenements.
Partir2Page.initialize = function () {
    this.eventHandler();
};

Partir2Page.eventHandler = function () {
    $(document).on({
        'DOMNodeInserted': function() {
            $('.pac-item, .pac-item span', this).addClass('needsclick');
        }
    }, '.pac-container');
    
    this.el.on('click', '.back-menu', function (event) {
        goToPage("#partir");
    });

    this.el.on('click', '.input', function (event) {
        var object = $(this);
        var id = parseInt(object.find('.id').html());
        var result = $.grep(window.localStorage.getArray("partir2Favorites"), function (e) {
            return e.idfavoritePlaces === id;
        })[0];
        var place = {lat : result.address.latitude, lng : result.address.longitude};
        Partir2Page.returnObject.find(".adress").html(decodeURIComponent(result.addressestextIdaddressestext.text));
        Partir2Page.returnObject.find(".adress").removeClass("grey");
        goToPage("#partir");
        if (Partir2Page.returnObject.hasClass('departure')) {
            PartirPage.departureObject = place;
        } else if (Partir2Page.returnObject.hasClass('arrival')) {
            PartirPage.arrivalObject = place;
        } else if (Partir2Page.returnObject.hasClass('alt_arrival')) {
            PartirPage.arrivalAltObject = place;
        }
        //gère les favori et historique
    });

    this.el.on('click', '.star', function (event) {
        event.stopPropagation();
        var object = $(this);
        Partir2Page.switchFavorite(object);
        //ajoute aux favorie ou enlève
    });
    
    this.el.on('click', '.clearAltDestContent', function (event) {
        Partir2Page.returnObject.find(".adress").html("Destination alternative");
        Partir2Page.returnObject.find(".adress").addClass('grey');
        delete PartirPage.arrivalAltObject;
        goToPage("#partir");
    });
    
    this.el.on('click', '.clearCross', function (event) {
        if (Partir2Page.el.find('#autocomplete').val() === "" | Partir2Page.el.find('#autocomplete').val() === Partir2Page.el.find('#autocomplete').attr('placeholder'))
            return;
        Partir2Page.fillInAddress(true);
    });
    
    this.el.on('blur', '#autocomplete', function (event) {
        Partir2Page.el.find('.placeholder').hide();
    });
    
    this.el.on('keydown','#autocomplete',function(event){
        Partir2Page.el.find('.placeholder').hide();
    });
    
    this.el.on('click', '.positionButton', function (event) {
        var buffer = {object : Partir2Page.returnObject};
        if (Partir2Page.returnObject.hasClass('departure')) {
            buffer.type = 'departure';
        } else if (Partir2Page.returnObject.hasClass('arrival')) {
            buffer.type = 'arrival';
        } else if (Partir2Page.returnObject.hasClass('alt_arrival')) {
            buffer.type = 'alt_arrival';
        }
        var timeoutLock = 1;
        setTimeout(function() {
            if (timeoutLock === 1) {
                timeoutLock = 2;
                Partir2Page.preparePartirPageForGeolocation(true);
            }
        },
        500);
        navigator.geolocation.getCurrentPosition(
            function (position) {
                if (timeoutLock === 1) {
                    timeoutLock = 2;
                    Partir2Page.preparePartirPageForGeolocation(false);
                }
                Partir2Page.geolocationSuccess(position, buffer);
            },
            function(err){
                if(err.code === 2) {
                    timeoutLock = 2;
                    alert("Les services de localisation sont désactivés sur votre appareil");
                } else if (err.code === 3) {
                    if (buffer.object.find(".adress").html() === 'Ma position') {
                        if (buffer.type === 'departure') {
                            PartirPage.el.find('.departure .adress').html('Départ');
                            PartirPage.el.find('.departure .adress').addClass('grey');
                        }
                        else if (buffer.type === 'arrival') {
                            PartirPage.el.find('.arrival .adress').html('Destination');
                            PartirPage.el.find('.arrival .adress').addClass('grey');
                        }
                        else if (buffer.type === 'alt_arrival') {
                            PartirPage.el.find('.alt_arrival .adress').html('Destination alternative');
                            PartirPage.el.find('.alt_arrival .adress').addClass('grey');
                        }
                        alert('Désolé, nous ne sommes pas parvenu à vous localiser');
                    }
                } else {
                    timeoutLock = 2;
                    alert("Vous n'avez pas autorisé la localisation pour Kankaroo");
                }
            },
            {enableHighAccuracy: true, timeout: 45000}
        );
    });
    
    this.el.on('click','.popUpOk',function(event){
        if (Partir2Page.el.find("input[value='partir2Tuto']").prop('checked'))
            localStorage.partir2Tuto = true;
        hidePopUp(Partir2Page);
        setTimeout(function() {
            Partir2Page.el.find('#autocomplete').focus();
            cordova.plugins.Keyboard.show();
        },100);
    });
    
    this.el.on('click',".partir2TutoText",function () {
        Partir2Page.el.find("input[value='partir2Tuto']").prop('checked', !Partir2Page.el.find("input[value='partir2Tuto']").prop('checked'));
    });
    
};

Partir2Page.preparePartirPageForGeolocation = function(showToast) {
    Partir2Page.returnObject.find(".adress").html("Ma position");
    Partir2Page.returnObject.find(".adress").removeClass("grey");
    goToPage("#partir");
    if (showToast)
        window.plugins.toast.showShortBottom("En attente d'informations de localisation...");
};

Partir2Page.switchFavorite = function (star) {
    var data = {
        "placeId": parseInt(star.parent().find('.id').html()),
        "favorite": star.attr('src') !== "img/favorite_yellow_star.svg"
    };
    Partir2Page.switchFavoriteSuccess(star);
    Partir2Page.sendSwitchFavorite(data);
};

Partir2Page.sendSwitchFavorite = function(data) {
    serverRequest(
        "/favorites/places/edit",
        "GET",
        function () {},
        "switch favorite",
        function () {Partir2Page.sendSwitchFavorite(data);},
        data
    );
};

Partir2Page.switchFavoriteSuccess = function (star) {
    var placeInList;
    var placeId = parseInt(star.parent().find('.id').html());
    var list = window.localStorage.getArray("partir2Favorites");
    var length = list.length;
    for (var i = 0; i < length; i++) {
        if (list[i].idfavoritePlaces === placeId) {
            placeInList = list[i];
        }
    }
    if (star.attr('src') === "img/emptyStar.svg") {
        placeInList.isFavorite = true;
    } else {
        placeInList.isFavorite = false;
    }
    window.localStorage.setArray("partir2Favorites", list);
    Partir2Page.dealWithFavorites();
};

Partir2Page.geolocationSuccess = function (position, buffer) {
    var latitude = position.coords.latitude;
    var longitude = position.coords.longitude;
    Geocoding.reverseGeocoding({lat : latitude, lng : longitude}, function (place) {
        Partir2Page.myPositionSuccess(place, place[0].formatted_address, buffer, latitude, longitude);
    });
};

Partir2Page.myPositionSuccess = function (place, text, buffer, latitude, longitude) {
    if (buffer.object.find(".adress").html() === 'Ma position') {
        window.plugins.toast.showShortBottom("Localisation : " + text);
        buffer.object.find(".adress").html(text);
        buffer.object.find(".adress").removeClass("grey");
        place.lat = latitude;
        place.lng = longitude;
        if (buffer.type === 'departure') {
            PartirPage.departureObject = place;
        } else if (buffer.type === 'arrival') {
            PartirPage.arrivalObject = place;
        } else if (buffer.type === 'alt_arrival') {
            PartirPage.arrivalAltObject = place;
        }
    }
};

Partir2Page.initializeAutocomplete = function () {
    if (!Partir2Page.autocomplete) {
        Partir2Page.autocomplete = new google.maps.places.Autocomplete(
            (document.getElementById('autocomplete')),
            {
                componentRestrictions: {country: 'fr'}
            }
        );
        google.maps.event.addListener(Partir2Page.autocomplete, 'place_changed', function () {
            Partir2Page.fillInAddress();
            cordova.plugins.Keyboard.close();
        });
    }
};

Partir2Page.fillInAddress = function (go) {
    var place;
    if (typeof go !== 'undefined')
        place = {};
    else
        place = Partir2Page.autocomplete.getPlace();
    Partir2Page.returnObject.find(".adress").html(Partir2Page.el.find('#autocomplete').val());
    Partir2Page.returnObject.find(".adress").removeClass('grey');
    if (Partir2Page.returnObject.hasClass('departure')) {
        PartirPage.departureObject = place;
    } else if (Partir2Page.returnObject.hasClass(('arrival'))){
        PartirPage.arrivalObject = place;
    } else if (Partir2Page.returnObject.hasClass(('alt_arrival'))){
        PartirPage.arrivalAltObject = place;
    }
    goToPage("#partir");
};

Partir2Page.request = function (object) {
    Partir2Page.returnObject = object;
};

Partir2Page.getFavorites = function (action) {
    serverRequest(
        "/favorites/places/list",
        "GET",
        function (data) {
            window.localStorage.setArray("partir2Favorites", data.places);
            Partir2Page.dealWithFavorites();
            Partir2Page.fillGeocodingCache();
            if (!!action) action();
        },
        "get favorites PartirPage",
        Partir2Page.getFavorites
    );
};

Partir2Page.dealWithFavorites = function() {
    Partir2Page.el.find('.history .field, .favorite .field').html('');
    var list = window.localStorage.getArray("partir2Favorites");
    list.sort(function (a, b) {
        var Atime = new Date(a.updated);
        var Btime = new Date(b.updated);
        return ((Atime.getTime() < Btime.getTime()) ? 1 : -1);
    });
    var length = list.length;
    for (var i = 0; i < length; i++) {
        if (list[i].isFavorite) {
            Partir2Page.fillInFavorites(list[i]);
        } else {
            Partir2Page.fillInHistoric(list[i]);
        }
    }
    Partir2Page.handleFavoHistEmpty();
};

Partir2Page.fillInFavorites = function (favorite) {
        var address = decodeURIComponent(favorite.addressestextIdaddressestext.text);
        var html = $(
                '<div class="input">' +
                '<img class="icon" src="img/gps.svg" alt="">' +
                '<span class ="address"></span>' +
                '<span class ="id">' + favorite.idfavoritePlaces + '</span>' +
                '<img class="icon star" src="img/favorite_yellow_star.svg" alt="">' +
                '</div>'
                );
        html.find('.address').html(address);  //data[0].formatted_address);
        Partir2Page.el.find('.favorite .field').append(html);
        Partir2Page.refreshLast();
};

Partir2Page.refreshLast = function () {
    Partir2Page.el.find('.last').removeClass("last");
    Partir2Page.el.find('.input:last-child').addClass("last");
};

Partir2Page.fillInHistoric = function (history) {
        var address = decodeURIComponent(history.addressestextIdaddressestext.text);
        var html = $(
                '<div class="input">' +
                '<img class="icon" src="img/gps.svg" alt="">' +
                '<span class ="address"></span>' +
                '<span class ="id">' + history.idfavoritePlaces + '</span>' +
                '<img class="icon star" src="img/emptyStar.svg" alt="">' +
                '</div>'
                );
        html.find('.address').html(address);  //data[0].formatted_address);
        Partir2Page.el.find('.history .field').append(html);
        Partir2Page.refreshLast();
};

Partir2Page.handleFavoHistEmpty = function() {
    var favoField = Partir2Page.el.find('.favorite .field');
    if (favoField.html().length < 26) favoField.css('display', 'none');
    else favoField.css('display', 'block');
    
    var histField = Partir2Page.el.find('.history .field');
    if (histField.html().length < 26) histField.css('display', 'none');
    else histField.css('display', 'block');
};

//Affiche la page
Partir2Page.render = function () {
    Partir2Page.initializeAutocomplete();
    Partir2Page.reset();
    if (Partir2Page.returnObject.hasClass('departure')) {
        Partir2Page.el.find('.clearAltDest').hide();
        Partir2Page.el.find('.headerTitle').html('Départ');
        Partir2Page.el.find('.departure').show();
        Partir2Page.el.find('.arrival').hide();
    } else if (Partir2Page.returnObject.hasClass('arrival')) {
        Partir2Page.el.find('.clearAltDest').hide();
        Partir2Page.el.find('.headerTitle').html('Destination');
        Partir2Page.el.find('.departure').hide();
        Partir2Page.el.find('.arrival').show();
    } else {
        Partir2Page.el.find('.clearAltDest').show();
        Partir2Page.el.find('.headerTitle').html('Destination Alternative');
        Partir2Page.el.find('.departure').hide();
        Partir2Page.el.find('.arrival').show();
    }
    Partir2Page.dealWithFavorites();
    this.el.addClass("shown");
    if (Partir2Page.displayTuto) {
        showPopUp(Partir2Page);
        Partir2Page.displayTuto = false;
    } else {
        Partir2Page.el.find('#autocomplete').focus();
        cordova.plugins.Keyboard.show();
    }
    Partir2Page.el.find('.autocompleteBigBoxPhysicalPadding').height(Partir2Page.el.find('.autocompleteBigBox').height());
};

Partir2Page.reset = function () {
    Partir2Page.el.find('.history .field, .favorite .field').html('');
    Partir2Page.el.find('#autocomplete').val('');
    if (deviceType === 'android')
        Partir2Page.el.find('.placeholder').show();
    else
        Partir2Page.el.find('.placeholder').hide();
};

Partir2Page.fillGeocodingCache = function() {
    var list = window.localStorage.getArray("partir2Favorites");
    var cache = window.localStorage.getArray("geocodingCache");
    var date = new Date();
    var listLength = list.length;
    var cacheLength = cache.length;
    var toBeAddedToCache = [];
    for (var j = 0; j < listLength; j++) {
        var listEl = list[j];
        var exists = false;
        for (var i = 0; i < cacheLength; i++) {
            var cacheEl = cache[i];
            if (listEl.address.latitude === cacheEl.lat && listEl.address.longitude === cacheEl.lng) {
                cacheEl.update = date.getTime();
                cacheEl.used = date.getTime();
                cacheEl.str = decodeURIComponent(listEl.addressestextIdaddressestext.text);
                exists = true;
                break;
            }
        }
        if (!exists) toBeAddedToCache.push(listEl);
    }
    //add elements of toBeAddedToCache
    for (var i=0; i<toBeAddedToCache.length; i++) {
        var el = toBeAddedToCache[i];
        cache.push({
            str : decodeURIComponent(el.addressestextIdaddressestext.text),
            lat : el.address.latitude,
            lng : el.address.longitude,
            update : date.getTime(),
            used : date.getTime()});
    }
    
    window.localStorage.setArray("geocodingCache", cache);
    MyTravels.purgeGeocodingCache();
};