/* global PartirPage */

var Partir3Page = new Object();

Partir3Page.el = $('#partir3');
Partir3Page.returnObject;

//Fonction d'initialisation, affecte les evenements.
Partir3Page.initialize = function () {
    this.eventHandler();
};

Partir3Page.eventHandler = function () {
    this.el.on('click', '.back-menu', function (event) {
        goToPage("#partir");
    });

    this.el.on('click', '.journey', function (event) {
        var object = $(this);
        var id = parseInt(object.find('.id').html());
        var result = $.grep(window.localStorage.getArray("partir3Favorites"), function (e) {
            return e.idfavoritejourneys === id;
        })[0];
        Partir3Page.validateJourney(result);
        //gère les favori et historique
    });

    this.el.on('click', '.star', function (event) {
        event.stopPropagation();
        var object = $(this);
        Partir3Page.switchFavorite(object);
        //ajoute aux favorie ou enlève
    });
};

Partir3Page.switchFavorite = function (star) {
    var data = {
        "journeyId": parseInt(star.parent('.journey').find('.id').html()),
        "favorite": star.find('img').attr('src') !== "img/favorite_yellow_star.svg"
    };
    Partir3Page.switchFavoriteSuccess(star);
    Partir3Page.sendSwitchFavorite(data);
};

Partir3Page.sendSwitchFavorite = function(data) {
    serverRequest(
        "/favorites/journeys/edit",
        "GET",
        function () {
        },
        "switch favorite",
        function () {
            Partir3Page.sendSwitchFavorite(data);
        },
        data
    );
};

Partir3Page.switchFavoriteSuccess = function (star) {
    var placeInList;
    var placeId = parseInt(star.parent('.journey').find('.id').html());
    var list = window.localStorage.getArray("partir3Favorites");
    var length = list.length;
    for (var i = 0; i < length; i++) {
        if (list[i].idfavoritejourneys === placeId) {
            placeInList = list[i];
        }
    }
    if (star.find('img').attr('src') === "img/emptyStar.svg") {
        placeInList.isFavorite = true;
    } else {
        placeInList.isFavorite = false;
    }
    window.localStorage.setArray("partir3Favorites", list);
    Partir3Page.dealWithFavorites();
};

Partir3Page.validateJourney = function (journey) {
    if (journey.addressesIdaddresses){
        var place = {lat : journey.addressesIdaddresses.latitude, lng : journey.addressesIdaddresses.longitude};
        PartirPage.departureObject = place;
        PartirPage.el.find('.departure .adress').html(decodeURIComponent(journey.addressestextIdaddressestext.text));
        PartirPage.el.find('.departure .adress').removeClass("grey");
    } 
    if (journey.addressesIdaddresses1) {
        var place = {lat : journey.addressesIdaddresses1.latitude, lng : journey.addressesIdaddresses1.longitude};
        PartirPage.arrivalObject = place;
        PartirPage.el.find('.arrival .adress').html(decodeURIComponent(journey.addressestextIdaddressestext1.text));
        PartirPage.el.find('.arrival .adress').removeClass("grey");
    }
    if (journey.addressesIdaddresses2) {
        var place = {lat : journey.addressesIdaddresses2.latitude, lng : journey.addressesIdaddresses2.longitude};
        PartirPage.arrivalAltObject = place;
        PartirPage.el.find('.alt_arrival .adress').html(decodeURIComponent(journey.addressestextIdaddressestext2.text));
        PartirPage.el.find('.alt_arrival .adress').removeClass("grey");
    } else {
        PartirPage.el.find('.alt_arrival .adress').html("Destination alternative");
        PartirPage.el.find('.alt_arrival .adress').addClass('grey');
    }
    goToPage("#partir");
};

Partir3Page.request = function (object) {
    Partir3Page.returnObject = object;
};

Partir3Page.getFavorites = function () {
    serverRequest(
        "/favorites/journeys/list",
        "GET",
        function (data) {
            window.localStorage.setArray("partir3Favorites", data.journeys);
            Partir3Page.dealWithFavorites();
            if (data.journeys.length>0)
                PartirPage.el.find('.star').show();
        },
        "get favorites PartirPage",
        Partir3Page.getFavorites
    );
};

Partir3Page.dealWithFavorites = function() {
    Partir3Page.el.find('.favorite .field').html('');
    Partir3Page.el.find('.history .field').html('');
    var list = window.localStorage.getArray("partir3Favorites");
    list.sort(function (a, b) {
        var Atime = new Date(a.updated);
        var Btime = new Date(b.updated);
        return ((Atime.getTime() < Btime.getTime()) ? 1 : -1);
    });
    var length = list.length;
    for (var i = 0; i < length; i++) {
        (function(index,list){
            if (list[index].isFavorite) {
                Partir3Page.fillInFavorites(list[index]);
            } else {
                Partir3Page.fillInHistoric(list[index]);
            }
        })(i,list);
    }
    Partir3Page.handleFavoHistEmpty();
};

Partir3Page.fillInFavorites = function (favorite) {
    if (!(favorite.addressesIdaddresses2 && PartirPage.el.find("label[for='radioRolePi']").hasClass('selectedLabel'))){
        var pickupAddress = decodeURIComponent(favorite.addressestextIdaddressestext.text);
        var dropAddress = decodeURIComponent(favorite.addressestextIdaddressestext1.text);
        var data = {
            isFavorite: true,
            idfavoritejourneys: favorite.idfavoritejourneys,
            pickupAddress: pickupAddress,
            dropAddress: dropAddress
        };
        if (favorite.addressesIdaddresses2)
            data.dropAltAddress = decodeURIComponent(favorite.addressestextIdaddressestext2.text);
        Partir3Page.el.find('.favorite .field').append(partir3Journey_template(data));
        Partir3Page.refreshLast();
    }
};

Partir3Page.refreshLast = function() {
    Partir3Page.el.find('.journey.last').removeClass("last");
    Partir3Page.el.find('.journey:last-child').addClass("last");
};

Partir3Page.fillInHistoric = function (history) {
    if (!(history.addressesIdaddresses2 && PartirPage.el.find("label[for='radioRolePi']").hasClass('selectedLabel'))){
        
        var pickupAddress = decodeURIComponent(history.addressestextIdaddressestext.text);
        var dropAddress = decodeURIComponent(history.addressestextIdaddressestext1.text);
        var data = {
            idfavoritejourneys: history.idfavoritejourneys,
            pickupAddress: pickupAddress,
            dropAddress: dropAddress
        };
        if (history.addressesIdaddresses2)
            data.dropAltAddress = decodeURIComponent(history.addressestextIdaddressestext2.text);
        Partir3Page.el.find('.history .field').append(partir3Journey_template(data));
        Partir3Page.refreshLast();
    }
};

Partir3Page.handleFavoHistEmpty = function() {
    var bothEmpty = true;
    
    var favoField = Partir3Page.el.find('.favorite .field');
    if (favoField.html().length === 0) favoField.css('display', 'none');
    else {
        favoField.css('display', 'block');
        bothEmpty = false;
    }
    
    var histField = Partir3Page.el.find('.history .field');
    if (histField.html().length === 0) histField.css('display', 'none');
    else {
        histField.css('display', 'block');
        bothEmpty = false;
    }
    
    if (bothEmpty === true)
        Partir3Page.el.find('.bothEmpty').show();
    else
        Partir3Page.el.find('.bothEmpty').hide();
};

//Affiche la page
Partir3Page.render = function () {
    Partir3Page.reset();
    Partir3Page.dealWithFavorites();
    this.el.addClass("shown");
};

Partir3Page.reset = function () {
    Partir3Page.el.find('.favorite .field').html('');
    Partir3Page.el.find('.history .field').html('');
};