/* global MyProfilePage, Notification, Create2Page, Create3Page, ContactsPage, MapPage, ImageHandler, Menu */

var ProfilePage = new Object();

ProfilePage.el = $('#profile');
ProfilePage.userInfo;
ProfilePage.userData;
ProfilePage.profilePicture;
ProfilePage.vehiclePicture;
ProfilePage.insurancePicture;
ProfilePage.vehicle;

//Fonction d'initialisation, affecte les evenements.
ProfilePage.initialize = function () {
    this.eventHandler();
};

ProfilePage.eventHandler = function () {
    this.el.on('click','.back-menu',function (event){
        ProfilePage.backToPreviousPage();
    });
    
    this.el.on('click','.leftSide',function (event){
        if (ProfilePage.profilePicture.noPicture === "true") {
            var url;
            if (ProfilePage.userData.sex === true)
                url = 'img/replace_image_female.svg';
            else url = 'img/replace_image_male.svg';
            ProfilePage.el.find('.imagePopUp').html("<img src='" + url + "' alt='' class='imageLoaded'>");
        } else {
            ProfilePage.displayPicture(ProfilePage.profilePicture, ProfilePage.el.find('.imagePopUp'));
        }
        showPopUp(ProfilePage);
    });
    
    this.el.on('click','.car',function (event){
        if (ProfilePage.vehiclePicture.noPicture === "true") {
            var url;
            if (ProfilePage.vehicle.type === 'car')
                url = 'img/replace_image_car.svg';
            else url = 'img/replace_image_moto.svg';
            ProfilePage.el.find('.imagePopUp').html("<img src='" + url + "' alt='' class='imageLoaded'>");
        } else {
            ProfilePage.displayPicture(ProfilePage.vehiclePicture, ProfilePage.el.find('.imagePopUp'));
        }
        showPopUp(ProfilePage);
    });
    
    this.el.on('click','.insurance',function (event){
        if (ProfilePage.insurancePicture.noPicture === "true")
            ProfilePage.el.find('.imagePopUp').html("<img src='img/replace_image_insurance.png' alt='' class='imageLoaded'>");
        else
            ProfilePage.displayPicture(ProfilePage.insurancePicture, ProfilePage.el.find('.imagePopUp'));
        showPopUp(ProfilePage);
    });
    
    this.el.on('click','.overlay, .close',function (event){
        hidePopUp(ProfilePage);
    });
    
    this.el.on('click','.popUp',function (event){
        event.stopPropagation();
    });
};

ProfilePage.setUpUsers = function (info, vehicle, data) {
    ProfilePage.userInfo = info;
    ProfilePage.userData = data;
    if (!!ProfilePage.userInfo.idContact)
        ProfilePage.el.find('.previousPageTitle').html('Contacts');
    else
        ProfilePage.el.find(".previousPageTitle").html('Récapitulatif');
    ProfilePage.vehicle = vehicle;
};

ProfilePage.backToPreviousPage = function() {
    $(".shown").removeClass("shown");
    if (!!ProfilePage.userInfo.idContact) {
        ContactsPage.el.addClass("shown");
        Menu.handleJSRendering(ContactsPage);
    } else {
        MapPage.el.addClass("shown");
        Menu.handleJSRendering(MapPage);
    }
};

ProfilePage.getProfile = function (contactId){
    serverRequest(
        "/profile/display",
        "GET",
        ProfilePage.gotProfile,
        "profil contact profile",
        function() {ProfilePage.getProfile(contactId);},
        {idContact: contactId}
    );
};
    
ProfilePage.gotProfile = function(data){
    ProfilePage.userData = data;
    if(typeof data.preferences !== "undefined"){
        ProfilePage.el.find(".music").html(escapeXml(data.preferences));
    }
    if(typeof data.workplace !== "undefined"){
        ProfilePage.el.find(".firm").html(escapeXml(data.workplace));
    }
    if(typeof data.transport !=="undefined"){
        ProfilePage.el.find('.transport').html(ProfilePage.parseTransportToReadable(data.transport));
    }
    if(typeof data.comment !=="undefined"){
        ProfilePage.el.find('.info').html(escapeXml(data.comment));
    }
    if(typeof data.averageRatings !== "undefined"){
        MyProfilePage.handleStar(data.averageRatings,ProfilePage.el.find('.noteBar .rating'));
    }
    if(typeof data.ratings !== "undefined"){
        MyProfilePage.handleComments(data.ratings, ProfilePage, data.numberOfRatings);
    }
    if(typeof data.sex !=="undefined"){
        var url;
        if (data.sex === true)
            url = 'img/replace_image_female.svg';
        else url = 'img/replace_image_male.svg';
        ProfilePage.el.find('.profile .imageLoaded').attr('src', url);
    }
    if (!ProfilePage.userInfo.idContact)
        ProfilePage.el.find(".name").html(escapeXml(data.name));
};

ProfilePage.parseTransportToReadable = function(transport) {
    if (transport === 'BOTH')
        return 'auto et moto';
    else if (transport === 'CAR')
        return 'auto';
    else if (transport === 'MOTO')
        return 'moto';
};

ProfilePage.fillImage = function (matchId,journeyId) {
    ProfilePage.fillImageProfile(matchId, journeyId, true);
    if (!!ProfilePage.vehicle) {
        ProfilePage.fillImageVehicle(matchId, journeyId);
        ProfilePage.fillImageInsurance(matchId, journeyId);
    }
};

ProfilePage.fillImageProfile = function (matchId,journeyId, isProfilePage) {
    if (ImageHandler.isLoaded(matchId,"profile")){
        if (ImageHandler.isData(matchId)){
            ProfilePage.profilePicture = {picture : ImageHandler.getImage(matchId,"profile")};
            if (isProfilePage)
                Create2Page.cameraSuccess(ImageHandler.getImage(matchId,"profile"),ProfilePage.el.find('.profile'));
            else
                Create2Page.cameraSuccess(ImageHandler.getImage(matchId,"profile"),MapPage.el.find('.profileImage'));
        } else  {
            ProfilePage.profilePicture = {url : ImageHandler.getImage(matchId,"profile")};
            if (isProfilePage)
                Create3Page.loadImgFromUrl(ImageHandler.getImage(matchId,"profile"),ProfilePage.el.find('.profile'));
            else
                Create3Page.loadImgFromUrl(ImageHandler.getImage(matchId,"profile"),MapPage.el.find('.profileImage'));
        }
    } else {
        if (!ImageHandler.noImg(matchId,"profile")){
            serverRequest(
                "/travel/pic",
                "GET",
                function(data){
                    ProfilePage.storeImg(data,matchId,"profile");
                    ProfilePage.fillImageProfile(matchId,journeyId);
                },
                "image MapPage",
                function() {ProfilePage.fillImageProfile(matchId,journeyId);},
                {
                    'myJourneyId':journeyId,
                    'matchId':matchId
                }                        
            );
            return;
        } else {
            ProfilePage.profilePicture = {noPicture : "true"};
        }
    }
};

ProfilePage.fillImageVehicle = function (matchId,journeyId) {
    if (ImageHandler.isLoaded(matchId,"car")){
        ProfilePage.vehiclePicture = {picture : ImageHandler.getImage(matchId,"car")};
        Create2Page.cameraSuccess(ImageHandler.getImage(matchId,"car"),ProfilePage.el.find('.car'));
    } else {
        if (!ImageHandler.noImg(matchId,"car")){
            serverRequest(
                "/travel/pic",
                "GET",
                function(data){
                    ProfilePage.storeImg(data,matchId,"car");
                    ProfilePage.fillImageVehicle(matchId,journeyId);
                },
                "image MapPage",
                function() {ProfilePage.fillImageVehicle(matchId,journeyId);},
                {
                    'myJourneyId':journeyId,
                    'matchId':matchId,
                    'vehicle':true
                }                        
            );
            return;
        } else {
            ProfilePage.vehiclePicture = {noPicture : "true"};
        }
    }
};

ProfilePage.fillImageInsurance = function (matchId,journeyId) {
    if (ImageHandler.isLoaded(matchId,"insurance")){
        ProfilePage.insurancePicture = {picture : ImageHandler.getImage(matchId,"insurance")};
        Create2Page.cameraSuccess(ImageHandler.getImage(matchId,"insurance"),ProfilePage.el.find('.insurance'));
    } else {
        if (!ImageHandler.noImg(matchId,"insurance")){
            serverRequest(
                "/travel/pic",
                "GET",
                function(data){
                    ProfilePage.storeImg(data,matchId,"insurance");
                    ProfilePage.fillImageInsurance(matchId,journeyId);
                },
                "image MapPage",
                function() {ProfilePage.fillImageInsurance(matchId,journeyId);},
                {
                    'myJourneyId':journeyId,
                    'matchId':matchId,
                    'insurance':true
                }                        
            );
            return;
        } else {
            ProfilePage.insurancePicture = {noPicture : "true"};
        }
    }
};

ProfilePage.getImg = function(contactId){
    serverRequest(
        "/profile/picture",
        "GET",
        ProfilePage.gotImg,
        "image profil contact profile",
        function() {ProfilePage.getImg(contactId);},
        {idContact: contactId}
    );
};

ProfilePage.gotImg = function (data) {
    ProfilePage.profilePicture = data;
    ProfilePage.displayPicture(data, ProfilePage.el.find('.profile'));
};

ProfilePage.displayPicture = function(data, object) {
    if (typeof data.noPicture !== "undefined"){
        //pas de photo de profil
    } else if (typeof data.picture !== "undefined"){
        Create2Page.cameraSuccess(data.picture,object);
    } else if (typeof data.url !== "undefined") {
        Create3Page.loadImgFromUrl(data.url,object);
    }
};

ProfilePage.storeImg = function(data,matchId,type) {
    if (typeof data.noPicture !== "undefined"){
        ImageHandler.notifyNoImg(matchId,type);
    } else if (typeof data.picture !== "undefined"){
        ImageHandler.addImage(data.picture,matchId,type);
    } else if (typeof data.url !== "undefined") {
        ImageHandler.addUrlImage(data.url,matchId,type);
    }
};

//affiche la page
ProfilePage.render = function() {
    ProfilePage.reset();
    ProfilePage.fillVehicleInfo();
    this.el.addClass("shown");
    showLoading();
    var width = ProfilePage.el.find('.profile').width();
    ProfilePage.el.find('.image').css('height',width);
    ProfilePage.el.find('.info').css('height',width - 10);
    showPopUp(ProfilePage);
    ProfilePage.el.find('.imagePopUp').css('height',ProfilePage.el.find('.imagePopUp').width());
    hidePopUp(ProfilePage);
    if (!!ProfilePage.userInfo.idContact) {
        ProfilePage.getProfile(ProfilePage.userInfo.idContact);
        ProfilePage.getImg(ProfilePage.userInfo.idContact);
        ProfilePage.el.find(".name").html(ProfilePage.userInfo.name);
    } else {
        ProfilePage.gotProfile(ProfilePage.userData);
        ProfilePage.fillImage(ProfilePage.userInfo.matchId, ProfilePage.userInfo.journeyId);
        endLoading();
    }
    Menu.handleJSRendering(ProfilePage);
};

ProfilePage.fillVehicleInfo = function() {
    if (!!ProfilePage.vehicle) {
        ProfilePage.el.find('.vehicle').show();
        if (ProfilePage.vehicle.type === 'car') {
            ProfilePage.el.find('.car img').attr('src', 'img/replace_image_car.svg');
            if (ProfilePage.vehicle.smoking) {
                ProfilePage.el.find('.smoking').show();
                ProfilePage.el.find('.nonSmoking').hide();
            } else {
                ProfilePage.el.find('.smoking').hide();
                ProfilePage.el.find('.nonSmoking').show();
            }
        } else {
            ProfilePage.el.find('.car img').attr('src', 'img/replace_image_moto.svg');
            ProfilePage.el.find('.smoking').hide();
            ProfilePage.el.find('.nonSmoking').hide();
        }
        ProfilePage.el.find('.insurance img').attr('src', 'img/replace_image_insurance.png');
        ProfilePage.el.find('.vehicleName').html(escapeXml(ProfilePage.vehicle.name));
    } else {
        ProfilePage.el.find('.vehicle').hide();
    }
};

ProfilePage.reset = function() {
    ProfilePage.el.find('.comments').html('');
    ProfilePage.el.find('.noteBar .rating').html('');
    ProfilePage.el.find(".music").val('');
    ProfilePage.el.find('.firm').html('');
    ProfilePage.el.find('.nbNotes').html('');
    ProfilePage.el.find('.transport').html('');
    ProfilePage.el.find('.image').html("<img src='' alt='' class='imageLoaded'>");
    delete ProfilePage.profilePicture;
    delete ProfilePage.vehiclePicture;
    delete ProfilePage.insurancePicture;
};