/* global device, SoftKeyboard, ContactsPage, MyTravels, Notification, pushNotification, appIsOnForeground, Feedback, MessagePage, EWalletPage, ProfilePage, HistoryPage, gaPlugin, Partir4Page, Partir3Page, Partir2Page, Create2Page, Create3Page, MyCarsPage, Create3FirmPage, MyProfilePage, MapPage, PasswdPage, CreatePage, MyAccountPage, PartirPage, TestPage, LoginPage, Menu, Handlebars, cordova, Map2Page, GradePage, deviceType, Map3Page, JourneyPage, load, Origami, AccountsPage, AccountPage */

function initializeApp() {
    /* --------------------------------- Event Registration -------------------------------- */
    $.ajaxSetup({
        'beforeSend': function (xhr) {
            xhr.overrideMimeType('text/html; charset=ISO-8859-1');
        }
    });
    //Templates
    vehicule_template                = Handlebars.compile($("#vehicule-template").html());
    map_popUp_price_template         = Handlebars.compile($('#map-popUp-price-template').html());
    map_popUp_money_template         = Handlebars.compile($('#map-popUp-money-template').html());
    message_template                 = Handlebars.compile($('#message-template').html());
    agreement_template               = Handlebars.compile($('#agreement-template').html());
    no_agreement_template            = Handlebars.compile($('#no-agreement-template').html());
    travel_template                  = Handlebars.compile($('#travel-template').html());
    popUp_modify_time_template       = Handlebars.compile($('#popUp-modify-time-template').html());
    history_line_template            = Handlebars.compile($('#history-line-template').html());
    contact_template                 = Handlebars.compile($('#contact-template').html());
    account_template                 = Handlebars.compile($('#account-template').html());
    notification_template            = Handlebars.compile($('#notification-template').html());
    map_popUp_help                   = Handlebars.compile($('#map-popUp-help').html());
    partir3Journey_template          = Handlebars.compile($('#partir3Journey-template').html());
    new_travels_recap_template       = Handlebars.compile($('#new-travels-recap-template').html());
    partir4_prices_template          = Handlebars.compile($('#partir4-prices-template').html());

    Handlebars.registerHelper('ifCond2', function(v1, v2, options) {
        if(v1 | v2) {
          return options.fn(this);
        }
        return options.inverse(this);
    });

    Handlebars.registerHelper('ifCond3', function(v1, v2, v3, options) {
        if(v1 | v2 | v3) {
          return options.fn(this);
        }
        return options.inverse(this);
    });

    Handlebars.registerHelper('ifCond4', function(v1, v2, v3, v4, options) {
        if(v1 | v2 | v3 | v4) {
          return options.fn(this);
        }
        return options.inverse(this);
    });

    Handlebars.registerHelper('ifCond5', function(v1, v2, v3, v4, v5, options) {
        if(v1 | v2 | v3 | v4 | v5) {
          return options.fn(this);
        }
        return options.inverse(this);
    });

    Handlebars.registerHelper('ifCond6', function(v1, v2, v3, v4, v5, v6, options) {
        if(v1 | v2 | v3 | v4 | v5 | v6) {
          return options.fn(this);
        }
        return options.inverse(this);
    });

    Handlebars.registerHelper('ifCond7', function(v1, v2, v3, v4, v5, v6, v7, options) {
        if(v1 | v2 | v3 | v4 | v5 | v6 | v7) {
          return options.fn(this);
        }
        return options.inverse(this);
    });

    Handlebars.registerHelper('ifCond8', function(v1, v2, v3, v4, v5, v6, v7, v8, options) {
        if(v1 | v2 | v3 | v4 | v5 | v6 | v7 | v8) {
          return options.fn(this);
        }
        return options.inverse(this);
    });

    Handlebars.registerHelper('ifCond9', function(v1, v2, v3, v4, v5, v6, v7, v8, v9, options) {
        if(v1 | v2 | v3 | v4 | v5 | v6 | v7 | v8 | v9) {
          return options.fn(this);
        }
        return options.inverse(this);
    });
    
    Handlebars.registerHelper('breaklines', function(text) {
        text = Handlebars.Utils.escapeExpression(text);
        text = text.replace(/(\r\n|\n|\r)/gm, '<br>');
        return new Handlebars.SafeString(text);
    });

    //Push notification
    pushNotification = window.plugins.pushNotification;
    registerPush();
    if (!!localStorage.mail)
        sendRegIDToServer();
    //Fastclick
    var attachFastClick = Origami.fastclick;
    attachFastClick(document.body);
    //Google analytics not the same for iOS and android cause not the same plugin
    if (deviceType !== 'iOS') {
        gaPlugin = window.plugins.gaPlugin;
        gaPlugin.init(nativePluginResultHandler, nativePluginErrorHandler, "UA-67844724-1", 10);
    } else {
        window.ga.startTrackerWithId("UA-67844724-1");
    }
    if (navigator.notification) { // Override default HTML alert with native dialog
        window.alert = function (message, title, button) {
            if (!title)
                title = "Kankaroo";
            if (!button)
                button = 'OK';
            navigator.notification.alert(
                    message, // message
                    null, // callback
                    title, // title
                    button // buttonName
                    );
        };
    }

    $(window).on('hashchange', route);

    document.addEventListener("backbutton", onBackKeyDown, false);
    document.addEventListener("menubutton", onMenuButton, false);

    function onBackKeyDown() {
        var hash = window.location.hash;
        if ($('#overlayLoad').is(":visible")) {}
        else if ($('.overlay:visible').length !== 0){
            if (hash === '#partir' && PartirPage.tooLate === true) return;
            if (hash === '#partir2' && Partir2Page.el.find('.popUp').is(':visible')) return;
            $('.overlay:visible').find(".popUp").hide();
            $('.overlay:visible').hide();
        }else if (Notification.popUp.is(":visible")) {
            Notification.closePopUp();
        }else if (Menu.open === false) {
            Menu.handleMenu();
        }else if(hash === "#create"){
            exitApp();
        } else if(hash === "#login"){
            exitApp();
        } else if(hash === "#passwd"){
            PasswdPage.backToLogin();
        } else if(hash === "#create3firm"){
            Create3FirmPage.el.find('.back-menu').click();
        } else if (hash === "#create2") {
            Create2Page.el.find('.back-menu').click();
        } else if (hash === "#create3") {
            Create3Page.el.find('.back-menu').click();
        } else if (hash === "#partir") {
            if (PartirPage.el.find('.first .back-menu').is(':visible'))
                PartirPage.el.find('.first .back-menu').click();
            else if (PartirPage.el.find('.next .back-menu').is(':visible'))
                PartirPage.el.find('.next .back-menu').click();
        } else if (hash === "#partir2") {
                goToPage("#partir");
        } else if (hash === "#partir3") {
            goToPage("#partir");
        } else if (hash === "#map") {
            if (MessagePage.el.is(":visible")) {
                MessagePage.backToPreviousPage();
            } else if (ProfilePage.el.is(":visible")) {
                ProfilePage.backToPreviousPage();
            } else if (GradePage.el.is(":visible")) {
                GradePage.backToPreviousPage();
            } else if (Map2Page.el.is(":visible")) {
                Map2Page.el.find('.back-menu').click();
            } else if (Map3Page.el.is(":visible")) {
                Map3Page.backToPreviousPage();
            } else if (JourneyPage.el.is(":visible")) {
                JourneyPage.backToPreviousPage();
            }
            else {
                MapPage.el.find('.back-menu').click();
            }
        } else if (hash === "#myTravels") {
            exitApp();
        } else if (hash === "#partir4") {
            Partir4Page.el.find('.back-menu').click();
        } else if (hash === "#contacts") {
            if (MessagePage.el.is(":visible")) {
                MessagePage.backToPreviousPage();
            } else if (ProfilePage.el.is(":visible")) {
                ProfilePage.backToPreviousPage();
            } else {
                goToPage('#myTravels');
            }
        } else if (hash === "#account") {
                AccountPage.el.find('.back-menu').click();
        } else {
            goToPage('#myTravels');
        }
    }

    function onMenuButton() {
        if (Menu.isMenuAble()) Menu.handleMenu();
    }


    $('body').on('click','a',function(event){
        event.preventDefault();
        window.open($(this).attr("href"), '_system');
    });
    
    $('body').on('click','.onoffswitch-label',function(event){
        event.preventDefault();
    });
    
    $('body').on('touchstart','.onoffswitch-label',function(event){
        event.preventDefault();
        var check = $(this).parent().find('input');
        if (check.val() === "cash") { //TODO remove when paiement via CB is available
            alert("Paiement en espèce obligatoire\n\nNous travaillons à mettre en place un paiement automatique");
            return;
        }
        var checked = !check.prop('checked');
        check.prop('checked', !check.prop('checked'));
        switch (check.val()) {
            case "cash" :
                //TODO unquote when paiement via CB is available
//                serverRequest(
//                    "/agreementChangeRefuseCash",
//                    "GET",
//                    function(data){
//                    },
//                    "cashPref MapPage",
//                    null,
//                    {
//                        myJourneyId:Partir4Page.journeyId,
//                        set:$(this).is(":checked")
//                    }
//                );
                break;
            /* Suspended for the moment
            case "matchNotification" :
                Partir4Page.handleMatchNotification(checked);
                break;
            */
            case "RDVReminder" :
                var match = MapPage.matchList[MapPage.matchNum];
                var agreementId = match.agreements[MapPage.agreementNum].idagreements;
                var delay = MapPage.el.find('select[name="RDVReminderParameter"]').val();
                if (checked) {
                    var pickupDate    = new Date(match.agreementJourney.pickupTimeMin + " GMT");
                    var alarmTime = new Date(pickupDate.getTime() - delay*60*1000);
                    var date = new Date();
                    if (alarmTime.getTime() - date.getTime() < 0) {
                        alert('Vous devriez déjà être en route !');
                        check.prop('checked',false);
                        return;
                    }
                    //Save the default value of Delay for next time
                    localStorage.alarmsDelay = delay;
                    alert('Vous recevrez une notification ' + delay + ' min avant le RDV');
                    var json = JSON.stringify({
                        journeyId: Partir4Page.journeyId, 
                        matchId: match.match.idmatches,
                        agreementId: agreementId,
                        delay: delay
                    });
                    window.plugin.notification.local.add({
                        id:         agreementId,
                        date:       alarmTime,
                        message:    "Vous avez rendez-vous dans " + delay + " min",
                        title:      "Kankaroo",
                        json:       json,
                        autoCancel: true
                    });
                    window.plugin.notification.local.onclick = function (id, state, json) {
                        onLocalNotification(id, json);
                    };
                    window.plugin.notification.local.ontrigger = function (id, state, json) {
                        onLocalNotificaitonTrigger(id, json);
                    };
                } else {
                    alert('Alarme supprimée');
                    window.plugin.notification.local.cancel(agreementId);
                }
                var alarms = window.localStorage.getArray("alarms");
                var indice;
                for (var i = 0; i < alarms.length; i++) {
                    if (parseInt(alarms[i].id) === parseInt(agreementId)) {
                        indice = i;
                        break;
                    }
                }
                if (typeof indice !== 'undefined') {
                    alarms[indice].val = checked;
                    alarms[indice].delay = delay;
                }
                else alarms.push({id : agreementId, val : checked, delay : delay});
                window.localStorage.setArray('alarms', alarms);
                break;
            case "chat" :
                MessagePage.handleNotifMessageChange(checked);
                break;
            case "CGU" :
                if (checked) {
                    CreatePage.el.find('.popUpCancel').hide();
                    CreatePage.el.find('#facebook').show();
                } else {
                    CreatePage.el.find('.popUpCancel').show();
                    CreatePage.el.find('#facebook').hide();
                }
                break;
            case "travelRegularity" :
                var hash = window.location.hash;
                var page;
                if (hash === '#myTravels')
                    page = MyTravels;
                else
                    page = Partir4Page;
                if (checked) {
                    page.el.find('.unregular').hide();
                    page.el.find('.regular').show();
                } else {
                    page.el.find('.unregular').show();
                    page.el.find('.regular').hide();
                }
                showPopUp(page);
                break;
        }
    });


    $('body').on('focus', 'input[type="text"], textarea', function () {
        var object = $(this);
        if (!object.hasClass("focus"))
            object.addClass('focus');
        if (object.val() === object.attr('placeholder')) {
            object.val('');
        }
    });

    $('body').on('blur', 'input[type="text"], textarea', function () {
        var object = $(this);
        if (object.val() === "") {
            object.removeClass('focus');
            object.val(object.attr('placeholder'));
        }
    });
    
    //init css
    var valeur = $(".image").height();
    if(window.orientation===0 && valeur){
        $(".image").css("height",valeur);
        $(".image").css("min-height",valeur);
        $(".image").css("max-height",valeur);
    }
    $('#message-holder').css("max-height",$('message-holder').css('height'));
    
    if (deviceType === 'iOS') { // Prevent select to instantly close on fast click
        $('select').on('touchstart',function(e) {
            e.preventDefault();
        });
    }

    document.addEventListener('click', function(e) {
        if (!isTextInput(e.target) && isTextInput(document.activeElement)) {
            cordova.plugins.Keyboard.close();
            document.activeElement.blur();
        }
    }, false);
    
    document.onkeyup=function(e) {
        if(e.which === 13 & ['INPUT'].indexOf(e.target.nodeName) !== -1){
            cordova.plugins.Keyboard.close();
        }
    };
    
    $('body').on('click', '.popUpOkNotifTuto', function () {
        localStorage.notifsTuto = true;
        $('.popUpNotifTuto').hide();
        $('.overlayNotifTuto').hide();
        registerPush();
    });
    
};

function route() {
    var hash = window.location.hash;
    var page;
    var pageText;
    if (!hash) {
        page = MyTravels;
        pageText = 'MyTravels';
    }
    else if (hash === '#login') {
        page = LoginPage;
        pageText = 'LoginPage';
    }
    else if (hash === '#test') {
        page = TestPage;
        pageText = 'TestPage';
    }
    else if (hash === '#create') {
        page = CreatePage;
        pageText = 'CreatePage';
    }
    else if (hash === '#myAccount')
    {
        page = MyAccountPage;
        pageText = 'MyAccountPage';
    }
    else if (hash === '#partir')
    {
        page = PartirPage;
        pageText = 'PartirPage';
    }
    else if (hash === '#partir2')
    {
        page = Partir2Page;
        pageText = 'Partir2Page';
    }
    else if (hash === '#partir3')
    {
        page = Partir3Page;
        pageText = 'Partir3Page';
    }
    else if (hash === "#partir4"){
        page = Partir4Page;
        pageText = 'Partir4Page';
    }
    else if (hash === '#create2')
    {
        page = Create2Page;
        pageText = 'Create2Page';
    }
    else if (hash === '#create3')
    {
        page = Create3Page;
        pageText = 'Create3Page';
    }
    else if (hash === '#myCars') {
        page = MyCarsPage;
        pageText = 'MyCarsPage';
    }
    else if (hash === "#create3firm") {
        page = Create3FirmPage;
        pageText = 'Create3FirmPage';
    }
    else if (hash === "#myProfile") {
        page = MyProfilePage;
        pageText = 'MyProfilePage';
    }
    else if (hash === '#map') {
        page = MapPage;
        pageText = 'MapPage';
    }
    else if (hash === '#map2') {
        page = Map2Page;
        pageText = 'Map2Page';
    }
    else if (hash === '#map3') {
        page = Map3Page;
        pageText = 'Map3Page';
    }
    else if (hash === '#journey') {
        page = JourneyPage;
        pageText = 'JourneyPage';
    }
    else if (hash === '#passwd') {
        page = PasswdPage;
        pageText = 'PasswdPage';
    }
    else if (hash === '#chat') {
        page = MessagePage;
        pageText = 'MessagePage';
    }
    else if (hash === "#myTravels") {
        page = MyTravels;
        pageText = 'MyTravels';
    }
    else if (hash === '#feedback') {
        page = Feedback;
        pageText = 'Feedback';
    }
    else if (hash === '#eWallet') {
        page = EWalletPage;
        pageText = 'EWalletPage';
    }
    else if (hash === '#accounts') {
        page = AccountsPage;
        pageText = 'AccountsPage';
    }
    else if (hash === '#account') {
        page = AccountPage;
        pageText = 'AccountPage';
    }
    else if (hash === '#grade') {
        page = GradePage;
        pageText = 'GradePage';
    }
    else if (hash === '#profile') {
        page = ProfilePage;
        pageText = 'ProfilePage';
    }
    else if (hash === '#history') {
        page = HistoryPage;
        pageText = 'HistoryPage';
    }
    else if (hash === '#contacts') {
        page = ContactsPage;
        pageText = 'ContactsPage';
    }
    if (Menu.isMenuAble())
        Menu.el.show();
    else
        Menu.el.hide();
    page.render();
    load.handleStatusBar();
    Menu.handleJSRendering(page);
    if (deviceType !== 'iOS')
        gaPlugin.trackPage(nativePluginResultHandler, nativePluginErrorHandler, pageText);
    else
        window.ga.trackView(pageText);
}

function nativePluginResultHandler(result) {
}

function nativePluginErrorHandler(error) {
}

// result contains any message sent from the plugin call //Android
function successHandler(result) {
}

// result contains any error description text returned from the plugin call
function errorHandler(error) {
    navigator.notification.confirm(
        "Vous ne pouvez pas recevoir de notification\n\nL'application ne peut donc pas se rafraichir automatiquement",
        function(index){
            if (index === 2) {
                registerPush();
                sendRegIDToServer();
            }
        },
        'Erreur innattendue',
        'Abandonner,Rééssayer'
    );
}

//success iOS
function tokenHandler(result) {
    // Stock the iOS push token for later send it to the server
    clearTimeout(iOSNotifsFailingTimeout);
    localStorage.regID = result;
}

function onLocalNotification(id, json) {
    var data = JSON.parse(json);
    if (parseInt(id) === 0) {
        if (!!data.journeyId)
            goSomewhere(data.journeyId, data.matchId, false, true);
        else
            goToMessageContact(data.contactId);
    } else
        goSomewhere(data.journeyId, data.matchId, data.agreementId);
}

function onLocalNotificaitonTrigger(id, json) {
    if (appIsOnForeground) {
        if (parseInt(id) === 0)
            alert("L'envoi du message a échoué\n\nVérifiez votre connexion internet");
        else
            alert('Vous avez rendez-vous dans ' + json.delay + ' mins');
    }
};

function goSomewhere(journeyId, matchId, agreementId, message) {
    var data = {
        journeyId: journeyId,
        matchId: matchId,
        agreementId: agreementId,
        message: message
    };
    showLoading();
    MyTravels.getTravels(data);
}

function goToMessageContact(contactId) {
    ContactsPage.goingStraight = {contactId: contactId};
    goToPage('#contacts');
}

function goToAccounts(compteId) {
    AccountsPage.goingStraight = {compteId: compteId};
    goToPage('#accounts');
}

// iOS
function onNotificationAPN(e) {
    if (parseInt(e.foreground) === 1) {
        navigator.vibrate(500);
        Notification.appleOnForeground = true;
        Notification.fetchNotifications();
    } else {
        var json = JSON.parse(e.jsonMessage);
        Notification.appleJustClicked = json;
    }
}

// Android and Amazon Fire OS
function onNotification(e) {
    switch (e.event)
    {
        case 'registered':
            if (e.regid.length > 0)
            {
                // Stock the regId obtained from the OS company
                localStorage.regID = e.regid;
            }
            break;

        case 'message':
            // if this flag is set, this notification happened while we were in the foreground.
            // you might want to play a sound to get the user's attention, throw up a dialog, etc.
            if (e.foreground)
            {
                navigator.vibrate(500);
                var content = e.payload.jsonMessage;
                if (Notification.checkIfDestEqualsThis(content, e.payload.message)) {
                    Notification.sendNotificationHandled(content.notificationId);
                    Notification.findIdenticalNotifications(content);
                    return;
                }
                Notification.handledAleready.push(content.notificationId);
                Notification.storeHandledNotifications();
                Notification.addNotification(e.payload.message, e.payload.title, content);
            }
            else
            {  // otherwise we were launched because the user touched a notification in the notification tray.
                if (e.coldstart) ;//the app was closed
                else ;//the app was running in background
                Notification.justClicked = e.payload.jsonMessage;
                Notification.notifAction(e.payload.jsonMessage);
            }
            break;

        case 'error':
            break;

        default:
            break;
    }
}

function registerPush() {
    if (deviceType === 'android') {
        pushNotification.register(
                successHandler,
                errorHandler,
                {
                    "senderID": "849793313840",
                    "ecb": "onNotification"
                }
        );
    } else {
        if (!localStorage.notifsTuto) {
            handleNotifTuto();
            return;
        }
        try {
            pushNotification.register(
                    tokenHandler,
                    errorHandler,
                    {
                        "badge": "true",
                        "sound": "true",
                        "alert": "true",
                        "ecb": "onNotificationAPN"
                    }
            );
            iOSNotifsFailingTimeout = setTimeout(function(){
                iOSNotifsFailingToRegister();
            },100);
        } catch (e) {
            iOSNotifsFailingToRegister();
        }
        
    }
}

function handleNotifTuto() {
    $('.popUpNotifTuto').show();
    $('.overlayNotifTuto').show();
    var hauteur = $('.popUpNotifTuto').outerHeight();
    $('.popUpNotifTuto').css('margin-top',-hauteur/2);
}

function sendRegIDToServer() {
    setTimeout(function() {
        var data = new Object();
        if (!localStorage.regID) {
            if (deviceType === 'android')
                navigator.notification.confirm(
                    "Vous ne pouvez pas recevoir de notification\n\nVous ne pourrez pas être averti lorsqu'un covoiturage est disponible sur un de vos trajets",
                    function(index){
                        if (index === 2) {
                            registerPush();
                            sendRegIDToServer();
                        }
                    },
                    'Problèmes de synchronisation',
                    'Abandonner,Rééssayer'
                );
            else
                navigator.notification.confirm(
                    "Vous avez interdit les notifications pour Kankaroo\n\nVous ne pourrez pas être averti lorsqu'un covoiturage est disponible sur un de vos trajets",
                    function(index){
                        if (index === 2) {
                            registerPush();
                            sendRegIDToServer();
                        }
                    },
                    'Notification bloquées',
                    'Je comprends,Rééssayer'
                );
        } else {
            data.pushToken = localStorage.regID;
            data.deviceId = device.uuid;
            if (deviceType === 'android')
                data.company = "google";
            else
                data.company = "apple";
            serverRequest(
                "/registerPushToken",
                "GET",
                null,
                "send Reg Id",
                sendRegIDToServer,
                data
            );
        }
    }, 4000);
}

function iOSNotifsFailingToRegister() {
    logErrorToServer("NotificationRegistrationAttempt", "NotificationRegistrationFailedIOS");
}

function isTextInput(node) {
    return ['INPUT', 'TEXTAREA'].indexOf(node.nodeName) !== -1;
}
