/* global google, load, Map2Page, MapPage */

var Geocoding = new Object();

Geocoding.geocoder;
Geocoding.pendingRequests = 0;
Geocoding.initializeSource;
Geocoding.label;
Geocoding.intializeLocked = false;

Geocoding.initialize = function() { //Can be called by parallel threads
    Geocoding.geocoder = new google.maps.Geocoder();
    var latlng = new google.maps.LatLng(48.851303, 2.332865);
    Geocoding.geocoder.geocode(
        {'latLng': latlng},
        function() {
            Geocoding.initialized();
        }
    );
    setTimeout(function() {
        if (Geocoding.intializeLocked === false) {
            navigator.notification.alert(
                "Services Google inaccessibles",
                function(){
                    load.googleScriptInitializedLocked = false;
                    load.initGoogleScript();
                },
                'Erreur de connexion',
                'Réessayer'
            );
        }
    },3000);
};

Geocoding.initialized = function() {
    if (Geocoding.intializeLocked === false) {
        Geocoding.intializeLocked = true;
        load.googleScriptInitializedLocked = true;
        if (Geocoding.initializeSource === "load") {
            if (load.asyncLocked.app === false) {
                load.loadUnlocked();
            } else {
                load.asyncLocked.google = false;
            }
        } else if (Geocoding.initializeSource === "map2") {
            //Reset map elts
            for (var i = 0; i < MapPage.markers.length; i++) {
                MapPage.markers[i].setMap(null);
            }
            MapPage.markers = [];
            MapPage.addDepMarkers();
            MapPage.addArrMarkers();
            var match = MapPage.matchList[MapPage.matchNum];
            if (!!match.polyline)
                MapPage.route = google.maps.geometry.encoding.decodePath(JSON.parse(match.polyline).points);
            else
                delete MapPage.route;
            Map2Page.initializeMap(Geocoding.label);
        }
    }
};

Geocoding.reverseGeocodingMap = function (place,callback){
    var latlng = new google.maps.LatLng(place.lat, place.lng);
    Geocoding.geocoder.geocode(
        {'latLng': latlng},
        function(results, status) {
            if (status === google.maps.GeocoderStatus.OK) {
                if (results[0]) {
                    callback(results, place);
                }
            } else {
                callback([{formatted_address : "Déplacez la carte pour raffraichir l'adresse"}], place);
            }
        }
    );
};


Geocoding.reverseGeocoding = function (place,callback, alreadyTryed){
    if (alreadyTryed === true) ;
    else Geocoding.pendingRequests++;
    
    var waitingTime;
    if (Geocoding.pendingRequests < 4) waitingTime = 0;
    else if (Geocoding.pendingRequests < 7) waitingTime = (1000* (Geocoding.pendingRequests-3));
    else waitingTime = (3000 + 1500* (Geocoding.pendingRequests-6));
    var latlng = new google.maps.LatLng(place.lat, place.lng);
    setTimeout( function() {
        Geocoding.geocoder.geocode(
            {'latLng': latlng},
            function(results, status) {
                if (status === google.maps.GeocoderStatus.OK) {
                    Geocoding.pendingRequests--;
                    if (results[0]) {
                        callback(results, place);
                    }
                } else if (status === google.maps.GeocoderStatus.OVER_QUERY_LIMIT){
                    setTimeout(
                        function(){
                            Geocoding.reverseGeocoding(place,callback, true);
                        },
                        2000);
                } else {
                    Geocoding.pendingRequests--;
                    endLoading();
                }
            }
        );
    },waitingTime);
};

Geocoding.straightGeocoding = function(address, callback, alreadyTryed) {
    if (alreadyTryed === true) ;
    else Geocoding.pendingRequests++;
    
    var waitingTime;
    if (Geocoding.pendingRequests < 4) waitingTime = 0;
    else if (Geocoding.pendingRequests < 7) waitingTime = (1000* (Geocoding.pendingRequests-3));
    else waitingTime = (3000 + 1500* (Geocoding.pendingRequests-6));
    setTimeout( function() {
        Geocoding.geocoder.geocode( { 'address': address}, function(results, status) {
            if (status === google.maps.GeocoderStatus.OK) {
                Geocoding.pendingRequests--;
                callback(results[0]);
            } else if (status === google.maps.GeocoderStatus.OVER_QUERY_LIMIT){
                setTimeout(
                    function(){
                        Geocoding.straightGeocoding(address,callback, true);
                    },
                    2000);
            } else {
                Geocoding.pendingRequests--;
                callback("fail");
            }
        });
    },waitingTime);
  };