/* global MessagePage, ProfilePage, PartirPage, ContactsPage, Notification, MyCarsPage, deviceType */

var Menu = new Object();

Menu.el = $('#menu');
Menu.open = true;
Menu.width;
Menu.wrapper = Menu.el.find('#menu-wrapper');

Menu.initialize = function() {
    this.eventHandler();
    Menu.width = Menu.el.outerWidth();
    Menu.el.css('left',-Menu.width);
};

Menu.eventHandler = function () {

    $('#overlayLoad').on('click', function(){
       window.plugins.toast.showShortBottom("En attente du serveur...\nLa connexion est peut-être lente"); 
    });

    $('#loadScreen').on('click', function(){
       window.plugins.toast.showShortBottom("En attente du serveur...\nLa connexion est peut-être lente"); 
    });
    
    $('.open-menu').on('click',function(){
        Menu.handleMenu();
    });

    this.el.find('.deco').on('click',function(){
        navigator.notification.confirm(
            "Me déconnecter ?", 
            function(index) {
                if (index === 2) {
                    showLoading();
                    deconnexion();
                    Menu.handleMenu(true);
                }
            },
            "Kankaroo",
             "Annuler,Déconnexion"
        );
    });

    this.el.find('.myCars').on('click',function(){
        Menu.handleMenu(true);
        MyCarsPage.fromPartirPage = false;
        goToPage('#myCars');
    });

    this.el.find('.myAccount').on('click',function(){
        Menu.handleMenu(true);
        goToPage('#myAccount');
    });

    this.el.find('.myProfile').on('click',function(){
        Menu.handleMenu(true);
        goToPage('#myProfile');
    });

    this.el.find('.menu-overlay').on('click',function(){
        Menu.handleMenu();
        event.stopPropagation();
    });

    this.el.find('.my_travels').on('click',function(){
        Menu.handleMenu(true);
        goToPage('#myTravels');
    });

    this.el.find('.feedback').on('click',function(){
        Menu.handleMenu(true);
        goToPage('#feedback');
    });
    
    this.el.find('.eWallet').on('click',function(){
        Menu.handleMenu(true);
        goToPage('#eWallet');
    });
    
    this.el.find('.accounts').on('click',function(){
        Menu.handleMenu(true);
        goToPage('#accounts');
    });
    
    this.el.find('.history').on('click',function(){
        Menu.handleMenu(true);
        goToPage('#history');
    });
    
    this.el.find('.contacts').on('click',function(){
        Menu.handleMenu(true);
        ContactsPage.goingStraight = {};
        goToPage('#contacts');
    });
};

Menu.handleMenu = function(close){
    if(Menu.open){
        Menu.open=false;
        if ($('#notif-overlay').is(":visible")) Notification.closePopUp();
        Menu.el.find('.ref').scrollTop(0);
        Menu.el.find('.menu-overlay').show();
        Menu.wrapper.animate({left:Menu.width,useTranslate3d: true},300);
    } else {
        Menu.open=true;
        Menu.el.find('.menu-overlay').hide();
        if (!close)
            Menu.wrapper.animate({left:0,useTranslate3d: true},300);
        else
            Menu.wrapper.css('left',0);
    }
};

events = {
    start: {},
    differences: {},
    isHorizontal: null,
    handleEvent: function (event) {
        switch (event.type) {
            case 'touchstart':
                this.touchstart(event);
                break;
            case 'touchmove':
                this.touchmove(event);
                break;
            case 'touchend':
                this.touchend(event);
                break;
        }
    },
    touchstart: function (event) {
        var elt = $(event.target);
        var touch = event.touches[0];
        events.start = {
            x: touch.pageX,
            y: touch.pageY
        };
    },
    touchmove: function (event) {
        var touch = event.touches[0];
        events.differences = {
            x: touch.pageX - events.start.x,
            y: touch.pageY - events.start.y
        };
        if (events.isHorizontal === null) {
            events.isHorizontal = (Math.abs(events.differences.x) > Math.abs(events.differences.y));
        }
        if (events.isHorizontal) {
            event.preventDefault();
            if (events.start.x < 21 && events.differences.x > 49) Menu.onSwipe('open');
            if (-events.differences.x > 49) Menu.onSwipe('close');
        }
    },
    touchend: function () {
        events.isHorizontal = null;
        events.differences = {};
        events.start = {};
    }
};

document.addEventListener('touchstart', events);
document.addEventListener('touchmove', events);
document.addEventListener('touchend', events);

Menu.onSwipe = function(action) {
    if (action === 'close') {
        if (Menu.open === false) {
            Menu.handleMenu();
        }
    }
    else {
        if (Menu.isMenuAble()) {
            if (Menu.open === true) {
                Menu.handleMenu();
            }
        }
    }
};

Menu.isDescendant = function(parent, child) {
     var node = child.parent();
     while (node.length !== 0) {
         if (node.get(0) === parent.get(0)) {
             return true;
         }
         node = node.parent();
     }
     return false;
};

Menu.isMenuAble = function() {
    var hash = window.location.hash;
    if (["#create", "#login", "#passwd", "#create3firm", "#create2", "#create3", "#partir2", "#partir3", "#chat", "#profile", "#partir4", "#map", "#partir", "#account"].indexOf(hash) >= 0) {
        return false;
    }
    if (MessagePage.el.is(":visible")) return false;
    if (ProfilePage.el.is(":visible")) return false;
    if ($('#overlayLoad').is(":visible")) return false;
    if ($('.overlay:visible').length !== 0){
            $('.overlay:visible').find(".popUp").hide();
            $('.overlay:visible').hide();
    }
    return true;
};

Menu.notificationsAreVisible = function() {
    var hash = window.location.hash;
    if (["#create", "#login", "#passwd", "#create2", "#create3", "#create3firm"].indexOf(hash) >= 0) {
        return false;
    }
    if (PartirPage.el.find('.noReturn .fake-menu').is(":visible")) return false;
    return true;
};

Menu.handleJSRendering = function(page) {
    Notification.handleNotification();
    var outerWidth;
    if (page === PartirPage)
        outerWidth = Math.max(page.el.find('.first .back-menu').outerWidth(), page.el.find('.next .back-menu').outerWidth());
    else
        outerWidth = page.el.find('.back-menu').outerWidth();
    outerWidth = Math.max(outerWidth, page.el.find('.open-menu').outerWidth());
    outerWidth = Math.max(outerWidth, page.el.find('.fake-menu').outerWidth());
    page.el.find('.headerTitle').css('max-width', $( window ).width()-outerWidth-$('#notif').outerWidth()-10);
    page.el.find('.headerTitle').css('margin-left',outerWidth);
    Menu.scroller(page);
};

Menu.scroller = function(page, bot) {
    if (!!bot) {
        setTimeout(function() {
            if (deviceType !== 'iOS')
                $('body').scrollTop($('body').prop('scrollHeight'));
            else
                page.el.find('.pageContent').scrollTop(page.el.find('.pageContent').prop('scrollHeight'));
        },0);
    } else {
        if (deviceType !== 'iOS')
            $('body').scrollTop(0);
        else
            page.el.find('.pageContent').scrollTop(0);
    }
};